
##################################################################
#
# Do not edit this file! File generated by inc2py.py utility.
#
# File generated Mon May 28 19:44:08 2012
#

inc2py_build_hash = 'd0298a4b3220bd15a173c020eae4fef4b366a53c'
inc2py_build_localtime = 1338259448


##################################################################
#
# Author:		Kurt W Dekker
# Started:		11:14 AM 10/25/2011
# Description:	Python Daleks (formerly TBB, Turn Based Botz)
#
# NOTE! This has been tested with Python 2.5 and PyGame 1.9.1.
#

##################################################################
# optional
screen_size = (640,480)

##################################################################

##################################################################
# This is part of Kurt Dekker's common python library codebase.
#

# overwrite with a later one if you have stuff to silence
def sounds_silence_all():
	return

##################################################################
import pygame
from pygame.constants import *

import random

import glob

import sys,os

from math import sin, cos, sqrt, atan2, pi, pow

import time

# As of Python 2.5, the hypot() function is slower than
# just using sqrt(), so don't use hypot()
# from math import hypot

##################################################################
try:
	a = screen_size[0]
except NameError:
	screen_size = (640,480)

##################################################################
scrnflags = 0

##################################################################
try:
	a = fullscreen
	if fullscreen:
		scrnflags |= pygame.FULLSCREEN
	del fullscreen
except NameError:
	pass

try:
	a = resizable
	if resizable:
		scrnflags |= pygame.RESIZABLE
	del resizable
except NameError:
	pass

try:
	a = noframe
	if noframe:
		scrnflags |= pygame.NOFRAME
	del noframe
except NameError:
	pass

##################################################################
hold_negative_sizes = None
if (screen_size[0] < 0) or (screen_size[1] < 0):
	hold_negative_sizes = (screen_size[0], screen_size[1])
	screen_size = (0,0)

##################################################################
pygame.init()

screen = pygame.display.set_mode(screen_size, scrnflags)

if scrnflags & pygame.FULLSCREEN:
	pygame.mouse.set_visible(False)
else:
	pygame.mouse.set_visible(True)

clock = pygame.time.Clock()

##################################################################
if hold_negative_sizes:
	screen_size = (screen.get_width() + hold_negative_sizes[0], screen.get_height() + hold_negative_sizes[1])
	screen = pygame.display.set_mode(screen_size, scrnflags)

##################################################################
def lowercase(x):
	return x.lower()

##################################################################
# Most library calls will use this surface for drawing
pygame_library_screen = screen
pygame_library_screen_original = screen
pygame_library_screen_stack = []

# Use this to redirect if you want it to go to other surfaces
# Use None if you want the original screen surface, or -1 to pop.
def	pygame_set_library_screen(s = None):
	global pygame_library_screen
	global pygame_library_screen_stack
	if not s:			# restore
		pygame_library_screen = pygame_library_screen_original
	elif s == -1:		# pop (or restore)
		if len( pygame_library_screen_stack):
			pygame_library_screen = pygame_library_screen_stack[-1]
			pygame_library_screen_stack = pygame_library_screen_stack[:-1]
		else:
			pygame_library_screen = pygame_library_screen_original
	else:				# push
		pygame_library_screen_stack.append( pygame_library_screen)
		pygame_library_screen = s
	return

##################################################################
def	Random(N):
	return random.randrange(N)

##################################################################
def	RandomList( L):
	return L[ Random( len( L))]

##################################################################
def	RandomRect( R):
	return (R[0] + Random( R[2]), R[1] + Random( R[3]))

##################################################################
bycheating_strings = ("", " (by cheating)",)
def	bycheating(arg):
	if arg:
		return bycheating_strings[1]
	return bycheating_strings[0]

##################################################################
enadis_strings = ("Disabled", "Enabled",)
def	enadis(arg):
	if arg:
		return enadis_strings[1]
	return enadis_strings[0]

##################################################################

##################################################################
# This is part of Kurt Dekker's common python library codebase.
#
# These are some basic data-loading functions I've found in various
# places on the net and incorporated here.

##################################################################
loaddata_data_directory = "./data/"

##################################################################
def	loaddata_set_data_directory(newdir):
	global loaddata_data_directory
	loaddata_data_directory = newdir
	return

##################################################################
def	datapath_art(file):
	# bypass prefixes with explicit paths
	if file.find(":") >= 0: return file
	if (file[0] == '.') or (file[0] == '/') or (file[0] == '\\'): return file
	return loaddata_data_directory + "art/" + file
def	datapath_sound(file):
	# bypass prefixes with explicit paths
	if file.find(":") >= 0: return file
	if (file[0] == '.') or (file[0] == '/') or (file[0] == '\\'): return file
	return loaddata_data_directory + "sound/" + file

##################################################################
#taken from livewires
def load_image(file, transparent=None):
	"""
	file -- the filename of the image to load
	transparent -- whether the background of the image should be transparent.
				   Defaults to true.
				   The background colour is taken as the colour of the pixel
				   at (0,0) in the image.
	"""
	if transparent == None:
		transparent = 1
	surface = pygame.image.load(datapath_art(file))
	if transparent:
		corner = surface.get_at((0, 0))
		surface.set_colorkey(corner, RLEACCEL)
	return surface		#.convert

def load_sound(file):
	"""
	Load a sound file, returning a Sound object.
	"""
	return pygame.mixer.Sound(datapath_sound(file))

##################################################################
# Loads an image, then copies it by flipping into 4 "wrappable" quadrants
# so that there are no seams and it is tile-able (crudely).
def	load_image_wrapped4( file, transparent=None):
	image = load_image( file, transparent)
	image4x4 = pygame.Surface( (image.get_width() * 2, image.get_height() * 2))
	image4x4 = image4x4.convert( image)
	image4x4.blit( image, (0,0))
	image4x4.blit( pygame.transform.flip( image, 1, 0), (image.get_width(),0))
	image4x4.blit(pygame.transform.flip( image, 0, 1), (0,image.get_height()))
	image4x4.blit( pygame.transform.flip( image, 1, 1), (image.get_width(),image.get_height()))
	return image4x4

##################################################################
def	make_image_rotable( baseimage, maxrots):
	imagearray = []
	for i in range( maxrots):
		angle = -(i * 360) / maxrots
		imagearray.append( pygame.transform.rotate( baseimage, angle))
	return imagearray

##################################################################
# Loads and pre-rotates an image
def	load_image_rotable( file, maxrots):
	return make_image_rotable( load_image( file), maxrots)

##################################################################
def	load_image_xflipped_pair( file, transparent=None):
	i1 = load_image( file, transparent)
	i2 = pygame.transform.flip( i1, 1, 0)
	return (i1, i2)

##################################################################
def	image_doublesizer( img):
	xsz = img.get_width()
	ysz = img.get_height()
	return pygame.transform.scale( img, (xsz * 2, ysz * 2))

##################################################################
def	load_text_file( txtfile_or_handle):
	lines = None
	try:
		lines = txtfile_or_handle.readlines()
	except AttributeError:
		try:
			f = open( txtfile_or_handle, "rt");
			lines = f.readlines()
			f.close()
		except:
			lines = [
				"File not found error.",
				"",
				"Unable to load file '%s'" % txtfile_or_handle,
				"",
				"Current directory is '%s'" % os.getcwd(),
			]
	for i in xrange( len( lines)):
		if len( lines[i]) > 0:
			if lines[i][-1] == '\n':
				lines[i] = lines[i][:-1]		# chomp
	return lines


##################################################################
# This is part of Kurt Dekker's common python library codebase.
#
# This wraps the font/printing stuff in a way that is useful to me.
#

##################################################################
JUSTIFY_LEFT   = 0x0000
JUSTIFY_CENTER = 0x0001
JUSTIFY_RIGHT  = 0x0002

##################################################################

##################################################################
def	initialize_default_font_palette(s):
	assert( s.get_bitsize() == 8)
	s.set_colorkey(0)
	# It appears that PyGame 1.9.1 or beyond is needed for 4-color arguments!
	s.set_palette_at( 0, (0,0,0,0))
	s.set_palette_at( 1, (255,255,255,255))
	s.set_palette_at( 2, (0,0,0,255))
	return

##################################################################
class	BITMAP_FONT:
	def	load_from_bitmap(	self,
							bitmap_font,
							charcellsize,
							cellcounts=None,
							upperleft=None,
							firstcharval=None,
							displaysize=None):
		# figure out our defaults
		if cellcounts == None:
			cellcounts = (0,0)
		if upperleft == None:
			upperleft = (0,0)
		if firstcharval == None:
			firstcharval = 0
		# no display size means "use the charcellsize"
		if displaysize == None:
			displaysize = [ charcellsize[0], charcellsize[1] ]
		# negative display size indicates "shrink in a bit"
		elif (displaysize[0] < 0) or (displaysize[1] < 0):
			displaysize = [ charcellsize[0] + displaysize[0],
							charcellsize[1] + displaysize[1]]

		self.charcellsize = [ charcellsize[0], charcellsize[1] ]
		self.cellcounts   = [ cellcounts[0],   cellcounts[1]   ]
		self.upperleft    = [ upperleft[0],    upperleft[1]    ]
		self.firstcharval = firstcharval
		self.thesheet = bitmap_font.copy()
		if self.cellcounts[0] == 0:
			self.cellcounts[0] = self.thesheet.get_width() / self.charcellsize[0]
		if self.cellcounts[1] == 0:
			self.cellcounts[1] = self.thesheet.get_height() / self.charcellsize[1]
		self.maxchars = (self.thesheet.get_width()  / self.charcellsize[0]) * \
						(self.thesheet.get_height() / self.charcellsize[1])
		self.displaysize = displaysize
		return self

	def	load_from_ttf(self,charsize,ttf_font=None,make8bit=None):
		if make8bit == None:
			make8bit = 1
		if ttf_font == None:
			ttf_font = "Times New Roman"
		font = pygame.font.SysFont( ttf_font, charsize)
		firstchar = 0
		lastchar = 128
		maxwidth = 0
		maxheight = 0
		bitmap_font = 0
		across = 16		# chars across
		for passno in xrange(2):
			for i in xrange(firstchar,lastchar):
				str = "%c" % chr(i)
				if i >= 32:
					s = font.render( str,False,(255,255,255))
					w = s.get_width()
					h = s.get_height()
					if passno == 0:
						if w > maxwidth:
							maxwidth = w
						if h > maxheight:
							maxheight = h
					if passno == 1:
						if 0:		# DEBUG: make red/green cells around it for alignment
							x = (i % across)
							y = (i / across)
							c = (30,80,30)
							if (x + y) & 1:
								c = (80,30,30)
							x *= maxwidth
							y *= maxheight
							bitmap_font.fill( c, (x,y,x+maxwidth,y+maxheight))
						x = (i % across) * maxwidth + maxwidth / 2 - w / 2
						y = int(i / across) * maxheight
						if make8bit:
							# This is painfully slow, pixel manipulation
							for jj in xrange(h):
								for ii in xrange(w):
									c = 0
									if s.get_at( (ii,jj))[2] > 128:
										c = 1
									bitmap_font.set_at( (x+ii,y+jj), c)
						else:
							bitmap_font.blit( s, (x,y))
			if passno == 0:
				if make8bit:
					bitmap_font = pygame.Surface( (maxwidth * across, maxheight * (lastchar - firstchar) / across), 0, 8)
					bitmap_font.fill(0)
					initialize_default_font_palette(bitmap_font)
				else:
					bitmap_font = pygame.Surface( (maxwidth * across, maxheight * (lastchar - firstchar) / across), SRCALPHA)
					bitmap_font.fill( (255,0,255,0))
		self.load_from_bitmap(bitmap_font, (maxwidth, maxheight))
		return self

	# 04/05/2011 - this uses the _CS*.H and _KP*.H string files converted by
	# the CBFONTS project into _CS*.TXT and _KP*.TXT files.
	def	load_from_charset(self,charset_strings):
		# extract from the charset_strings all of the values defining the charset
		charcellxsz = int( charset_strings[ 1])
		charcellysz = int( charset_strings[ 2])
		self.charcellsize = (charcellxsz, charcellysz)
		firstchar = int( charset_strings[ 3])
		numchars = int( charset_strings[4])
		cells_across = 16
		cells_down = int((firstchar + numchars + (cells_across - 1)) / cells_across)
		sheet_xsz = cells_across * charcellxsz
		sheet_ysz = cells_down * charcellysz
		bitmap_font = pygame.Surface( ( sheet_xsz, sheet_ysz), 0, 8)	# paletized 8-bit image
		bitmap_font.fill(0)
		initialize_default_font_palette(bitmap_font)
		i = firstchar
		for oneline in charset_strings[10:]:
			X = (i % cells_across) * charcellxsz
			Y = int(i / cells_across) * charcellysz
			for j in xrange( len( oneline)):
				x = X + (j % charcellxsz)
				y = Y + (j / charcellxsz)
				if oneline[j] == '*':
					bitmap_font.set_at( (x, y), 1)
				else:
					bitmap_font.set_at( (x, y), 0)
			i += 1
		# call good old load_from_bitmap() and off we go!
		self.load_from_bitmap( bitmap_font, (charcellxsz, charcellysz))
		return self

	# the naive inter-color 8-bit blit (blitting remapped color1 to
	# color2) does not work to give us what we want, therefore
	# we must do it the tedious way! We do a 24-color blit (which
	# works fine) and then back-paletize the resultant sheet.
	def	synthesize_outline(self,olc=None):
		if olc == None:
			olc = 2
		newcellxsz = self.charcellsize[0] + 2
		newcellysz = self.charcellsize[1] + 2
		# presumes this is only a one-color font at this point, soon to be a 2-color font!
		self.thesheet.set_palette_at( 1, (255,255,255,255))
		# we stamp it all to this temporary sheet before repaletizing
		tempsheet = pygame.Surface( (newcellxsz * self.cellcounts[0], newcellysz * self.cellcounts[1]), SRCALPHA)
		tempsheet.fill( (128,0,0))		# special value meaning transparent
		colorants = ((0,0,0,255), (255,255,255,255), )
		# do the 24-color blit
		for i in xrange(self.maxchars):
			x =  i % self.cellcounts[0]
			y =  i / self.cellcounts[0]
			nx = newcellxsz * x
			ny = newcellysz * y
			x *=  self.charcellsize[0]
			y *=  self.charcellsize[1]
			r = pygame.Rect( x, y, self.charcellsize[0], self.charcellsize[1])
			for (xxx,yyy,ccc) in ((0,0,0), (1,0,0), (2,0,0), (0,1,0), (2,1,0), (0,2,0), (1,2,0), (2,2,0), (1,1,1), ):
				self.thesheet.set_palette_at( 1, colorants[ccc])
				tempsheet.blit( self.thesheet, (nx + xxx, ny + yyy), r)
			del xxx,yyy,ccc
		# self.displaysize does not change!!
		self.charcellsize = [newcellxsz, newcellysz]
		del newcellxsz, newcellysz
		# synthesize our new 8-bit sheet
		newsurface = pygame.Surface( (tempsheet.get_width(), tempsheet.get_height()), 0, 8)
		newsurface.fill(0)
		initialize_default_font_palette(newsurface)
		# repaletize
		for j in xrange(tempsheet.get_height()):
			for i in xrange(tempsheet.get_width()):
				c = tempsheet.get_at( (i,j))
				if c[0] == 128:
					continue		# transparent - no blit!
				elif c[0] == 255:
					c = 1
				else:
					c = 2				# must be the outline color
				newsurface.set_at( (i,j), c)
		self.thesheet = newsurface
		return self

	def	get_surface(self):
		return self.thesheet

	def	scale(self,dimensions=None):
		if dimensions == None:
			dimensions = (2,2)
		xsz = self.thesheet.get_width() * dimensions[0]
		ysz = self.thesheet.get_height() * dimensions[1]
		newsurface = pygame.transform.scale( self.thesheet, (xsz, ysz))
		initialize_default_font_palette(newsurface)
		# update sizes cheaply; this is why you must do displaysize "kerning" last
		# update sizes cheaply; this is why you must do displaysize "kerning" last
		self.charcellsize[0] *= dimensions[0]
		self.charcellsize[1] *= dimensions[1]
		self.displaysize[0] *= dimensions[0]
		self.displaysize[1] *= dimensions[1]
		self.thesheet = newsurface
		return self

##################################################################
class	_vgaprn:
	def	setsize(self,newsize):
		if self.currsize != newsize:
			self.currsize = newsize
		self.print_font = pygame.font.SysFont( "Times New Roman", self.currsize)
		self.bitmap_font = 0
		return

	def set_bitmap_font(self,bitmap_font):
		self.bitmap_font = bitmap_font
		if bitmap_font:
			self.print_font = 0
		return

	def __init__(self):
		self.currsize = 10
		self.setsize(30)
		self.color0 = (  0,  0,  0)
		self.color1 = (255,255,255)
		self.color2 = (255,255,  0)		# highlight color
		self.zerowrite = 0
		self.justify = 0
		self.set_bitmap_font(0)
		return

	def getwidth(self,str):
		if self.bitmap_font:
			return self.bitmap_font.displaysize[0] * len( str)
		self.lastrender = self.print_font.render( str,False,self.color1)
		return self.lastrender.get_width()

	def getheight(self,str):
		if self.bitmap_font:
			return self.bitmap_font.displaysize[1]
		self.lastrender = self.print_font.render( str,False,self.color1)
		return self.lastrender.get_height()

	def	printf(self,pos,str):
		if pos == None:
			pos = (self.lastrect[0] + self.lastrect[2], self.lastrect[1])
		x = pos[0]
		y = pos[1]
		# handle newline-separated chunks of text here
		n = str.find( '\n')
		if n >= 0:
			lines = str.split( '\n')
			for oneline in lines:
				self.printf( (x, y), oneline)
				y += self.currsize
			return
		self.lastrender = None
		if self.bitmap_font:
			bmpfont = self.bitmap_font
			thesurface = bmpfont.thesheet
			if self.justify & JUSTIFY_CENTER:
				x -= len(str) * bmpfont.displaysize[0] / 2
			elif self.justify & JUSTIFY_RIGHT:
				x -= len(str) * bmpfont.displaysize[0]
			self.lastrect = pygame.Rect(x,y,len(str) * bmpfont.displaysize[0],bmpfont.displaysize[1])
			if thesurface.get_bitsize() == 8:
				thesurface.set_palette_at( 1, VGAPRN.color1)
			if self.zerowrite:
				pygame.draw.rect( pygame_library_screen, self.color0, self.lastrect)
			for c in str:
				c = ord(c) - bmpfont.firstcharval
				if c >= 0:
					if c < bmpfont.maxchars:
						srcrect = ( bmpfont.upperleft[0] + ( c % bmpfont.cellcounts[0]) * bmpfont.charcellsize[0],
									bmpfont.upperleft[1] + ( c / bmpfont.cellcounts[0]) * bmpfont.charcellsize[1],
									 bmpfont.charcellsize[0], bmpfont.charcellsize[1])
						pygame_library_screen.blit( thesurface, (x,y), srcrect)
						x += bmpfont.displaysize[0]
			return
		if self.print_font:
			s = self.print_font.render( str,False,self.color1)
			if self.justify & JUSTIFY_CENTER:
				x -= s.get_width() / 2
			elif self.justify & JUSTIFY_RIGHT:
				x -= s.get_width()
			self.lastrect = pygame.Rect(x,y,s.get_width(),s.get_height())
			if self.zerowrite:
				pygame.draw.rect( pygame_library_screen, self.color0, self.lastrect)
			pygame_library_screen.blit( s, (x, y))
			self.lastrender = s
			return
		return


VGAPRN = _vgaprn()


##################################################################
# See TEST project (TESTE) for tests of this module.

##################################################################
joystick_initialized = 0
joystick1 = 0

jx1 = -1
jy1 = -1
jx2 = -1
jy2 = -1
jx3 = -1
jy3 = -1

prevjbuttons = 0
jbuttons = 0

##################################################################
# adjust to suit how twitchy you want things to be
joystick_dead_zone = 50

##################################################################
def	joystick_map_axes_default():
	global jx1, jy1, jx2, jy2, jx3, jy3
	jx1 = -1
	jy1 = -1
	jx2 = -1
	jy2 = -1
	jx3 = -1
	jy3 = -1
	for i in range( joystick1.get_numaxes()):
		xxx = joystick1.get_axis(i)
		xxx = 100 + int( 100 * xxx)
		if i == 0: jx1 = xxx
		if i == 1: jy1 = xxx
		if i == 2: jx2 = xxx
		if i == 3: jy2 = xxx
		if i == 4: jx3 = xxx		# often not present
		if i == 5: jy3 = xxx		# often not present
	return

##################################################################
# The XBox 360 controller has an unusual mapping, plus Microsoft has
# (apparently intentionally) crippled the analog triggers... buttheads!
def	joystick_map_axes_xbox360():
	global joystick1, jx1, jy1, jx2, jy2, jx3, jy3
	jx1 = -1
	jy1 = -1
	jx2 = -1
	jy2 = -1
	jx3 = -1
	jy3 = -1
	for i in range( joystick1.get_numaxes()):
		xxx = joystick1.get_axis(i)
		xxx = 100 + int( 100 * xxx)
		if i == 0: jx1 = xxx
		if i == 1: jy1 = xxx
		if i == 2: jx3 = xxx		# triggers
		if i == 3: jy2 = xxx
		if i == 4: jx2 = xxx
		# nothing mapped to jy3
	return

##################################################################
def	joystick_map_btns_default():
	global joystick1, jbuttons, prevjbuttons
	prevjbuttons = jbuttons
	jbuttons = 0
	for i in range( joystick1.get_numbuttons()):
		if joystick1.get_button(i):
			jbuttons |= (1 << i)
	return

##################################################################
def	joystick_configure_default():
	global joystick_map_axes_function, joystick_map_btns_function
	print "joystick_configure_default()"
	joystick_map_axes_function = joystick_map_axes_default
	joystick_map_btns_function = joystick_map_btns_default
	return

##################################################################
def	joystick_configure_xbox360():
	global joystick_map_axes_function, joystick_map_btns_function
	print "joystick_configure_xbox360()"
	joystick_map_axes_function = joystick_map_axes_xbox360
	joystick_map_btns_function = joystick_map_btns_default
	return

##################################################################
def joystick_think():
	global joystick1, joystick_initialized

	if not joystick_initialized:
		joystick_initialized = 1
		try:
			joystick1 = pygame.joystick.Joystick(0)
			if joystick1.get_name().lower().find( "xbox") >= 0:
				joystick_configure_xbox360()
		except pygame.error:
			joystick1 = 0
			return
		joystick1.init()

	if not joystick1:
		return

	joystick_map_axes_function()
	joystick_map_btns_function()

	return

##################################################################
def	joystick_greet_paint():
	if joystick1:
		VGAPRN.setsize(15)
		VGAPRN.color1 = (255,255,255)
		VGAPRN.justify = JUSTIFY_LEFT
		VGAPRN.printf( (4, scry - 18), "JOY: %u AXES" % joystick1.get_numaxes())
	return

##################################################################
joystick_configure_default()


##################################################################
# Individual entity objects
class	OBJ:
	def __init__(self):
		# status
		self.flag = 0
		self.dead = 0
		self.type = 0
		self.subtype = 0

		# timers, counters, etc
		self.timer = 0
		self.state = 0
		self.points = 0

		# fixed point 16.16 precision
		self.x = 0
		self.y = 0
		self.xm = 0
		self.ym = 0
		self.rot = 0
		self.rotm = 0
		self.speed = 0

		# integer (screen coords generally)
		self.ix = 0
		self.iy = 0
		self.irot = 0;
		self.r = pygame.Rect(0,0,0,0)

		# original locations
		self.orgx = 0
		self.orgy = 0

		# is there another entity I may be related to?
		self.cousin = -1

		# appearance
		self.frameno = 0
		self.animseq = 0

		# hitpoints
		self.hits = 0
		self.maxhits = 0	# generally, 0 will imply 1

		# miscellany
		self.gunheat = 0


##################################################################
		# miscellany that belongs in the OBJ structure


		return

	# converts the fixed point down to integer, and sets up the rect
	def	calcrect(self,w=None,h=None):
		if w == None:
			w = 0
		if h == None:
			h = 0
		self.ix = int(self.x) >> 16
		self.iy = int(self.y) >> 16
		self.r = pygame.Rect( self.ix - (w >> 1), self.iy - (h >> 1), w, h)
		self.irot = self.rot >> 16
		return

##################################################################
def	obj_filterfunc_flagnonzero(o):
	return o.flag

##################################################################
def	obj_filter_flagnonzero(thelist):
	return filter(obj_filterfunc_flagnonzero,thelist)


##################################################################
# This is part of Kurt Dekker's common python library codebase.
#
# This is a handy message-displaying suite of functions

##################################################################

##################################################################
def	threeby_expand_image(src,(w,h)):
	w3 = src.get_width()  / 3
	h3 = src.get_height() / 3
	s2 = pygame.Surface((w,h), pygame.SRCALPHA)
	# debug: turn it all purple so we can see what's going on
	#s2.fill((255,0,100))
	n_across = int( w / w3)
	n_down   = int( h / h3)
	#print "n_across = ", n_across, " and n_down = ", n_down
	for j in xrange(n_down):
		for i in xrange(n_across):
			dx = i * w3
			dy = j * h3
			if i == 0:
				sx = 0
			elif i == n_across - 1:
				sx = w3 * 2
			else:
				sx = w3
			if j == 0:
				sy = 0
			elif j == n_down - 1:
				sy = h3 * 2
			else:
				sy = h3
			s2.blit( src, (dx,dy), (sx,sy,w3,h3))
	return s2

class	messagestate:
	pass

MESSAGE = messagestate()

# global place to dump settings
MESSAGE.max_display_lines = 8
MESSAGE.threeby_image = None
MESSAGE.threeby_image_expanded = None

# how long to dwell waiting for the user to type strings
MESSAGE_KEYSTROKE_TIMER_TIME = 30
MESSAGE.keystroke_timer = 0
MESSAGE.keystroke_matcher = ""

##################################################################
class	MESSAGE_METRICS:
	def __init__(self):
		self.x = 0
		self.y = 0
		self.w = 0
		self.h = 0
		self.xpadding = 30
		self.ypadding = 30
	pass

##################################################################
def	message_metrics_apply_strings(strings,mm=None):
	if mm == None:
		mm = MESSAGE_METRICS()
	mm.maxlines = len( strings)
	mm.numlines = min( mm.maxlines, MESSAGE.max_display_lines)
	for s in strings:
		w2 = VGAPRN.getwidth(s)
		if w2 > mm.w:
			mm.w = w2
	mm.h0 = VGAPRN.getheight("")
	mm.h += mm.h0 * mm.numlines
	return mm

##################################################################
def	message_metrics_final_adjustment(mm):
	mm.w0 = mm.w
	# figure out our padding
	if MESSAGE.threeby_image:
		s1 = MESSAGE.threeby_image
		w = s1.get_width()
		h = s1.get_height()
		w3 = w / 3
		h3 = h / 3
		# The edge padding will need to be expanded far enough
		# to bring the interior fill area up to an even integer
		# number of tiles in both the X- and Y-directions.
		# how many times will this be repeated? (round up)
		n_across = int( (mm.w + w3 - 1) / w3)
		n_down   = int( (mm.h + h3 - 1) / h3)
		# add extra for borders
		n_across += 2
		n_down   += 2
		# fill it all the way out
		mm.xpadding = n_across * w3 - mm.w
		mm.ypadding = n_down   * h3 - mm.h
	# expand, either by default padding or by threeby-based calculated
	mm.w += mm.xpadding
	mm.h += mm.ypadding
	mm.xpadding /= 2
	mm.ypadding /= 2
	# expand the threeby panel
	if MESSAGE.threeby_image and not MESSAGE.threeby_image_expanded:
		MESSAGE.threeby_image_expanded = threeby_expand_image( MESSAGE.threeby_image, (mm.w,mm.h))
	# center it up
	mm.x = (scrx - mm.w) / 2
	mm.y = (scry - mm.h) / 2
	return mm

##################################################################
def	message_draw_frame(mm):
	if MESSAGE.threeby_image and MESSAGE.threeby_image_expanded:
		pygame_library_screen.blit(
				MESSAGE.threeby_image_expanded, (mm.x, mm.y))
	else:
		if VGAPRN.color0:
			pygame.draw.rect( pygame_library_screen,
					VGAPRN.color0,
					(mm.x, mm.y, mm.w, mm.h))
			pygame.draw.rect( pygame_library_screen,
					VGAPRN.color2,
					(mm.x, mm.y, mm.w, mm.h),
					2)
	return

##################################################################
def	message_paint_simple_centered(strings):
	mm = MESSAGE_METRICS()
	mm = message_metrics_apply_strings(strings,mm)
	mm = message_metrics_final_adjustment(mm)

	if INPUT.idle_callback:
		INPUT.idle_callback( mm)

	message_draw_frame( mm)

	x2 = mm.x + mm.xpadding
	y2 = mm.y + mm.ypadding
	x2pos = x2
	if VGAPRN.justify == JUSTIFY_CENTER:
		x2pos = x2 + mm.w0 / 2
	if VGAPRN.justify == JUSTIFY_RIGHT:
		x2pos = x2 + mm.w0
	VGAPRN.zerowrite = 0
	for s in strings:
		VGAPRN.printf( (x2pos, y2), s)
		y2 += mm.h0

	return mm

##################################################################
def	message_simple_ok(strings):
	strings = list( strings)
	done = 0
	while not done:
		message_paint_simple_centered(strings)
		waitclock()
		if len( INPUT.unicodeses):
			if len( INPUT.unicodeses[0]):
				done = 1
		for m in INPUT.micestuffs:
			if m.type == pygame.MOUSEBUTTONUP:
				done = 1
	waitclock()
	return INPUT_RESULT_ACCEPT

##################################################################
def	message_simple_yesno(strings):
	strings = list( strings)
	newstrings = strings[:]
	newstrings.append( "(Type Y or N)")
	done = 0
	while not done:
		message_paint_simple_centered(newstrings)
		waitclock()
		for u in INPUT.unicodeses:
			if u.lower() == 'y':
				done = 1
				yesno = INPUT_RESULT_YES
			elif u.lower() == 'n' or u == chr(27):
				done = 1
				yesno = INPUT_RESULT_NO
	waitclock()
	return yesno

##################################################################
def	message_simple_yesnocancel(strings):
	strings = list( strings)
	newstrings = strings[:]
	newstrings.append( "(Type Y or N or ESC)")
	done = 0
	while not done:
		message_paint_simple_centered(newstrings)
		waitclock()
		for u in INPUT.unicodeses:
			if u.lower() == 'y':
				done = 1
				yesnocancel = INPUT_RESULT_YES
			elif u.lower() == 'n':
				done = 1
				yesnocancel = INPUT_RESULT_NO
			elif u == chr(27):
				done = 1
				yesnocancel = INPUT_RESULT_CANCEL
	waitclock()
	return yesnocancel

##################################################################
def	message_draw_arrow(pos,dir4):
	if (dir4 == 0) or (dir4 == 2):
		x = pos[0]
		y = pos[1]
		for i in range(12):			# pixel-drawn arrow size
			j = i | 1
			for k in range(j):
				pygame_library_screen.set_at( (x + k, y), VGAPRN.color2)
			if i & 1:
				x -= 1
			if dir4 == 0:
				y += 1
			else:
				y -= 1
		return
	return

##################################################################
def	message_list_select(strings,caption,startcursor=None):
	emptylist = 0
	if len( strings) == 0:
		strings = ("<No selections available!>",)
		emptylist = 1

	strings = list( strings)
	count = len( strings)

	topline = 0

	cursor = 0
	if (startcursor > 0) and (startcursor < len(strings)):
		cursor = startcursor
		while cursor >= topline + MESSAGE.max_display_lines:
			topline += 1

	hbargap = 2
	mm = MESSAGE_METRICS()
	mm = message_metrics_apply_strings([caption],mm)
	mm = message_metrics_apply_strings(strings,mm)
	mm = message_metrics_final_adjustment(mm)
	mm.h += hbargap
	mm.h += hbargap * 2

	c0 = VGAPRN.color0
	c1 = VGAPRN.color1
	done = 0
	result = INPUT_RESULT_CANCEL
	while not done:
		if INPUT.idle_callback:
			INPUT.idle_callback( mm, strings, cursor)

		message_draw_frame(mm)

		x2 = mm.x + mm.xpadding
		y2 = mm.y + mm.ypadding
		VGAPRN.justify = JUSTIFY_LEFT
		VGAPRN.zerowrite = 1
		VGAPRN.printf( (x2,y2), caption)
		y2 += mm.h0
		pygame.draw.rect( pygame_library_screen, VGAPRN.color2,
										(mm.x + mm.xpadding,y2,
											mm.w - 2 * mm.xpadding,hbargap))
		y2 += hbargap * 2
		for i in range( mm.numlines):
			s = strings[i + topline]
			if i + topline == cursor:
				VGAPRN.color0 = c1
				VGAPRN.color1 = c0
			else:
				VGAPRN.color0 = c0
				VGAPRN.color1 = c1
			VGAPRN.printf( (x2,y2), s)
			y2 += mm.h0
		VGAPRN.color0 = c0
		VGAPRN.color1 = c1

		if mm.maxlines > mm.numlines:
			# <WIP> show some kind of thumbnail indicator on vertical extent of list
			if topline > 0:
				message_draw_arrow( (mm.x + mm.w - 10, mm.y + (mm.h0 * 2)), 0)
			if topline + MESSAGE.max_display_lines < mm.maxlines:
				message_draw_arrow( (mm.x + mm.w - 10, mm.y + mm.h - (mm.h0 / 2)), 2)

		if MESSAGE.keystroke_timer > 0:
			MESSAGE.keystroke_timer -= 1

		waitclock()

		for u in INPUT.unicodeses:
			if u in (chr(27),):
				done = 1
				result = INPUT_RESULT_CANCEL
			elif u in (chr(10), chr(13)):
				done = 1
				result = INPUT_RESULT_ACCEPT
			elif ((u >= 'a') and (u <= 'z')) or ((u >= 'A') and (u <= 'Z')) or ((u >= '0') and (u <= '9')):
				if MESSAGE.keystroke_timer > 0:
					MESSAGE.keystroke_string = MESSAGE.keystroke_string + ("%c" % u)
				else:
					MESSAGE.keystroke_string = "%c" % u
				MESSAGE.keystroke_timer = MESSAGE_KEYSTROKE_TIMER_TIME
				searchor = cursor
				found = 0
				for n in range(count):
					if len(MESSAGE.keystroke_string) > 1:
						if strings[searchor].lower().startswith(MESSAGE.keystroke_string):
							found = 1
							cursor = searchor
							break
					searchor += 1
					if searchor >= count:
						searchor = 0
					if strings[searchor].lower().startswith(MESSAGE.keystroke_string):
						found = 1
					if found:
						cursor = searchor
						break
				if cursor < topline:
					topline = cursor
				while cursor >= topline + MESSAGE.max_display_lines:
					topline += 1
		for k in INPUT.keypresses:
			if k == K_HOME:
				cursor = 0
				topline = 0
			if k == K_END:
				cursor = count - 1
				while cursor >= topline + MESSAGE.max_display_lines:
					topline += 1
			if k == K_UP:
				cursor -= 1
				if cursor < 0:
					cursor = 0
				if cursor < topline:
					topline = cursor
			if k == K_DOWN:
				cursor += 1
				if cursor >= count:
					cursor = count - 1
				while cursor >= topline + MESSAGE.max_display_lines:
					topline += 1
			if k == K_PAGEUP:
				cursor -= MESSAGE.max_display_lines - 1
				if cursor < 0:
					cursor = 0
				if cursor < topline:
					topline = cursor
			if k == K_PAGEDOWN:
				cursor += MESSAGE.max_display_lines
				if cursor >= count:
					cursor = count - 1
				while cursor >= topline + MESSAGE.max_display_lines:
					topline += 1
		if INPUT.keybits[ K_DOWN]:
			if INPUT.autorepeat():
				cursor += 1
				if cursor >= count:
					cursor = count - 1
				while cursor >= topline + MESSAGE.max_display_lines:
					topline += 1
		elif INPUT.keybits[ K_UP]:
			if INPUT.autorepeat():
				cursor -= 1
				if cursor < 0:
					cursor = 0
				if cursor < topline:
					topline = cursor
		elif INPUT.keybits[ K_PAGEUP]:
			if INPUT.autorepeat():
				cursor -= MESSAGE.max_display_lines - 1
				if cursor < 0:
					cursor = 0
				if cursor < topline:
					topline = cursor
		elif INPUT.keybits[ K_PAGEDOWN]:
			if INPUT.autorepeat():
				cursor += MESSAGE.max_display_lines
				if cursor >= count:
					cursor = count - 1
				while cursor >= topline + MESSAGE.max_display_lines:
					topline += 1
		else:
			INPUT.autorepeat(0)

	waitclock()

	if emptylist:
		return -1

	if result == INPUT_RESULT_ACCEPT:
		return cursor

	return -1

##################################################################
def	message_simple_sally(strings,milliseconds=1000):
	strings = list( strings)
	done = 0
	message_paint_simple_centered(strings)
	waitclock()
	pygame.time.wait(milliseconds)
	return INPUT_RESULT_ACCEPT

##################################################################
def	message_simple_gets(strings,gets):
	strings = list( strings)
	INPUT.flush()
	strings.append( "")
	done = 0
	# A little tricky on callbacks: if we have one, turn it
	hold_idle_callback = INPUT.idle_callback
	INPUT.idle_callback = None
	mm = message_paint_simple_centered(strings)
	# Now put it back so it can function through GETS
	INPUT.idle_callback = hold_idle_callback
	gets.mm = mm
	gets.x = mm.x + mm.xpadding
	gets.y = VGAPRN.lastrect.y
	gets.width = mm.w - 2 * mm.xpadding
	VGAPRN.justify = JUSTIFY_LEFT
	result = gets.gets()
	waitclock()
	return result

##################################################################
def	message_textfile_paint_helper(strings,topline, r):
	if VGAPRN.color0:
		pygame.draw.rect( pygame_library_screen, VGAPRN.color0, r)

	x = r[0]
	y = r[1]

	remaining = 0

	for i in range( len( strings)):
		if i >= topline:
			s = strings[i]
			if len(s):
				if s[-1] == '\n':
					s = s[:-1]
				VGAPRN.printf( (x, y), s)
			y += VGAPRN.getheight("")
			if y >= r[1] + r[3]:
				remaining = len(strings) - i
				break

	return remaining

##################################################################
def	message_simple_text_array( strings, topline = None, r = None):
	if topline == None:
		topline = 0

	if r == None:
		r = pygame.Rect( 0,0, scrx, scry)
	if r[2] < 0:
		r = pygame.Rect( r[0], r[1], r[2] + scrx, r[3])
	if r[3] < 0:
		r = pygame.Rect( r[0], r[1], r[2], r[3] + scry)

	mm = MESSAGE_METRICS()
	mm.x = r[0]
	mm.y = r[1]
	mm.w = r[2]
	mm.h = r[3]
	mm.xpadding = 0
	mm.ypadding = 0

	VGAPRN.justify = JUSTIFY_LEFT

	strings = strings[:]

	# expand tabs to spaces
	for i in range( len( strings)):
		n = strings[i].find( "\t")
		while n >= 0:
			spaces = (4 - (n & 3)) * " "
			strings[i] = strings[i][:n] + spaces + strings[i][n+1:]
			n = strings[i].find( "\t")

	linesshown = int( r[3] / VGAPRN.getheight(""))

	done = 0
	dirty = 1
	remaining = 0
	while not done:
		if INPUT.idle_callback:
			INPUT.idle_callback( mm)
			dirty = 1

		if dirty:
			dirty = 0
			remaining = message_textfile_paint_helper( strings, topline, r)

		for u in INPUT.unicodeses:
			if u in (chr(27),):
				done = 1

		if INPUT.keybits[K_UP]:
			topline -= 1
			if topline < 0:
				topline = 0
			dirty = 1

		if remaining:
			if INPUT.keybits[K_DOWN]:
				topline += 1
				dirty = 1

		for k in INPUT.keypresses:
			if k == K_HOME:
				topline = 0
				dirty = 1
			elif k == K_END:
				topline = len( strings) - linesshown
				dirty = 1
			elif k == K_PAGEUP:
				topline -= linesshown - 1
				if topline < 0:
					topline = 0
				dirty = 1
			elif k == K_PAGEDOWN:
				if remaining:
					topline += linesshown - 1
					dirty = 1

		waitclock()

	waitclock()
	return topline

##################################################################
def	message_simple_text_file( filename, topline = None, r = None):
	strings = load_text_file(filename)
	return message_simple_text_array(strings, topline, r)

##################################################################
def	message_private_setfontspec( fontspec):
	if fontspec == None:
		return
	if fontspec == 0:
		fontspec = 25		# default font size
	# <WIP> check for integer or bitmap or other possibilities
	# for now we assume integer
	VGAPRN.setsize( fontspec)
	return

# for reading large blobs of text, text files for instance
def	message_setcolor_text(fontspec = None):
	message_private_setfontspec(fontspec)
	VGAPRN.color1 = (222,222,222)
	VGAPRN.color0 = (  0,  0, 50)
	VGAPRN.color2 = (100,255,100)
	return

# for general small information popups
def	message_setcolor_info(fontspec = None):
	message_private_setfontspec(fontspec)
	VGAPRN.color1 = (255,255,255)
	VGAPRN.color0 = ( 50, 50,100)
	VGAPRN.color2 = (200,200,200)
	return

# success messages
def	message_setcolor_good(fontspec = None):
	message_private_setfontspec(fontspec)
	VGAPRN.color1 = (100,255, 50)
	VGAPRN.color0 = (  0, 30,  0)
	VGAPRN.color2 = (100,200,100)
	return

# bad things have happened messages - or WATCH OUT, CAUTION
def	message_setcolor_bad(fontspec = None):
	message_private_setfontspec(fontspec)
	VGAPRN.color1 = (255,255, 50)
	VGAPRN.color0 = (140,  0,  0)
	VGAPRN.color2 = (255,  0,  0)
	return

##################################################################
def	message_setcolor_threeby(image):
	MESSAGE.threeby_image = image
	MESSAGE.threeby_image_expanded = None
	return


##################################################################
# This is part of Kurt Dekker's common python library codebase.
#

##################################################################
# generic result codes for various input subsystems
INPUT_RESULT_CANCEL = 1
INPUT_RESULT_ACCEPT = 2
INPUT_RESULT_REJECT = 3

# Aliases to the above
INPUT_RESULT_YES = INPUT_RESULT_ACCEPT
INPUT_RESULT_NO = INPUT_RESULT_REJECT

##################################################################
# an attempt to abstract the current player's controller
CONTROLLER_KEY_UP    = 0
CONTROLLER_KEY_DOWN  = 1
CONTROLLER_KEY_LEFT  = 2
CONTROLLER_KEY_RIGHT = 3
CONTROLLER_KEY_FIRE1 = 4
CONTROLLER_KEY_FIRE2 = 5
CONTROLLER_MAXIMUM   = 6

##################################################################
JOYSTICK_MAP_LEFTANALOG_TO_UDLR = 0x0001
JOYSTICK_MAP_BUTTON1_TO_ENTER = 0x0002
JOYSTICK_MAP_BUTTON2_TO_ENTER = 0x0004
JOYSTICK_MAP_BUTTON4_TO_ESCAPE = 0x0008

##################################################################
def	input_draw_default_mousecursor((x,y)):
	def	arrow(c):
		pygame.draw.line( pygame_library_screen, c, (x,y), (x,y+8), 2)
		pygame.draw.line( pygame_library_screen, c, (x,y), (x+8,y), 2)
		pygame.draw.line( pygame_library_screen, c, (x,y), (x+16,y+16), 2)
		return
	x += 1
	y += 2
	arrow((0,0,0))
	x -= 1
	y -= 2
	arrow((150,150,150))
	pygame.draw.rect( pygame_library_screen, (255,255,255), (x, y, 4, 4))
	return

##################################################################
class	_input:
	def	__init__(self):
		self.keybits = pygame.key.get_pressed()
		self.prevkeybits = self.keybits[:]
		self.keypresses = []
		self.unicodeses = []
		self.mousecursor_x = 0
		self.mousecursor_y = 0
		self.mousecursor_prevx = 0
		self.mousecursor_prevy = 0
		self.micestuffs = []
		self.mousebuttons = pygame.mouse.get_pressed()[:]
		self.prevmousebuttons = self.mousebuttons[:]
		self.mousecursor_function = 0
		self.mousecursor_function_stack = []
		self.controller_prev = CONTROLLER_MAXIMUM *[0]
		self.controller_curr = CONTROLLER_MAXIMUM *[0]
		self.controller_trig = CONTROLLER_MAXIMUM *[0]
		self.controller_rele = CONTROLLER_MAXIMUM *[0]

		self.autorepeater = 0
		self.autorepeater_delay = 10
		self.autorepeater_rate = 2

		self.joystick_mapping_predefined = 0
#/ comment out any lines you disagree with!
		self.joystick_mapping_predefined |= JOYSTICK_MAP_LEFTANALOG_TO_UDLR
		self.joystick_mapping_predefined |= JOYSTICK_MAP_BUTTON1_TO_ENTER
		self.joystick_mapping_predefined |= JOYSTICK_MAP_BUTTON2_TO_ENTER
		self.joystick_mapping_predefined |= JOYSTICK_MAP_BUTTON4_TO_ESCAPE

		self.mapping_restore_default()

		self.idle_callback = None

		return

	def	add_kb2cm(self,pair):
		self.mapping_keybits_to_controllers.append(pair)
		return

	def	mapping_restore_default(self):
		self.mapping_keybits_to_controllers = []
		self.mapping_keybits_to_controllers.append( (K_UP, CONTROLLER_KEY_UP))
		self.mapping_keybits_to_controllers.append( (K_DOWN, CONTROLLER_KEY_DOWN))
		self.mapping_keybits_to_controllers.append( (K_LEFT, CONTROLLER_KEY_LEFT))
		self.mapping_keybits_to_controllers.append( (K_RIGHT, CONTROLLER_KEY_RIGHT))
		self.mapping_keybits_to_controllers.append( (K_LCTRL, CONTROLLER_KEY_FIRE1))
		self.mapping_keybits_to_controllers.append( (K_SPACE, CONTROLLER_KEY_FIRE2))

		self.mapping_joybuttons_to_metakeys = []
		self.mapping_joybuttons_to_metakeys.append( (2, CONTROLLER_KEY_FIRE1))
		self.mapping_joybuttons_to_metakeys.append( (4, CONTROLLER_KEY_FIRE2))

		return

	def	mousecursor_function_set( self, f):
		if f == -1:			# "pop"
			if len(self.mousecursor_function_stack):
				self.mousecursor_function = self.mousecursor_function_stack[-1]
				self.mousecursor_function_stack = self.mousecursor_function_stack[:-1]
			return
		# push
		self.mousecursor_function_stack.append(self.mousecursor_function)
		self.mousecursor_function = f
		return

	def	mousecursor_function_pop( self, f):
		self.mousecursor_function = f
		return

	def call_mousecursor_function(self):
		if self.mousecursor_function:
			self.mousecursor_function((self.mousecursor_x,self.mousecursor_y))
		elif scrnflags & pygame.FULLSCREEN:
			input_draw_default_mousecursor((self.mousecursor_x,self.mousecursor_y))
		return

	def flush(self):
		self.process_input_event_queue()
		self.process_input_event_queue()
		return

	def process_input_event_queue(self):
		joystick_think()

		self.prevkeybits = self.keybits[:]
		self.keybits = pygame.key.get_pressed()

		# you need to process ALL keypresses each frame, or else they're GONE!
		self.keypresses = []
		self.unicodeses = []

		self.micestuffs = []
		self.mousecursor_prevx = self.mousecursor_x
		self.mousecursor_prevy = self.mousecursor_y

		self.prevmousebuttons = self.mousebuttons[:]
		self.mousebuttons = pygame.mouse.get_pressed()[:]

		for e in pygame.event.get():
			if (e.type == pygame.MOUSEBUTTONDOWN) or (e.type == pygame.MOUSEBUTTONUP) or (e.type == pygame.MOUSEMOTION):
				self.micestuffs.append( e)
				self.mousecursor_x = e.pos[0]
				self.mousecursor_y = e.pos[1]

			if e.type == pygame.KEYDOWN:
				# throw the keypresses in this list so canvases can process them
				self.keypresses.append( e.key)
				self.unicodeses.append( e.unicode)

			if e.type in (pygame.QUIT,):
				canvas_set_current(0)
				break

			if e.type in (pygame.VIDEORESIZE,):
				global scrx,scry,screen_size,scrnflags
				global screen, pygame_library_screen, pygame_library_screen_original
				scrx = e.w
				scry = e.h
				screen_size = (scrx,scry)
				hold_backing_store = screen.copy()
				screen = pygame.display.set_mode(screen_size,scrnflags)
				screen.blit( hold_backing_store, (0,0))
				pygame_library_screen = screen
				pygame_library_screen_original = screen
				break

		# age the data
		for i in xrange(CONTROLLER_MAXIMUM):
			self.controller_prev[i] = self.controller_curr[i]
			self.controller_curr[i] = 0

		# kb2cm is "keybit 2 controller map"
		for kb2cm in self.mapping_keybits_to_controllers:
			self.controller_curr[ kb2cm[1]] |= self.keybits[ kb2cm[0]]

		# jb2mk is "joybutton 2 meta key"
		for jb2mk in self.mapping_joybuttons_to_metakeys :
			if jbuttons & jb2mk[0]:
				self.controller_curr[ jb2mk[1]] |= 1

		#/ left stick mapped to up/down/left/right controls
		if self.joystick_mapping_predefined & JOYSTICK_MAP_LEFTANALOG_TO_UDLR:
			if (jx1 != -1) and (jy1 != -1):
				if jx1 < 100 - joystick_dead_zone:
					self.controller_curr[CONTROLLER_KEY_LEFT] = 1
				if jx1 >  100 + joystick_dead_zone:
					self.controller_curr[CONTROLLER_KEY_RIGHT] = 1
				if jy1 < 100 - joystick_dead_zone:
					self.controller_curr[CONTROLLER_KEY_UP] = 1
				if jy1 > 100 + joystick_dead_zone:
					self.controller_curr[CONTROLLER_KEY_DOWN] = 1

		if self.joystick_mapping_predefined & JOYSTICK_MAP_BUTTON1_TO_ENTER:
			if jbuttons & 1:
				if not (prevjbuttons & 1):
					self.unicodeses.append( chr(13))

		if self.joystick_mapping_predefined & JOYSTICK_MAP_BUTTON2_TO_ENTER:
			if jbuttons & 2:
				if not (prevjbuttons & 2):
					self.unicodeses.append( chr(13))

		if self.joystick_mapping_predefined & JOYSTICK_MAP_BUTTON4_TO_ESCAPE:
			if jbuttons & 8:
				if not (prevjbuttons & 8):
					self.unicodeses.append( chr(27))

		# detect edges
		for i in xrange(CONTROLLER_MAXIMUM):
			self.controller_trig[i] = self.controller_curr[i] and (self.controller_curr[i] ^ self.controller_prev[i])
			self.controller_rele[i] = self.controller_prev[i] and (self.controller_curr[i] ^ self.controller_prev[i])

		return

	def	holding_shift_key(self):
		return (self.keybits[K_LSHIFT] != 0) or (self.keybits[K_RSHIFT] != 0)

	# tricky function:
	#	- if you give no argument, it increments the repeater and
	#		returns if it overflows (i.e., you should repeat), and also
	#		backs down the repeater by the rate value
	#	- if you give zero (0), it zeroes out the repeater and returns nothing
	def	autorepeat(self,cmd=None):
		if cmd == None:
			self.autorepeater += 1
			if self.autorepeater >= self.autorepeater_delay:
				self.autorepeater -= self.autorepeater_rate
				return 1
			return 0
		if cmd == 0:
			self.autorepeater = 0
		return

	def	mousecursor_test_rect(self,r):
		r = pygame.Rect(r)
		return r.collidepoint( INPUT.mousecursor_x, INPUT.mousecursor_y)

##################################################################
INPUT = _input()


##################################################################
# This is part of Kurt Dekker's common python library codebase.
#

##################################################################
# The simplest way to use and test this is just a simple GETS().gets()
#
# Testbed code also exists in test:canvas_testc

GETS_ACCEPTABLE_CHARS_ALL = None
GETS_ACCEPTABLE_CHARS_DIGITS = "0123456789"
GETS_ACCEPTABLE_ALPHA_LOWER = "abcdefghijklmnopqrstuvwxyz"
GETS_ACCEPTABLE_ALPHA_UPPER = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"

GETS_ACCEPTABLE_FILENAME = GETS_ACCEPTABLE_ALPHA_LOWER
GETS_ACCEPTABLE_FILENAME += GETS_ACCEPTABLE_ALPHA_UPPER
GETS_ACCEPTABLE_FILENAME += GETS_ACCEPTABLE_CHARS_DIGITS
GETS_ACCEPTABLE_FILENAME += "_"

GETS_CONVERT_CASE_NONE = 0
GETS_CONVERT_CASE_TOUPPER = 1
GETS_CONVERT_CASE_TOLOWER = 2

GETS_MINWIDTH = 32

##################################################################
class	GETS:
	def __init__(self):
		self.result = INPUT_RESULT_CANCEL
		self.value = ""
		self.maxchars = 32
		self.acceptable_chars = None
		self.convert_case = GETS_CONVERT_CASE_NONE
		self.x = 0
		self.y = 0
		self.cursorpos = len( self.value)
		self.hiwaterxsz = 0
		self.cursorchar = chr(8)
		self.secure = 0
		self.blinkrate = (10,10)
		self.width = None
		return

	def gets(self):
		gets_finished = False
		VGAPRN.lastrect = None
		blinker = 0
		while not gets_finished:
			blinker += 1
			if blinker >= (self.blinkrate[0] + self.blinkrate[1]):
				blinker = 0
			if VGAPRN.lastrect:
				lr = pygame.Rect( VGAPRN.lastrect)
				if self.width > GETS_MINWIDTH:
					lr.w = self.width
				pygame.draw.rect( pygame_library_screen, VGAPRN.color0, lr)
			VGAPRN.zerowrite = 1
			todisplay = self.value
			if self.secure:
				todisplay = len( self.value) * "*"
			todisplay2 = todisplay + self.cursorchar
			if blinker <= self.blinkrate[0]:
				todisplay += self.cursorchar
			if INPUT.idle_callback:
				INPUT.idle_callback(self)
			# if we shift and trim width, we do so based on the
			# displayed string WITH the cursor.
			if self.width > GETS_MINWIDTH:
				while VGAPRN.getwidth(todisplay2) >= self.width:
					if len(todisplay) > 0:
						todisplay  = todisplay [1:]	# trim what we'll show
						todisplay2 = todisplay2[1:]	# trim the copy with guaranteed cursor
					else:
						break
			VGAPRN.printf( (self.x, self.y), todisplay)
			for u in INPUT.unicodeses:
				if u in (chr(27),):
					self.result = INPUT_RESULT_CANCEL
					gets_finished = True
				elif u in (chr(10), chr(13),):
					self.result = INPUT_RESULT_ACCEPT
					gets_finished = True
				elif u in (chr(8), chr(127),):
					blinker = 0
					if len(self.value):
						self.value = self.value[:-1]
				elif u in (chr(21),):
					self.value = ""
				else:
					blinker = 0
					if len(self.value) < self.maxchars:
						if len(u):
							if (ord(u) >= 32) and (ord(u) < 128):
								if self.convert_case == GETS_CONVERT_CASE_TOUPPER:
									u = u.upper()
								if self.convert_case == GETS_CONVERT_CASE_TOLOWER:
									u = u.lower()
								if (not self.acceptable_chars) or (u in self.acceptable_chars):
									self.value += u
					else:
						# <WIP> beep!
						pass
			if INPUT.keybits[ K_DELETE] or INPUT.keybits[ K_BACKSPACE]:
				if INPUT.autorepeat():
					blinker = 0
					if len(self.value):
						self.value = self.value[:-1]
			waitclock()
		return self.result

##################################################################
xtable8 = ( 0, 1, 1, 1, 0, -1, -1, -1)
ytable8 = ( -1, -1, 0, 1, 1, 1, 0, -1)

xtable4 = (  0,  1,  0, -1)
ytable4 = ( -1,  0,  1,  0)

##################################################################
def	SIGN(x):
	if x < 0:
		return -1
	if x > 0:
		return 1
	return 0

##################################################################
# the basic plot-a-bitmap function (blit) based on the shape center
def	plot( (x, y), shape, sfc = None):
	r = (x - shape.get_width() / 2,y - shape.get_height() / 2)
	if not sfc:
		sfc = pygame_library_screen
	sfc.blit( shape, r)
	return
def	plot0( (x, y), shape, sfc = None):
	r = (x,y)
	if not sfc:
		sfc = pygame_library_screen
	sfc.blit( shape, r)
	return
# you want to make this shape be an alpha-cut-out white shape
def	erase( (x, y), shape, sfc = None):
	r = (x - shape.get_width() / 2,y - shape.get_height() / 2)
	if not sfc:
		sfc = pygame_library_screen
	sfc.blit( shape, r, None, BLEND_RGBA_SUB)
	return

##################################################################

##################################################################
# This is part of Kurt Dekker's common python library codebase.
#

##################################################################
CANVASOP_UPDATE = 1
CANVASOP_TRANSITION_IN = 2
CANVASOP_TRANSITION_OUT = 3
CANVASOP_USER1 = 4

##################################################################

##################################################################
# This is part of Kurt Dekker's common python library codebase.
#
# Shapestrips are convenient ways of storing related same-sized
# small graphical pieces, such as animations.

##################################################################

##################################################################
HOTSPOT_CENTER_XY = 100
HOTSPOT_TOP_LEFT = 101
HOTSPOT_BOTTOM_CENTER_X = 102

##################################################################
def	hotspot_sethotspot(o,hotspot=None):
	# commonize the xsize xsz etc.
	try:
		xsize = o.xsize
		ysize = o.ysize
	except AttributeError:
		try:
			xsize = o.r[2]
			ysize = o.r[3]
		except AttributeError:
			print "hotspot_sethotspot(): didn't find xsize or rect!"
			sys.exit()
	# you can supply hotspot, or it will use the center
	# <WIP> support for some text-defined presets, like "Bottom Center" for instance
	if (hotspot == None) or (hotspot == HOTSPOT_CENTER_XY):
		o.hotx = xsize / 2
		o.hoty = ysize / 2
	elif hotspot == HOTSPOT_BOTTOM_CENTER_X:
		o.hotx = xsize / 2
		o.hoty = ysize - 1
	else:
		#/ presuming hotspot is a tuple
		o.hotx = hotspot[0]
		o.hoty = hotspot[1]
	return

##################################################################
class shapestrip:
	def	__init__(self, filename_or_surface = None, ysize = None):
		if filename_or_surface:
			if isinstance( filename_or_surface, pygame.Surface):
				self.shape = filename_or_surface
			else:		# presume isinstance(string)
				self.shape = load_image( filename_or_surface)
			self.xsize = self.shape.get_width()
			self.ysize = ysize
			self.hotx = self.xsize / 2
			self.hoty = self.ysize / 2
			self.numframes = self.shape.get_height() / ysize
			self.sethotspot(None)
		else:
			# makes an empty one so you can fill it
			pass
		return

	def	plot(self,(x,y),frameno):
		dst = (x - self.hotx, y - self.hoty,0,0)
		src = (0, frameno * self.ysize, self.xsize, self.ysize)
		pygame_library_screen.blit( self.shape, dst, src)
		return

	def	plot_rotated(self,(x,y),frameno,angle):
		dst = (x - self.hotx, y - self.hoty,0,0)
		src = (0, frameno * self.ysize, self.xsize, self.ysize)
		newshape = pygame.Surface( (self.xsize, self.ysize))
		newshape.blit( self.shape, (0,0), src)

		# Before doing this transform.rotate, we need to set the upper
		# left corner to transparent so we don't have extra boundary draw.
		newshape.lock()
		newshape.set_at( (0,0), (0,0,0,0))
		newshape.unlock()

		pygame_library_screen.blit( pygame.transform.rotate( newshape, angle), dst)
		return

	def clone_from(self,source,(x,y,w,h)):
		self.shape = pygame.Surface( (w, h))
		self.shape.blit( source.shape, (-x,y))
		self.xsize = w
		self.ysize = h
		self.hotx = w / 2
		self.hoty = h / 2
		# for now we only support ONE frame copies
		self.numframes = 1
		return

	def	clone(self):
		ss = shapestrip()
		ss.shape = self.shape.copy()
		ss.xsize = self.xsize
		ss.ysize = self.ysize
		ss.hotx = self.hotx
		ss.hoty = self.hoty
		ss.numframes = self.numframes
		return ss

	def	sethotspot(self,hotspot):
		hotspot_sethotspot(self,hotspot)
		return

	def	__repr__(self):
		return "shapestrip:(%u,%u):frames=%u" % (self.xsize,self.ysize,self.numframes)

##################################################################
def shapestrip_load_xflipped_pair(file,ysize):
	s1 = shapestrip(file,ysize)
	s2 = shapestrip(file,ysize)
	s2.shape = clone_image_flipped_x(s2.shape)
	return (s1,s2)

##################################################################

# image2py.py created from 'fullscreen_button.tga'

##################################################################

##################################################################
dpe_palette = (
# converted by c:\py\junk\convert_dpe_palette.py on 6:56 AM 12/23/2010
(   0,   0,   0),		#   0
(   0,   0, 170),		#   1
(   0, 170,   0),		#   2
(   0, 170, 170),		#   3
( 170,   0,   0),		#   4
( 170,   0, 170),		#   5
( 170,  85,   0),		#   6
( 170, 170, 170),		#   7
(  85,  85,  85),		#   8
(  85,  85, 255),		#   9
(  85, 255,  85),		#  10
(  85, 255, 255),		#  11
( 255,  85,  85),		#  12
( 255,  85, 255),		#  13
( 255, 255,  85),		#  14
( 255, 255, 255),		#  15
( 238, 238, 238),		#  16
( 222, 222, 222),		#  17
( 210, 210, 210),		#  18
( 194, 194, 194),		#  19
( 182, 182, 182),		#  20
( 170, 170, 170),		#  21
( 153, 153, 153),		#  22
( 141, 141, 141),		#  23
( 125, 125, 125),		#  24
( 113, 113, 113),		#  25
( 101, 101, 101),		#  26
(  85,  85,  85),		#  27
(  72,  72,  72),		#  28
(  56,  56,  56),		#  29
(  44,  44,  44),		#  30
(  32,  32,  32),		#  31
( 255,   0,   0),		#  32
( 238,   0,   0),		#  33
( 226,   0,   0),		#  34
( 214,   0,   0),		#  35
( 202,   0,   0),		#  36
( 190,   0,   0),		#  37
( 178,   0,   0),		#  38
( 165,   0,   0),		#  39
( 153,   0,   0),		#  40
( 137,   0,   0),		#  41
( 125,   0,   0),		#  42
( 113,   0,   0),		#  43
( 101,   0,   0),		#  44
(  89,   0,   0),		#  45
(  76,   0,   0),		#  46
(  64,   0,   0),		#  47
( 255, 218, 218),		#  48
( 255, 186, 186),		#  49
( 255, 157, 157),		#  50
( 255, 125, 125),		#  51
( 255,  93,  93),		#  52
( 255,  64,  64),		#  53
( 255,  32,  32),		#  54
( 255,   0,   0),		#  55
( 255, 170,  93),		#  56
( 255, 153,  64),		#  57
( 255, 137,  32),		#  58
( 255, 121,   0),		#  59
( 230, 109,   0),		#  60
( 206,  97,   0),		#  61
( 182,  85,   0),		#  62
( 157,  76,   0),		#  63
( 255, 255, 218),		#  64
( 255, 255, 186),		#  65
( 255, 255, 157),		#  66
( 255, 255, 125),		#  67
( 255, 250,  93),		#  68
( 255, 246,  64),		#  69
( 255, 246,  32),		#  70
( 255, 246,   0),		#  71
( 230, 218,   0),		#  72
( 206, 198,   0),		#  73
( 182, 174,   0),		#  74
( 157, 157,   0),		#  75
( 133, 133,   0),		#  76
( 113, 109,   0),		#  77
(  89,  85,   0),		#  78
(  64,  64,   0),		#  79
( 210, 255,  93),		#  80
( 198, 255,  64),		#  81
( 182, 255,  32),		#  82
( 161, 255,   0),		#  83
( 145, 230,   0),		#  84
( 129, 206,   0),		#  85
( 117, 182,   0),		#  86
(  97, 157,   0),		#  87
( 218, 255, 218),		#  88
( 190, 255, 186),		#  89
( 157, 255, 157),		#  90
( 129, 255, 125),		#  91
(  97, 255,  93),		#  92
(  64, 255,  64),		#  93
(  32, 255,  32),		#  94
(   0, 255,   0),		#  95
(   0, 255,   0),		#  96
(   0, 238,   0),		#  97
(   0, 226,   0),		#  98
(   0, 214,   0),		#  99
(   4, 202,   0),		# 100
(   4, 190,   0),		# 101
(   4, 178,   0),		# 102
(   4, 165,   0),		# 103
(   4, 153,   0),		# 104
(   4, 137,   0),		# 105
(   4, 125,   0),		# 106
(   4, 113,   0),		# 107
(   4, 101,   0),		# 108
(   4,  89,   0),		# 109
(   4,  76,   0),		# 110
(   4,  64,   0),		# 111
( 218, 255, 255),		# 112
( 186, 255, 255),		# 113
( 157, 255, 255),		# 114
( 125, 255, 250),		# 115
(  93, 255, 255),		# 116
(  64, 255, 255),		# 117
(  32, 255, 255),		# 118
(   0, 255, 255),		# 119
(   0, 230, 230),		# 120
(   0, 206, 206),		# 121
(   0, 182, 182),		# 122
(   0, 157, 157),		# 123
(   0, 133, 133),		# 124
(   0, 113, 113),		# 125
(   0,  89,  89),		# 126
(   0,  64,  64),		# 127
(  93, 190, 255),		# 128
(  64, 178, 255),		# 129
(  32, 170, 255),		# 130
(   0, 157, 255),		# 131
(   0, 141, 230),		# 132
(   0, 125, 206),		# 133
(   0, 109, 182),		# 134
(   0,  93, 157),		# 135
( 218, 218, 255),		# 136
( 186, 190, 255),		# 137
( 157, 157, 255),		# 138
( 125, 129, 255),		# 139
(  93,  97, 255),		# 140
(  64,  64, 255),		# 141
(  32,  36, 255),		# 142
(   0,   4, 255),		# 143
(   0,   0, 255),		# 144
(   0,   0, 238),		# 145
(   0,   0, 226),		# 146
(   0,   0, 214),		# 147
(   0,   0, 202),		# 148
(   0,   0, 190),		# 149
(   0,   0, 178),		# 150
(   0,   0, 165),		# 151
(   0,   0, 153),		# 152
(   0,   0, 137),		# 153
(   0,   0, 125),		# 154
(   0,   0, 113),		# 155
(   0,   0, 101),		# 156
(   0,   0,  89),		# 157
(   0,   0,  76),		# 158
(   0,   0,  64),		# 159
( 242, 218, 255),		# 160
( 230, 186, 255),		# 161
( 218, 157, 255),		# 162
( 210, 125, 255),		# 163
( 202,  93, 255),		# 164
( 190,  64, 255),		# 165
( 182,  32, 255),		# 166
( 170,   0, 255),		# 167
( 153,   0, 230),		# 168
( 129,   0, 206),		# 169
( 117,   0, 182),		# 170
(  97,   0, 157),		# 171
(  80,   0, 133),		# 172
(  68,   0, 113),		# 173
(  52,   0,  89),		# 174
(  40,   0,  64),		# 175
( 255, 218, 255),		# 176
( 255, 186, 255),		# 177
( 255, 157, 255),		# 178
( 255, 125, 255),		# 179
( 255,  93, 255),		# 180
( 255,  64, 255),		# 181
( 255,  32, 255),		# 182
( 255,   0, 255),		# 183
( 226,   0, 230),		# 184
( 202,   0, 206),		# 185
( 182,   0, 182),		# 186
( 157,   0, 157),		# 187
( 133,   0, 133),		# 188
( 109,   0, 113),		# 189
(  89,   0,  89),		# 190
(  64,   0,  64),		# 191
( 255, 234, 222),		# 192
( 255, 226, 210),		# 193
( 255, 218, 198),		# 194
( 255, 214, 190),		# 195
( 255, 206, 178),		# 196
( 255, 198, 165),		# 197
( 255, 190, 157),		# 198
( 255, 186, 145),		# 199
( 255, 178, 129),		# 200
( 255, 165, 113),		# 201
( 255, 157,  97),		# 202
( 242, 149,  93),		# 203
( 234, 141,  89),		# 204
( 222, 137,  85),		# 205
( 210, 129,  80),		# 206
( 202, 125,  76),		# 207
( 190, 121,  72),		# 208
( 182, 113,  68),		# 209
( 170, 105,  64),		# 210
( 161, 101,  60),		# 211
( 157,  97,  56),		# 212
( 145,  93,  52),		# 213
( 137,  89,  48),		# 214
( 129,  80,  44),		# 215
( 117,  76,  40),		# 216
( 109,  72,  36),		# 217
(  93,  64,  32),		# 218
(  85,  60,  28),		# 219
(  72,  56,  24),		# 220
(  64,  48,  24),		# 221
(  56,  44,  20),		# 222
(  40,  32,  12),		# 223
(   0,   0,   0),		# 224
(   0,   0,   0),		# 225
(   0,   0,   0),		# 226
(   0,   0,   0),		# 227
(   0,   0,   0),		# 228
(   0,   0,   0),		# 229
(   0,   0,   0),		# 230
(   0,   0,   0),		# 231
( 198,  40,  40),		# 232
( 198,  76,  40),		# 233
( 198, 117,  40),		# 234
( 198, 157,  40),		# 235
( 198, 198,  40),		# 236
( 157, 198,  40),		# 237
( 117, 198,  40),		# 238
(  76, 198,  40),		# 239
(  40, 198,  48),		# 240
(  40, 198,  93),		# 241
(  40, 198, 137),		# 242
(  40, 198, 182),		# 243
(  40, 170, 198),		# 244
(  40, 125, 198),		# 245
(  40,  80, 198),		# 246
(  44,  40, 198),		# 247
(  89,  40, 198),		# 248
( 133,  40, 198),		# 249
( 178,  40, 198),		# 250
( 198,  40, 174),		# 251
( 198,  40, 129),		# 252
( 198,  40,  85),		# 253
( 198,  40,  40),		# 254
( 255, 255, 255),		# 255
)

##################################################################
# This expands RLE integer lists made by image2py.py utility
#
def	rle_expander(list):
	i = 0
	while i < len( list):
		for b in range(list[i]):
			yield list[i + 1]
		i += 2


##################################################################
def	tprot_unprotect_fp(fp):
	fp.seek(0)
	for i in xrange(80):
		d = fp.read(1)
		if d == chr(26):		# premature EOF, must be the one we want!
			return
	fp.seek(0)		# didn't find an EOF, just rewind the file
	return

##################################################################
GSFORMAT_8BIT_DPE = 1
GSFORMAT_IMAGE2PY_RLE = 2
GSFORMAT_IMAGE2PY_RAW = 3

##################################################################
class GETSHAP:
	# See the GETSHAP utility; output must match this constructor format
	def	__init__(self,gsformat,hotspots,dimensions,pixeldata,colortable = dpe_palette):
		self.gsformat = gsformat
		self.hotx = hotspots[0]
		self.hoty = hotspots[1]
		self.xsz = dimensions[0]
		self.ysz = dimensions[1]
		self.pixeldata = pixeldata
		self.colortable = colortable
		return

	def recreate_surface_32bitcolor(self):
		self.surface = pygame.Surface( (self.xsz, self.ysz), SRCALPHA)
		n = 0
		if self.gsformat == GSFORMAT_8BIT_DPE:
			for j in range(self.ysz):
				for i in range(self.xsz):
					if self.pixeldata[n]:
						self.surface.set_at( (i,j), self.colortable[ self.pixeldata[n]])
					n += 1
		elif self.gsformat == GSFORMAT_IMAGE2PY_RLE:
			d = rle_expander( self.pixeldata)
			for j in range(self.ysz):
				for i in range(self.xsz):
					self.surface.set_at( (i,j), self.colortable[ d.next()])
					n += 1
		else:
			print "GETSHAP.recreate_surface_32bitcolor(): unknown GSFORMAT == '%u'" % self.gsformat
			print "Failed to create the surface"
		return

	def recreate_surface_8bitcolor(self):
		self.surface = pygame.Surface( (self.xsz, self.ysz), 0, 8)	# paletized 8-bit image
		assert( len( self.colortable) <= 256);
		# if your palette entries provide alpha, then we make first color transparent
		if len( self.colortable[0]) == 4:
			self.surface.set_colorkey(0)
		# copy the palette entries over
		for i in range( len( self.colortable)):
			self.surface.set_palette_at( i, self.colortable[i])
		n = 0
		if self.gsformat == GSFORMAT_8BIT_DPE:
			for j in range(self.ysz):
				for i in range(self.xsz):
					if self.pixeldata[n]:
						self.surface.set_at( (i,j), self.pixeldata[n])
					n += 1
		elif self.gsformat == GSFORMAT_IMAGE2PY_RLE:
			d = rle_expander( self.pixeldata)
			for j in range(self.ysz):
				for i in range(self.xsz):
					self.surface.set_at( (i,j), d.next())
					n += 1
		else:
			print "GETSHAP.recreate_surface_8bitcolor(): unknown GSFORMAT == '%u'" % self.gsformat
			print "Failed to create the surface"
		return

	def recreate_surface(self,desired_colordepth=None):
		if desired_colordepth == None:
			desired_colordepth = 32
		if desired_colordepth == 32:
			self.recreate_surface_32bitcolor()
		elif desired_colordepth == 8:
			self.recreate_surface_8bitcolor()
		else:
			print "GETSHAP.recreate_surface(): unsupported desired_colordepth == '%u'" % desired_colordepth
			print "Failed to create the surface"
		return

	# desired_colordepth only matters on the first call!
	def get_surface(self,desired_colordepth=None):
		try:
			return self.surface
		except AttributeError:
			pass
		self.recreate_surface(desired_colordepth)
		return self.surface

	def	plot(self,pos):
		pos = (pos[0] - self.hotx, pos[1] - self.hoty)
		pygame_library_screen.blit( self.get_surface(), pos)
		return

##################################################################
class	GSKO:
	def	__init__(self,basename,palette=None):
		if palette:
			self.palette = palette
		else:
			self.palette = dpe_palette
		self.basename = basename
		self.load(basename)
		return

	def	getshape(self,n):
		return self.shapedict.get(n,self.unknshape)

	def	load(self,basename):
		self.clear()
		self.makeunknshape()
		self.insertfile(basename)
		return

	def	clear(self):
		self.shapedict = dict()
		return

	def	makeunknshape(self):
		self.unknshape = pygame.Surface( (40,40))
		self.unknshape.fill( (255,0,0))
		pygame_set_library_screen( self.unknshape)
		VGAPRN.zerowrite = 0
		VGAPRN.setsize(30)
		VGAPRN.justify = JUSTIFY_LEFT
		VGAPRN.printf( (5,5), "?")
		pygame_set_library_screen(-1)
		return

	def	insertfile(self,basename):
		# print "insertfile: '%s'" % basename
		self.gskfile = basename + ".gsk"
		self.gsofile = basename + ".gso"
		fpgsk = open( self.gskfile, "rb")
		tprot_unprotect_fp(fpgsk)
		fpgso = open( self.gsofile, "rb")
		# let's read some crudimentary header info, just what
		# I think was ever actually used, such as hotspots yes/no
		fpgso.seek(8)
		self.has_hotspots = ord( fpgso.read(1))
		# print "tell(fpgsk) = %u" % fpgsk.tell()
		for keyline in fpgsk.readlines():
			if len(keyline):
				if keyline[-1] == '\n':
					keyline = keyline[:-1]
				n1 = keyline.find( ":")
				if n1 >= 0:
					parttwo = keyline[n1+1:]
					keyline = keyline[:n1]
					n1 = keyline.find( "@")
					if n1 >= 0:
						atnum = int( keyline[n1+1:])
					else:
						atnum = keyline
					n1 = parttwo.find( " ")
					# chop off space and beyond (it's just human-readable shape size)
					if n1 >= 0:
						parttwo = parttwo[:n1]
					offset = int( parttwo)
					self.shapedict[atnum] = self.load1shape(fpgso,offset)
		fpgsk.close()
		fpgso.close()
		return

	def	load1shape(self,fpgso,offset):
		fpgso.seek(offset)
		def	read_short(fp):
			i = ord( fp.read(1))
			i += ord( fp.read(1)) << 8
			return i
		#/ let's presume hotspot info is present...
		if self.has_hotspots:
			hotx = read_short( fpgso)
			hoty = read_short( fpgso)
			# print "hotxy:", hotx, hoty
		w = read_short( fpgso)
		h = read_short( fpgso)
		# print "sizes:", w, h
		s = pygame.Surface( (w,h)).convert_alpha()
		s.fill( (0,0,0,0))
		s.lock()
		for j in xrange(h):
			for i in xrange(w):
				c = ord( fpgso.read(1))
				if c:
					s.set_at( (i,j), self.palette[c])
		s.unlock()
		return s

getshap_fullscreen_button_tga = GETSHAP(
	GSFORMAT_IMAGE2PY_RLE,
	(0,0),			# hotspots
	(24,96),		# dimensions
		(
1, 0, 22, 1, 1, 0, 1, 1, 1, 0, 20, 1, 1, 0, 1, 2, 2, 1, 20, 0,
2, 2, 2, 1, 20, 0, 2, 2, 2, 1, 20, 0, 2, 2, 2, 1, 20, 0, 2, 2,
2, 1, 20, 0, 2, 2, 2, 1, 20, 0, 2, 2, 2, 1, 20, 0, 2, 2, 2, 1,
20, 0, 2, 2, 2, 1, 20, 0, 2, 2, 2, 1, 20, 0, 2, 2, 2, 1, 20, 0,
2, 2, 2, 1, 20, 0, 2, 2, 2, 1, 20, 0, 2, 2, 2, 1, 20, 0, 2, 2,
2, 1, 20, 0, 2, 2, 2, 1, 20, 0, 2, 2, 2, 1, 20, 0, 2, 2, 2, 1,
20, 0, 2, 2, 2, 1, 20, 0, 2, 2, 2, 1, 20, 0, 2, 2, 1, 1, 1, 0,
20, 2, 1, 0, 1, 2, 1, 0, 22, 2, 1, 0, 1, 3, 22, 4, 1, 3, 1, 4,
1, 3, 20, 4, 1, 3, 1, 5, 2, 4, 20, 3, 2, 5, 2, 4, 20, 3, 2, 5,
2, 4, 20, 3, 2, 5, 2, 4, 20, 3, 2, 5, 2, 4, 20, 3, 2, 5, 2, 4,
20, 3, 2, 5, 2, 4, 20, 3, 2, 5, 2, 4, 20, 3, 2, 5, 2, 4, 20, 3,
2, 5, 2, 4, 20, 3, 2, 5, 2, 4, 20, 3, 2, 5, 2, 4, 20, 3, 2, 5,
2, 4, 20, 3, 2, 5, 2, 4, 20, 3, 2, 5, 2, 4, 20, 3, 2, 5, 2, 4,
20, 3, 2, 5, 2, 4, 20, 3, 2, 5, 2, 4, 20, 3, 2, 5, 2, 4, 20, 3,
2, 5, 2, 4, 20, 3, 2, 5, 1, 4, 1, 3, 20, 5, 1, 3, 1, 5, 1, 3,
22, 5, 1, 3, 75, 6, 6, 7, 6, 6, 6, 7, 6, 6, 1, 7, 4, 8, 1, 7,
6, 6, 1, 7, 4, 8, 1, 7, 6, 6, 1, 7, 2, 8, 3, 7, 6, 6, 3, 7,
2, 8, 1, 7, 6, 6, 1, 7, 1, 8, 1, 7, 1, 8, 2, 7, 6, 6, 2, 7,
1, 8, 1, 7, 1, 8, 1, 7, 6, 6, 1, 7, 1, 8, 2, 7, 1, 8, 2, 7,
4, 6, 2, 7, 1, 8, 2, 7, 1, 8, 1, 7, 6, 6, 5, 7, 1, 8, 2, 7,
2, 6, 2, 7, 1, 8, 5, 7, 10, 6, 2, 7, 1, 8, 1, 7, 2, 6, 1, 7,
1, 8, 2, 7, 15, 6, 3, 7, 2, 6, 3, 7, 64, 6, 3, 7, 2, 6, 3, 7,
15, 6, 2, 7, 1, 8, 1, 7, 2, 6, 1, 7, 1, 8, 2, 7, 10, 6, 5, 7,
1, 8, 2, 7, 2, 6, 2, 7, 1, 8, 5, 7, 6, 6, 1, 7, 1, 8, 2, 7,
1, 8, 2, 7, 4, 6, 2, 7, 1, 8, 2, 7, 1, 8, 1, 7, 6, 6, 1, 7,
1, 8, 1, 7, 1, 8, 2, 7, 6, 6, 2, 7, 1, 8, 1, 7, 1, 8, 1, 7,
6, 6, 1, 7, 2, 8, 3, 7, 6, 6, 3, 7, 2, 8, 1, 7, 6, 6, 1, 7,
4, 8, 1, 7, 6, 6, 1, 7, 4, 8, 1, 7, 6, 6, 6, 7, 6, 6, 6, 7,
125, 6, 3, 7, 14, 6, 3, 7, 4, 6, 1, 7, 1, 8, 2, 7, 12, 6, 2, 7,
1, 8, 1, 7, 4, 6, 2, 7, 1, 8, 5, 7, 4, 6, 5, 7, 1, 8, 2, 7,
5, 6, 2, 7, 1, 8, 2, 7, 1, 8, 1, 7, 4, 6, 1, 7, 1, 8, 2, 7,
1, 8, 2, 7, 7, 6, 2, 7, 1, 8, 1, 7, 1, 8, 1, 7, 4, 6, 1, 7,
1, 8, 1, 7, 1, 8, 2, 7, 8, 6, 3, 7, 2, 8, 1, 7, 4, 6, 1, 7,
2, 8, 3, 7, 8, 6, 1, 7, 4, 8, 1, 7, 4, 6, 1, 7, 4, 8, 1, 7,
8, 6, 6, 7, 4, 6, 6, 7, 104, 6, 6, 7, 4, 6, 6, 7, 8, 6, 1, 7,
4, 8, 1, 7, 4, 6, 1, 7, 4, 8, 1, 7, 8, 6, 3, 7, 2, 8, 1, 7,
4, 6, 1, 7, 2, 8, 3, 7, 8, 6, 2, 7, 1, 8, 1, 7, 1, 8, 1, 7,
4, 6, 1, 7, 1, 8, 1, 7, 1, 8, 2, 7, 7, 6, 2, 7, 1, 8, 2, 7,
1, 8, 1, 7, 4, 6, 1, 7, 1, 8, 2, 7, 1, 8, 2, 7, 5, 6, 2, 7,
1, 8, 5, 7, 4, 6, 5, 7, 1, 8, 2, 7, 4, 6, 1, 7, 1, 8, 2, 7,
12, 6, 2, 7, 1, 8, 1, 7, 4, 6, 3, 7, 14, 6, 3, 7, 50, 6,
		),
# Color table (including frequency of occurrence)
		(
		(112, 112, 112, 127) ,		# 408
		(170, 170, 170, 127) ,		# 84
		(48, 48, 48, 127) ,		# 84
		(112, 112, 112, 255) ,		# 408
		(170, 170, 170, 255) ,		# 84
		(48, 48, 48, 255) ,		# 84
		(0, 0, 0, 0) ,		# 784
		(0, 0, 0, 255) ,		# 272
		(255, 255, 255, 255) ,		# 96
		),
	)
try:
	a = ss_fullscreen_button
except:
# You can override this by providing a local
# alternative button in your assets area.
	ss_fullscreen_button = shapestrip(
			getshap_fullscreen_button_tga.get_surface(32), 24)

##################################################################
class	Canvas:
	def	set_fullscreen_toggle_visible(self, visible):
		self.fullscreen_toggle_visible = visible
		self.fullscreen_toggle_pos = None
		self.fullscreen_toggle_size = 24
		return

	def	__init__(self):
		# we'll duck-type everything else we need in here
		self.set_fullscreen_toggle_visible(1)
		self.kurtles = None
		self.ht = None			# hiscore table
		self.statistics = None
		self.joyfig = None		# joystick_configuration
		self.game_title = "Game Title"		# override please!
		return

	def	toggle_fullscreen(self):
		global scrnflags
		global screen, pygame_library_screen, pygame_library_screen_original
		hold_backing_store = screen.copy()
		if not (scrnflags & pygame.FULLSCREEN):
			scrnflags |= pygame.FULLSCREEN
			screen = pygame.display.set_mode(screen_size,scrnflags)
			pygame.mouse.set_visible(False)
		else:
			scrnflags &= ~pygame.FULLSCREEN
			pygame.mouse.set_visible(True)
			screen = pygame.display.set_mode(screen_size,scrnflags)
		screen.blit( hold_backing_store, (0,0))
		pygame_library_screen = screen
		pygame_library_screen_original = screen
		return

	def	handle_fullscreen_toggle_button(self,render=0):
		if self.fullscreen_toggle_visible:
			if self.fullscreen_toggle_pos == None:
				# default fullscreen toggle button location
				pos = (pygame_library_screen.get_width() - 28, 4,)
			else:
				pos = self.fullscreen_toggle_pos
			# This uses the embedded graphic.
			s = getshap_fullscreen_button_tga.get_surface(32)
			r = pygame.Rect( pos[0], pos[1],
					s.get_width(), s.get_width())	# intentional width/width!
			hovering = r.collidepoint( INPUT.mousecursor_x, INPUT.mousecursor_y)
			pos = (	pos[0] + 12, pos[1] + 12)
			if render:
				ss_fullscreen_button.plot( pos, hovering)
				spriteno = 2
				if scrnflags & pygame.FULLSCREEN:
					spriteno = 3
				ss_fullscreen_button.plot( pos, spriteno)
			else:
				if hovering:
					if INPUT.mousebuttons[0]:
						if not INPUT.prevmousebuttons[0]:
							self.toggle_fullscreen()
							INPUT.flush()
		return

CANVAS = Canvas()

##################################################################
CANVAS.previous = []
CANVAS.current = 0
CANVAS.timer = 0
CANVAS.takearg = 0
CANVAS.set_new_lockout = 0
CANVAS.requested_fps = 30
CANVAS.debounced = 0			# see mainloop.h for debounce value

##################################################################
def canvas_set_current( newcanvas, jam_in_previous_canvas=None):

	if CANVAS.set_new_lockout:
		return

	CANVAS.set_new_lockout = 1

	if newcanvas == -1:
		if len( CANVAS.previous) == 0:
			sys.exit()
		# pop previous canvas off the .CANVAS.previous stack
		newcanvas = CANVAS.previous[-1]
		CANVAS.previous = CANVAS.previous[:-1]
	elif newcanvas:
		if jam_in_previous_canvas:
			if len(CANVAS.previous):
				CANVAS.previous[-1] = jam_in_previous_canvas
			else:
				CANVAS.previous.append( jam_in_previous_canvas)
		else:
			CANVAS.previous.append( CANVAS.current)
		# keep canvas history from growing unbounded
		if len( CANVAS.previous) > 10:
			CANVAS.previous = CANVAS.previous[-10:]
	else:
		CANVAS.current = 0

	if CANVAS.takearg:
		if CANVAS.current:
			CANVAS.current( CANVASOP_TRANSITION_OUT)

	CANVAS.timer = 0
	CANVAS.takearg = 0
	CANVAS.current = newcanvas

	# uncomment this line for debugging when you have
	# some unhandled exception in the canvas transition-in
	# CANVAS.current( CANVASOP_TRANSITION_IN)

	try:
		CANVAS.current( CANVASOP_TRANSITION_IN)
		CANVAS.takearg = 1
	except TypeError:
		pass

	CANVAS.set_new_lockout = 0

	CANVAS.debounced = 0

	return

##################################################################
scrx = screen.get_width()
scry = screen.get_height()

screen_size = (scrx,scry)

##################################################################
def waitclock():
	if CANVAS.kurtles:
		CANVAS.kurtles.paint()
	CANVAS.handle_fullscreen_toggle_button(1)	# render
	CANVAS.timer += 1
	INPUT.call_mousecursor_function()
	pygame.display.update()
	clock.tick(CANVAS.requested_fps)
	INPUT.process_input_event_queue()
	CANVAS.handle_fullscreen_toggle_button()	# check for click
	return

##################################################################
def getch():
	while 1:
		waitclock()
		for u in INPUT.unicodeses:
			return u


##################################################################
BUTTONSTATUS_NORMAL  = 0
BUTTONSTATUS_HOVER   = 1		# aka focus
BUTTONSTATUS_PRESS   = 2
BUTTONSTATUS_MAXIMUM = 3

class	textbutton:
	def	__init__(self,
					text = None,
					size = None,
					hotchar = None,		# comes out of INPUT.unicodeses
					hotkey = None,		# comes out of INPUT.keypresses
					function = None,	# function to call
					canvas = None):		# canvas to set
		if text == None:
			text = "Button"
		if size == None:
			size = (scrx / 2 - 32, VGAPRN.currsize * 2)
		self.x = 0
		self.y = 0
		self.w = size[0]
		self.h = size[1]
		self.settext( text)
		self.hotchar = hotchar
		self.hotkey = hotkey
		self.function = function
		self.canvas = canvas
		return

	def	settext(self,text,hotchar = None):
		colors = (
			( ( 50, 50, 50), (255,255,255), (255,0,0)),
			( (150,150,150), (255,255,255), (255,0,0)),
			( (200,200,200), ( 55, 55, 55), (255,0,0)),
		)
		#/ create background graphics for normal, hover/focus and clicked
		self.bitmaps = []
		for status in xrange( BUTTONSTATUS_MAXIMUM):
			bg = pygame.Surface( (self.w,self.h), pygame.SRCALPHA)
			#/ <WIP> support 3x3 graphics inserts (threeby!)
			bg.fill( colors[status][0])
			self.bitmaps.append(bg)
			pygame_set_library_screen( bg)
			VGAPRN.color1 = colors[status][1]
			VGAPRN.justify = JUSTIFY_CENTER
			#/ stamp text on top
			VGAPRN.printf( (self.w / 2, VGAPRN.currsize / 2), text)
			#/ highlight the hotchar (color2)
			#/ (Not sure I can get this to work; subsequent text draws are not always pixel-perfect.)
			if hotchar:
				n = text.find( hotchar)
				if n >= 0:
					VGAPRN.justify = JUSTIFY_LEFT
					if n > 0:
						VGAPRN.printf( VGAPRN.lastrect, text[:n])
					else:
						VGAPRN.lastrect = pygame.Rect( VGAPRN.lastrect[0], VGAPRN.lastrect[1], 0,0)
					VGAPRN.color1 = colors[status][2]
					VGAPRN.printf( None, text[n:n+1])
			pygame_set_library_screen(-1)
		self.status = BUTTONSTATUS_NORMAL
		self.calcrect()
		return

	def	calcrect(self):
		self.r = pygame.Rect( self.x, self.y, self.w, self.h)
		return

	def	gotoxy(self,(x,y)):
		self.x = x
		self.y = y
		self.calcrect()
		return

	def	think(self):
		self.status = BUTTONSTATUS_NORMAL
		if INPUT.mousecursor_test_rect(self.r):
			self.status = BUTTONSTATUS_HOVER
		return

	def	paint(self):
		pygame_library_screen.blit( self.bitmaps[self.status], self.r)
		return


##################################################################
# Here is where canvas_pause goes if you agree to quit:
# This is a canvas function (given priority)
CANVAS.pause_quits_to = None
# This is just a function to call (such as rtns_gameover)
CANVAS.pause_quitfunc = None

##################################################################
def	canvas_pause():
	screen.fill( (60,60,60))

	sounds_silence_all()

	VGAPRN.zerowrite = 0
	VGAPRN.color1 = (255, 255, 0)
	VGAPRN.justify = JUSTIFY_CENTER

	VGAPRN.setsize(60)
	nn = 12		# cheesy line spacing onscreen
	VGAPRN.printf( (screen_size[0] / 2, 1 * screen_size[1] / nn),
					"Game Paused")
	VGAPRN.setsize(30)
	try:
		tmp = "Current Score: %u" % STATE.score
		VGAPRN.printf( (screen_size[0] / 2, 4 * screen_size[1] / nn),tmp)
	except AttributeError:		# handles STATE.score not existing
		pass
	except TypeError:			# handles STATE.score being invalid for %u printing
		pass
	except NameError:			# handles STATE not existing
		pass
	if CANVAS.debounced:
		nnn = nn - 3
		VGAPRN.printf( (screen_size[0] / 2, nnn * screen_size[1] / nn),
						"Press Q to quit current game")
		if CANVAS.kurtles:
			nnn -= 1
			VGAPRN.printf( (screen_size[0] / 2, nnn * screen_size[1] / nn),
						"Press K for Kurtles")
		if CANVAS.ht:
			nnn -= 1
			VGAPRN.printf( (screen_size[0] / 2, nnn * screen_size[1] / nn),
						"Press H for High Scores")
		if CANVAS.statistics:
			nnn -= 1
			VGAPRN.printf( (screen_size[0] / 2, nnn * screen_size[1] / nn),
						"Press S for Statistics")
		if CANVAS.joyfig:
			nnn -= 1
			VGAPRN.printf( (screen_size[0] / 2, nnn * screen_size[1] / nn),
						"Press J for Joystick Configuration")
		VGAPRN.printf( (screen_size[0] / 2, (nn - 2) * screen_size[1] / nn),
						"Press ESC/ENTER to continue game")

	if CANVAS.debounced:
		for u in INPUT.unicodeses:
			if u.lower() == 'q':
				if CANVAS.pause_quits_to:
					canvas_set_current( CANVAS.pause_quits_to)
				elif CANVAS.pause_quitfunc:
					CANVAS.pause_quitfunc()
				else:
					canvas_set_current( canvas_greet)
				return
			if CANVAS.ht and (u.lower() == 'h'):
				canvas_set_current( canvas_hiscores)
				return
			if CANVAS.kurtles and (u.lower() == 'k'):
				canvas_set_current( canvas_kurtles)
				return
			if CANVAS.joyfig and (u.lower() == 'j'):
				canvas_set_current( CANVAS.joyfig)
				return
			if u in (chr(27), chr(13), chr(10),):
				canvas_set_current( -1)
				return

	joystick_greet_paint()

	return

##################################################################
# This has knowledge about displaying hiscores.h data!

##################################################################

##################################################################
#
# 7:01 AM 4/10/2012
# High score module - hiscores

##################################################################

##################################################################
# Unit tests are found in junk\testdataline.c

##################################################################
def	dataline_import(oneline):
	datadict = dict()
	elements = oneline.split( ",")
	# This is really hacky: we rejoin elements that lack an
	# equals sign on the basis that they were mis-split.
	# What we really need is a quotes-aware line-splitter
	elements2 = []
	for e in elements:
		x = e.find( "=")
		if x >= 0:
			elements2.append(e)
		else:
			if len(elements2):
				elements2[-1] = elements2[-1] + "," + e
			else:
				elements2.append(e)
	for e in elements2:
		x = e.find( "=")
		if x >= 0:
			thekey = e[:x]
			thedata = e[x+1:]
			datadict[thekey] = thedata[1:-1]
			if thedata[0] == '\"':
				pass
			try:
				datadict[thekey] = int(thedata)
			except:
				try:
					datadict[thekey] = float(thedata)
				except:
					pass
	return datadict

##################################################################
def	dataline_export(datadict):
	oneline = ""
	for thekey in sorted(datadict):
		thedata = datadict[thekey]
		if isinstance(thedata, int):
			oneblob = "%s=%d" % (thekey,thedata)
		elif isinstance(thedata, float):
			oneblob = "%s=%f" % (thekey,thedata)
		else:
			oneblob = "%s=\"%s\"" % (thekey,thedata)
		if len(oneline):
			oneline += ","
		oneline += oneblob
	return oneline


##################################################################
class	HISC_ENTRY:
	def	__init__(self,score=0,name=None,extra=None,wave=None,percent=None):
		self.score = score

		if name == None:
			name = "Anonymous"
		self.name = name

		if extra == None:
			extra = ""
		self.extra = extra

		if wave == None:
			wave = 0
		self.wave = wave

		if percent == None:
			percent = 0
		self.percent = percent

		self.datetime = time.time()
		return

	def	__repr__(self):
		return dataline_export(self.__dict__)

##################################################################
class	HISC_TABLE:
	def	__init__(self,fn=None):
		if fn == None:
			fn = "hiscores.txt"
		self.fn = fn
		self.hiscores = []
		self.minranking = 15		# you must score above this to enter your name
		self.display_datetime = 0
		self.display_extra = 1
		fp = None
		try:
			fp = open( self.fn, "rt")
			for oneline in fp.readlines():
				he = HISC_ENTRY()
				d = dataline_import(oneline)
				# inject the loaded dictionary into the new hisc entry
				for k in d:
					he.__dict__[k] = d[k]
				self.hiscores.append(he)
			fp.close()
			print "Read %u high scores out of '%s'" % (len(self.hiscores), self.fn)
		except IOError:
			print "Unable to open file '%s' to READ high scores." % self.fn
		self.sort()

		self.lastname = "High scorer"
		# <WIP> be clever and search up USERNAME or USER environment variables for a name?
		# <WIP> be clever and extract the last-entered name and fill it into .lastname
		self.lastname = ""	# for now leave it blank, until above <WIP>s are done!

		return
	def	sort(self):
		def	sortfunc(he1,he2):
			if he1.score != he2.score:
				return he2.score - he1.score
			if he1.datetime < he2.datetime:
				return -1
			else:
				return 1
		self.hiscores = sorted( self.hiscores, cmp = sortfunc)
		return
	def	add_entry(self,he):
		if he.score <= 0:
			return
		self.lastname = he.name
		try:
			fp = open( self.fn, "at")
			print >> fp, he
			fp.close()
		except IOError:
			print "Unable to add to high score file on disk."
		# even if we cannot commit to disk, add it to our table!
		self.hiscores.append(he)
		self.sort()
		return
	def	__repr__(self):
		if len(self.hiscores):
			s = "High score table, %u entries." % len(self.hiscores)
			for he in self.hiscores:
				s = s + "\n%10u - %s" % (he.score, he.name)
		else:
			s = "Empty high score table"
		return s


##################################################################
# 8:07 AM 11/20/2011 - trying to nail this down so I don't have to keep rewriting it!

import time

##################################################################
def	time_fix_when(when):
	if when == None:
		when = time.time()
	when = time.localtime(when)
	return when

##################################################################
def	time_date_readable(when=None):
	when = time_fix_when(when)
	s = "%02u/%02u/%04u" % (when[1], when[2], when[0])
	return s

##################################################################
def	time_time_readable(when=None):
	when = time_fix_when(when)
	s = "%02u:%02u:%02u" % (when[3], when[4], when[5])
	return s

##################################################################
def	time_datetime_readable(when=None):
	return time_date_readable(when) + "-" + time_time_readable(when)

##################################################################
def	time_date_filename(when=None):
	when = time_fix_when(when)
	s = "%04u%02u%02u" % (when[0], when[1], when[2])
	return s

##################################################################
def	time_time_filename(when=None):
	when = time_fix_when(when)
	s = "%02u%02u" % (when[3], when[4])
	return s

##################################################################
def	time_datetime_filename(when=None):
	return time_date_filename(when) + "_" + time_time_filename(when)

##################################################################
def	hiscores_add_score_simple(table,score,extra=None,wave=None,percent=None):
	sounds_silence_all()

	if score <= 0:
		return
	name = "..."
	# you have to score in the top ten people to get your name in
	# otherwise we simply record you, but don't ask the name.
	if ((len(table.hiscores) < table.minranking) or
		(score > table.hiscores[table.minranking - 1].score)):
		pygame_library_screen.fill((0,0,0))
		VGAPRN.justify = JUSTIFY_LEFT
		message_setcolor_good()
		s = [
			"You have earned a high score!",
			"Your score is %u" % score,
			"Please enter your name.",
		]
		g = GETS()
		g.value = CANVAS.ht.lastname
		message_simple_gets( s, g)
		name = g.value
		if name == "":
			name = "..."
	# make and add the entry...
	he = HISC_ENTRY( score = score,
				name = name,
				extra = extra,
				wave = wave,
				percent = percent)
	table.add_entry(he)
	return

##################################################################
def	canvas_hiscores():
	sounds_silence_all()

	ht = CANVAS.ht

	pygame_library_screen.fill( (30,30,30))

	VGAPRN.zerowrite = 0
	VGAPRN.color1 = (200,200,200)
	VGAPRN.justify = JUSTIFY_CENTER

	VGAPRN.setsize(30)
	nn = 15		# cheesy line spacing onscreen
	VGAPRN.printf( (screen_size[0] / 2, 0 * screen_size[1] / nn),
					"%s" % CANVAS.game_title)
	VGAPRN.printf( (screen_size[0] / 2, 1 * screen_size[1] / nn),
					"High Scores")

	if CANVAS.debounced:
		VGAPRN.printf( (screen_size[0] / 2, (nn - 1) * screen_size[1] / nn),
						"Press ESC to continue")
		VGAPRN.setsize(16)
		VGAPRN.justify = JUSTIFY_LEFT
		x =  5
		y = scry - 20
		VGAPRN.printf( (x, y), "D/T - Date/Time")
		y -= 20
		VGAPRN.printf( (x, y), "X - Extra info")

	w = 0
	VGAPRN.setsize(20)
	numwidth = VGAPRN.getwidth("00000000")
	y = 2 * screen_size[1] / nn
	for i in xrange( len( ht.hiscores)):
		he = ht.hiscores[i]

		# line-oriented banding
		if i & 1:
			c = (45,45,45)
		else:
			c = (20,20,20)
		pygame.draw.rect( pygame_library_screen,
				c, (0,y+2,scrx,20))

		VGAPRN.color1 = (222,222,222)
		VGAPRN.justify = JUSTIFY_LEFT
		VGAPRN.printf( (20, y), "%u." % (i + 1))

		if i & 1:
			VGAPRN.color1 = (200,200,100)
		else:
			VGAPRN.color1 = (200,200,150)
		VGAPRN.justify = JUSTIFY_RIGHT
		x = 50 + numwidth
		VGAPRN.printf( (x, y), "%u" % he.score)

		if i & 1:
			VGAPRN.color1 = (150,200,100)
		else:
			VGAPRN.color1 = (150,200,150)
		VGAPRN.justify = JUSTIFY_LEFT
		x += 20
		VGAPRN.printf( (x, y), "%s" % he.name)

		#/ display date/time, or else extra information
		x = scrx - 20
		VGAPRN.justify = JUSTIFY_RIGHT
		if ht.display_datetime:
			if ht.display_datetime == 3:
				VGAPRN.printf( (x, y), "%s" % time_datetime_readable(he.datetime))
			elif ht.display_datetime == 1:
				VGAPRN.printf( (x, y), "%s" % time_date_readable(he.datetime))
			elif ht.display_datetime == 2:
				VGAPRN.printf( (x, y), "%s" % time_time_readable(he.datetime))
		else:
			if ht.display_extra:
				VGAPRN.printf( (x, y), "%s" % he.extra)

		y += 20
		if y >= (nn - 2) * screen_size[1] / nn:
			break

	if CANVAS.debounced:
		for u in INPUT.unicodeses:
			if u in (chr(27),):
				canvas_set_current( -1)
				return
			if u in ('d', 'D',):
				ht.display_datetime = ht.display_datetime ^ 1
			if u in ('t', 'T',):
				ht.display_datetime = ht.display_datetime ^ 2
			if u in ('x', 'X',):
				ht.display_extra = not ht.display_extra
				if ht.display_extra:
					ht.display_datetime = 0

	return

##################################################################
# This has knowledge about displaying kurtles.h data!

##################################################################

##################################################################
# This is part of Kurt Dekker's common python library codebase.
#

##################################################################
# 6:10 PM 1/10/2012 - # A new take on KURTLES
#
import pickle


##################################################################

# image2py.py created from 'kurtles_locked.tga'

getshap_kurtles_locked_tga = GETSHAP(
	GSFORMAT_IMAGE2PY_RLE,
	(0,0),			# hotspots
	(32,32),		# dimensions
		(
67, 0, 1, 1, 1, 2, 5, 3, 1, 2, 1, 1, 3, 0, 1, 4, 1, 5, 5, 3,
1, 6, 1, 7, 11, 0, 1, 2, 1, 8, 5, 9, 1, 8, 1, 2, 2, 0, 1, 10,
1, 11, 1, 12, 5, 9, 1, 12, 1, 13, 1, 14, 10, 0, 1, 3, 1, 9, 1, 15,
4, 16, 1, 15, 1, 3, 1, 0, 1, 17, 1, 11, 1, 9, 1, 18, 1, 19, 4, 16,
1, 20, 1, 21, 1, 14, 10, 0, 1, 3, 1, 9, 1, 16, 4, 22, 1, 16, 1, 23,
1, 17, 1, 11, 1, 9, 1, 18, 1, 24, 4, 22, 1, 25, 1, 26, 1, 27, 11, 0,
1, 3, 1, 9, 1, 16, 4, 22, 1, 16, 1, 28, 1, 29, 1, 9, 1, 18, 1, 24,
4, 22, 1, 25, 1, 26, 1, 30, 1, 14, 11, 0, 1, 3, 1, 9, 1, 16, 4, 22,
1, 16, 1, 31, 1, 9, 1, 18, 1, 32, 4, 22, 1, 25, 1, 33, 1, 30, 1, 14,
12, 0, 1, 3, 1, 9, 1, 16, 4, 22, 1, 16, 2, 18, 1, 32, 4, 22, 1, 34,
1, 35, 1, 36, 1, 14, 13, 0, 1, 3, 1, 9, 1, 16, 4, 22, 1, 16, 1, 18,
1, 37, 4, 22, 1, 34, 1, 35, 1, 38, 1, 39, 14, 0, 1, 3, 1, 9, 1, 16,
4, 22, 1, 16, 1, 37, 4, 22, 1, 40, 1, 35, 1, 38, 1, 39, 15, 0, 1, 3,
1, 9, 1, 16, 4, 22, 1, 41, 4, 22, 1, 40, 1, 42, 1, 43, 1, 39, 16, 0,
1, 3, 1, 9, 1, 16, 8, 22, 1, 44, 1, 45, 1, 46, 1, 39, 17, 0, 1, 3,
1, 9, 1, 16, 8, 22, 1, 47, 1, 48, 1, 46, 1, 39, 17, 0, 1, 3, 1, 9,
1, 16, 8, 22, 1, 44, 1, 49, 1, 50, 1, 38, 1, 39, 16, 0, 1, 3, 1, 9,
1, 16, 9, 22, 1, 40, 1, 49, 1, 50, 1, 38, 1, 14, 15, 0, 1, 3, 1, 9,
1, 16, 4, 22, 1, 51, 1, 40, 4, 22, 1, 40, 1, 52, 1, 50, 1, 36, 1, 14,
14, 0, 1, 3, 1, 9, 1, 16, 4, 22, 1, 16, 1, 49, 1, 40, 4, 22, 1, 40,
1, 52, 1, 50, 1, 36, 1, 14, 13, 0, 1, 3, 1, 9, 1, 16, 4, 22, 1, 16,
1, 18, 1, 49, 1, 44, 4, 22, 1, 34, 1, 52, 1, 50, 1, 36, 1, 53, 2, 1,
1, 14, 9, 0, 1, 3, 1, 9, 1, 16, 4, 22, 1, 16, 1, 54, 1, 55, 1, 56,
1, 44, 4, 22, 1, 34, 1, 57, 1, 48, 1, 58, 2, 59, 1, 60, 1, 1, 8, 0,
1, 3, 1, 9, 1, 16, 4, 22, 1, 16, 1, 61, 1, 5, 1, 62, 1, 56, 1, 63,
3, 22, 1, 64, 1, 65, 1, 66, 3, 67, 1, 68, 1, 60, 1, 14, 7, 0, 1, 3,
1, 9, 1, 16, 4, 22, 1, 16, 1, 3, 1, 39, 1, 5, 1, 55, 1, 69, 1, 63,
2, 22, 1, 70, 1, 71, 1, 67, 1, 66, 1, 12, 1, 72, 1, 67, 1, 73, 1, 1,
7, 0, 1, 3, 1, 9, 1, 16, 4, 22, 1, 16, 1, 3, 1, 0, 1, 39, 1, 74,
1, 55, 1, 69, 1, 63, 1, 22, 1, 70, 1, 71, 1, 67, 1, 75, 1, 76, 1, 55,
1, 67, 1, 73, 1, 1, 7, 0, 1, 2, 1, 8, 1, 15, 4, 16, 1, 77, 1, 78,
2, 0, 1, 39, 1, 79, 1, 55, 1, 80, 1, 16, 1, 81, 1, 82, 1, 67, 1, 83,
1, 84, 1, 85, 1, 67, 1, 86, 1, 87, 7, 0, 1, 1, 1, 78, 5, 3, 1, 78,
1, 1, 3, 0, 1, 39, 1, 88, 2, 3, 1, 89, 1, 90, 1, 67, 3, 91, 1, 67,
1, 90, 1, 2, 23, 0, 1, 3, 1, 91, 5, 67, 1, 91, 1, 3, 23, 0, 1, 3,
1, 91, 5, 67, 1, 91, 1, 3, 23, 0, 1, 3, 1, 91, 5, 67, 1, 91, 1, 3,
23, 0, 1, 3, 1, 91, 5, 67, 1, 91, 1, 3, 23, 0, 1, 3, 1, 91, 5, 67,
1, 91, 1, 3, 23, 0, 1, 2, 1, 92, 5, 91, 1, 90, 1, 78, 23, 0, 1, 1,
1, 78, 5, 3, 1, 78, 1, 1, 4, 0,
		),
# Color table (including frequency of occurrence)
		(
		(0, 0, 0, 0) ,		# 504
		(0, 0, 0, 4) ,		# 11
		(0, 0, 0, 80) ,		# 7
		(0, 0, 0, 92) ,		# 54
		(0, 0, 0, 22) ,		# 1
		(0, 0, 0, 87) ,		# 3
		(0, 0, 0, 86) ,		# 1
		(0, 0, 0, 17) ,		# 1
		(0, 0, 0, 250) ,		# 3
		(0, 0, 0, 254) ,		# 33
		(0, 0, 0, 25) ,		# 1
		(0, 0, 0, 184) ,		# 3
		(0, 0, 0, 252) ,		# 3
		(0, 0, 0, 128) ,		# 1
		(0, 0, 0, 1) ,		# 10
		(9, 41, 44, 255) ,		# 3
		(18, 83, 89, 255) ,		# 43
		(0, 0, 0, 24) ,		# 2
		(0, 0, 0, 255) ,		# 8
		(15, 68, 73, 255) ,		# 1
		(13, 62, 67, 255) ,		# 1
		(0, 0, 0, 140) ,		# 1
		(37, 167, 179, 255) ,		# 139
		(0, 0, 0, 93) ,		# 1
		(21, 95, 102, 255) ,		# 2
		(32, 146, 157, 255) ,		# 3
		(4, 22, 24, 238) ,		# 2
		(0, 0, 0, 76) ,		# 1
		(0, 0, 0, 142) ,		# 1
		(0, 0, 0, 183) ,		# 1
		(0, 0, 0, 82) ,		# 2
		(0, 0, 0, 248) ,		# 1
		(21, 94, 101, 255) ,		# 2
		(5, 23, 24, 238) ,		# 1
		(32, 147, 157, 255) ,		# 4
		(5, 23, 25, 239) ,		# 3
		(0, 0, 0, 83) ,		# 4
		(20, 94, 101, 255) ,		# 2
		(0, 0, 0, 84) ,		# 4
		(0, 0, 0, 2) ,		# 10
		(32, 148, 158, 255) ,		# 7
		(33, 151, 162, 255) ,		# 1
		(5, 24, 26, 239) ,		# 1
		(0, 0, 0, 85) ,		# 1
		(32, 148, 159, 255) ,		# 4
		(5, 23, 25, 247) ,		# 1
		(0, 0, 0, 91) ,		# 2
		(10, 47, 50, 255) ,		# 1
		(0, 0, 0, 246) ,		# 2
		(5, 22, 24, 255) ,		# 4
		(0, 0, 0, 236) ,		# 5
		(23, 106, 113, 255) ,		# 1
		(4, 22, 23, 255) ,		# 3
		(0, 0, 0, 5) ,		# 1
		(0, 0, 0, 204) ,		# 1
		(0, 0, 0, 238) ,		# 5
		(5, 23, 25, 255) ,		# 2
		(3, 20, 22, 255) ,		# 1
		(0, 0, 0, 227) ,		# 1
		(0, 0, 0, 214) ,		# 2
		(0, 0, 0, 133) ,		# 2
		(0, 0, 0, 100) ,		# 1
		(0, 0, 0, 237) ,		# 1
		(33, 149, 160, 255) ,		# 3
		(36, 166, 178, 255) ,		# 1
		(15, 70, 75, 255) ,		# 1
		(64, 64, 64, 255) ,		# 2
		(255, 255, 255, 255) ,		# 36
		(64, 64, 64, 252) ,		# 1
		(5, 24, 25, 255) ,		# 2
		(36, 164, 176, 255) ,		# 2
		(5, 26, 28, 255) ,		# 2
		(64, 64, 64, 254) ,		# 1
		(0, 0, 0, 216) ,		# 2
		(0, 0, 0, 88) ,		# 1
		(4, 20, 21, 255) ,		# 1
		(3, 18, 20, 255) ,		# 1
		(9, 42, 45, 253) ,		# 1
		(0, 0, 0, 81) ,		# 6
		(0, 0, 0, 89) ,		# 1
		(5, 24, 26, 255) ,		# 1
		(17, 81, 86, 255) ,		# 1
		(2, 12, 12, 255) ,		# 1
		(1, 6, 6, 255) ,		# 1
		(7, 36, 39, 254) ,		# 1
		(0, 0, 0, 245) ,		# 1
		(0, 0, 0, 220) ,		# 1
		(0, 0, 0, 7) ,		# 1
		(0, 0, 0, 59) ,		# 1
		(0, 0, 0, 143) ,		# 1
		(64, 64, 64, 253) ,		# 3
		(128, 128, 128, 255) ,		# 18
		(65, 65, 65, 251) ,		# 1
		),
	)

# image2py.py created from 'kurtles_background.tga'

getshap_kurtles_background_tga = GETSHAP(
	GSFORMAT_IMAGE2PY_RLE,
	(0,0),			# hotspots
	(300,40),		# dimensions
		(
6, 0, 288, 1, 9, 0, 3, 1, 288, 2, 3, 1, 5, 0, 1, 1, 37, 2, 2, 1,
255, 2, 1, 1, 3, 0, 1, 1, 38, 2, 2, 1, 256, 2, 1, 1, 2, 0, 1, 1,
38, 2, 2, 1, 256, 2, 1, 1, 1, 0, 1, 1, 39, 2, 2, 1, 257, 2, 2, 1,
39, 2, 2, 1, 257, 2, 2, 1, 39, 2, 2, 1, 257, 2, 2, 1, 39, 2, 2, 1,
257, 2, 2, 1, 39, 2, 2, 1, 257, 2, 2, 1, 39, 2, 2, 1, 257, 2, 2, 1,
39, 2, 2, 1, 257, 2, 2, 1, 39, 2, 2, 1, 257, 2, 2, 1, 39, 2, 2, 1,
257, 2, 2, 1, 39, 2, 2, 1, 257, 2, 2, 1, 39, 2, 2, 1, 257, 2, 2, 1,
39, 2, 2, 1, 257, 2, 2, 1, 39, 2, 2, 1, 257, 2, 2, 1, 39, 2, 2, 1,
257, 2, 2, 1, 39, 2, 2, 1, 257, 2, 2, 1, 39, 2, 2, 1, 257, 2, 2, 1,
39, 2, 2, 1, 257, 2, 2, 1, 39, 2, 2, 1, 257, 2, 2, 1, 39, 2, 2, 1,
257, 2, 2, 1, 39, 2, 2, 1, 257, 2, 2, 1, 39, 2, 2, 1, 257, 2, 2, 1,
39, 2, 2, 1, 257, 2, 2, 1, 39, 2, 2, 1, 257, 2, 2, 1, 39, 2, 2, 1,
257, 2, 2, 1, 39, 2, 2, 1, 257, 2, 2, 1, 39, 2, 2, 1, 257, 2, 2, 1,
39, 2, 2, 1, 257, 2, 2, 1, 39, 2, 2, 1, 257, 2, 2, 1, 39, 2, 2, 1,
257, 2, 2, 1, 39, 2, 2, 1, 257, 2, 1, 1, 1, 0, 1, 1, 38, 2, 2, 1,
256, 2, 1, 1, 2, 0, 1, 1, 38, 2, 2, 1, 256, 2, 1, 1, 3, 0, 1, 1,
37, 2, 2, 1, 255, 2, 1, 1, 5, 0, 3, 1, 288, 2, 3, 1, 9, 0, 288, 1,
6, 0,
		),
# Color table (including frequency of occurrence)
		(
		(0, 0, 0, 0) ,		# 52
		(255, 255, 255, 255) ,		# 732
		(0, 0, 0, 255) ,		# 11216
		),
	)

##################################################################
class	Kurtle:
	def	__init__(self,title,description,points):
		self.title = title
		self.description = description
		self.points = points
		self.kurtles = None			# this will point to KURTLES for convenience sake
		self.r = pygame.Rect(0,0,0,0)
		KURTLES.add_kurtle(self)
		return

	def	unlock(self):				# a convenient mirrored function
		self.kurtles.unlock(self)
		return

	def	__repr__(self):
		return "%s (%u): %s" % (self.title, self.points, self.description)

##################################################################
class	Kurtles:
	def	__init__(self):
		self.kurtles = []
		self.unlock_filename = None
		self.graphics_icons = None
		self.graphics_icons_filename = None
		CANVAS.kurtles = self		# this makes us paint automatically
		self.unlock_position = (scrx / 2, 40)
		self.unlock_queue = []
		self.unlock_timer = 0
		return

	def	add_kurtle(self,k):
		if not self.graphics_icons :
			if self.graphics_icons_filename:
				self.graphics_icons = load_image( self.graphics_icons_filename)
			else:
				print "ERROR: must setup graphics filenames first!"
				sys.exit()
			self.graphics_locked = getshap_kurtles_locked_tga.get_surface(32)
			self.graphics_background = getshap_kurtles_background_tga.get_surface(32)
		iconsize = self.graphics_icons.get_width()
		k.kurtles = self
		k.kno = len( self.kurtles)
		self.kurtles.append(k)
		# synthesize what the actual achievement will look like
		k.image_locked = self.graphics_background.copy()
		k.image_unlocked = self.graphics_background.copy()
		k.image_splashup = self.graphics_background.copy()
		templist = (k.image_locked, k.image_unlocked, k.image_splashup)
		for i in range( len( templist)):
			tempimg = templist[i]
			VGAPRN.zerowrite = 0
			VGAPRN.justify = JUSTIFY_LEFT
			if i == 0:
				VGAPRN.color1 = (150,150,150)
			else:
				VGAPRN.color1 = (240,240,240)
			x = self.graphics_background.get_height()
			y = (self.graphics_background.get_height() - self.graphics_locked.get_height()) >> 1
			x += y
			if i == 0:
				tempimg.blit( self.graphics_locked, (y, y))
			else:
				tempimg.blit( self.graphics_icons, (y, y), (0, iconsize * k.kno, iconsize, iconsize))
			pygame_set_library_screen( tempimg)
			if iconsize == 64:
				VGAPRN.setsize( 20)
				VGAPRN.printf( (x, y), "%s (%u)" % (k.title, k.points))
				VGAPRN.setsize( 16)
				y += 24
				for t in k.description:
					VGAPRN.printf( (x, y), t)
					y += 18
			if iconsize == 32:
				if i == 2:
					#/ special simpler "KURTLE UNLOCKED!" graphic
					VGAPRN.setsize( 16)
					VGAPRN.printf( (x, y), "KURTLE UNLOCKED!")
					y += 16
					VGAPRN.printf( (x, y), "%s (%u)" % (k.title, k.points))
				else:
					VGAPRN.setsize( 16)
					VGAPRN.printf( (x, y), "%s (%u)" % (k.title, k.points))
					VGAPRN.setsize( 12)
					y += 18
					for t in k.description:
						VGAPRN.printf( (x, y), t)
						y += 12
			pygame_set_library_screen(-1)
		return

	def	finished_adding(self,unlock_filename):
		self.unlock_filename = unlock_filename
		self.unlock_array = len( self.kurtles) * [0]
		self.read()
		self.tallyup()
		return

	def	unlock(self,k):
		if not self.unlock_filename:
			print "ERROR: must call .finished_adding() first!"
			sys.exit()
		kno = k.kno		# this gets set as the Kurtle is constructed
		if kno >= 0:
			if kno < len( self.unlock_array):
				if self.unlock_array[kno]:
					return
				k = self.kurtles[kno]
				print "Unlocking '%s'" % k.title
				self.unlock_array[kno] = 1
				self.write()
				self.unlock_queue.append(k)
		self.tallyup()
		return

	def	__repr__(self):
		if not self.unlock_filename:
			print "ERROR: must call .finished_adding() first!"
			sys.exit()
		self.tallyup()
		s = "? Kurtles Set"
		s += "\n"
		for i in range( len( self.kurtles)):
			k = self.kurtles[i]
			if self.unlock_array[i]:
				s += "* "
			else:
				s += "  "
			s += k.__repr__()
			s += "\n"
		s += "Kurtles unlocked: %u/%u\n" % (self.count_unlocked, self.count_total)
		s += "Points unlocked: %u/%u" % (self.points_unlocked, self.points_total)
		return s

	def	tallyup(self):
		unlocked = 0
		total = 0
		count = 0
		for i in range( len( self.kurtles)):
			k = self.kurtles[i]
			total += k.points
			if self.unlock_array[i]:
				unlocked += k.points
				count += 1
		self.points_unlocked = unlocked
		self.points_total = total
		self.count_unlocked = count
		self.count_total = len( self.kurtles)
		return

	def	check_unlocked(self,k):
		for i in xrange( len( self.kurtles)):
			if k == self.kurtles[i]:
				return self.unlock_array[i]
		print "check_unlocked: kurtle not found!"
		return

	def	write(self):
		try:
			print "Kurtles.write():"
			fpk = open( self.unlock_filename, "wt")
			pickle.dump( self.unlock_array, fpk)
			fpk.close()
		except IOError:
			pass
		return

	def	read(self):
		ua = None
		try:
			fpk = open( self.unlock_filename, "rt")
			ua = pickle.load( fpk)
			fpk.close()
		except IOError:
			print "Kurtles.read(): no %s file found" % self.unlock_filename
			self.write()
			return
		if len(ua) == len( self.unlock_array):
			self.unlock_array = ua
		else:
			self.write()
		return

	def	paint(self):
		if len(self.unlock_queue):
			k = self.unlock_queue[0]
			self.unlock_timer += 1
			#/ some initial "hang time" before it pops
			KURTLETIMER_INITIAL_HANG_TIME = 20
			KURTLETIMER_UPSCALE_TIME = 20
			KURTLETIMER_DWELL_AT_FULL_SIZE = 240
			KURTLETIMER_DOWNSCALE_TIME = 10
			timer = self.unlock_timer
			if timer < KURTLETIMER_INITIAL_HANG_TIME:
				return
			timer = timer - KURTLETIMER_INITIAL_HANG_TIME
			if timer < KURTLETIMER_UPSCALE_TIME:
				# it scales to a bit larger than it needs
				size = (timer * 120) / KURTLETIMER_UPSCALE_TIME
			else:
				# then snaps back to normal size
				size = 100
			timer = timer - KURTLETIMER_UPSCALE_TIME
			timer = timer - KURTLETIMER_DWELL_AT_FULL_SIZE
			if (timer >= 0) and (timer <= KURTLETIMER_DOWNSCALE_TIME):
				# and now shrinks down to nothing and vanishes
				size = ((KURTLETIMER_DOWNSCALE_TIME - timer) * 100) / KURTLETIMER_DOWNSCALE_TIME
			w = (k.image_splashup.get_width()  * size) / 100
			h = (k.image_splashup.get_height() * size) / 100
			s = pygame.transform.scale( k.image_splashup, (w, h))
			plot( self.unlock_position, s)
			if timer >= KURTLETIMER_DOWNSCALE_TIME:
				self.unlock_queue = self.unlock_queue[1:]
				self.unlock_timer = 0
				return
		return

##################################################################
KURTLES = Kurtles()

##################################################################
canvas_kurtles_help_text = """
Help for Kurtles (Achievements)

Kurtles are special goals or achievements that you can
unlock by playing this game.

Once you have unlocked a Kurtle, it will appear on this
page and its score value will be tallied at the top.

Once you have unlocked a Kurtle, it cannot be earned
again.
"""

##################################################################
def	canvas_kurtles():
	sounds_silence_all()

	pygame_library_screen.fill( (30,30,30))

	VGAPRN.zerowrite = 0
	VGAPRN.color1 = (200,200,200)
	VGAPRN.justify = JUSTIFY_CENTER

	VGAPRN.setsize(30)
	nn = 15		# cheesy line spacing onscreen
	VGAPRN.printf( (screen_size[0] / 2, 0 * screen_size[1] / nn),
					"%s" % CANVAS.game_title)
	VGAPRN.printf( (screen_size[0] / 2, 1 * screen_size[1] / nn),
					"Kurtles (Achievements)")
	if CANVAS.kurtles.count_unlocked:
		s = "%u of %u unlocked (%u of %u points)" % (
				CANVAS.kurtles.count_unlocked,  CANVAS.kurtles.count_total,
				CANVAS.kurtles.points_unlocked, CANVAS.kurtles.points_total,
		)
	else:
		s = "No Kurtles Unlocked (%u worth %u points)" % (
			CANVAS.kurtles.count_total,
			CANVAS.kurtles.points_total,
		)   
	VGAPRN.setsize(25)
	VGAPRN.printf( (screen_size[0] / 2, 2 * screen_size[1] / nn), s)

	# <WIP> put in summary of kurtles, how much you unlocked, and percentage

	if CANVAS.debounced:
		VGAPRN.printf( (screen_size[0] / 2, (nn - 1) * screen_size[1] / nn),
						"Press ESC to continue")
		VGAPRN.setsize(20)
		VGAPRN.justify = JUSTIFY_RIGHT
		VGAPRN.printf( (scrx - 5, scry - 25), "F1 - Help")

	yy = (4 * screen_size[1]) / nn
	numkurtles = len( CANVAS.kurtles.kurtles)
	kurtlespercolumn = 6
	for i in xrange( numkurtles):
		k = CANVAS.kurtles.kurtles[i]
		# <WIP> this needs to be more soft-flowed based on icon sizes!
		x = 10 + (i / kurtlespercolumn) * 320
		y = yy + 50 * (i % kurtlespercolumn)
		s = k.image_locked
		if CANVAS.kurtles.unlock_array[i]:
			s = k.image_unlocked
		pygame_library_screen.blit( s, (x, y))
		k.r = pygame.Rect( x, y, s.get_width(), s.get_height())

	if CANVAS.debounced:
		for u in INPUT.unicodeses:
			if u in (chr(27), chr(13), chr(10)):
				canvas_set_current( -1)
				return
		for k in INPUT.keypresses:
			if k in (K_F1,):
				message_setcolor_info(25)
				message_simple_text_array( canvas_kurtles_help_text.split("\n"))

	return

##################################################################
class	statistics:
	def	__init__(self):
		self.tally_total = [0] * STATTYPE_MAXIMUM
		self.tally_game = [0] * STATTYPE_MAXIMUM
		self.dirty = 1
		return

	def	tallyup( self, statcode, amount = 1):
		self.dirty = 1
		previous_total = self.tally_total[statcode]
		self.tally_total[statcode] += amount

		previous_game = self.tally_game[statcode]
		self.tally_game[statcode] += amount

		# <WIP> put a sally window achievement progress indicator here (every 5 for instance)

		# <WIP> put our achievement recognizer routines here

		return

	def	getgamevalue( self, statcode):
		return self.tally_game[statcode]

	def	resetgamevalues(self):
		for i in range( STATTYPE_MAXIMUM):
			self.tally_game[i] = 0
		return

##################################################################
import pickle

##################################################################
def	statistics_initonce():
	global STATISTICS
	STATISTICS = statistics()
	try:
		STATISTICS = pickle.load( open( statistics_savefile, "rt"))
	except IOError:
		pass
	STATISTICS.dirty = 0
	return

##################################################################
def	statistics_save():
	if STATISTICS.dirty == 0:
		return
	try:
		pickle.dump( STATISTICS, open( statistics_savefile, "wt"))
	except IOError:
		pass
	STATISTICS.dirty = 0
	return

##################################################################
class	stattracker:
	def	__init__(self,name,description,statcode1,statcode2=-1,function=None):
		self.name = name
		self.description = description
		self.statcode1 = statcode1
		self.statcode2 = statcode2
		self.function = function
		return

	def	get_tally_game(self):
		if self.function:
			return self.function(STATISTICS.tally_game[self.statcode1],
											STATISTICS.tally_game[self.statcode2])
		return "%u" % STATISTICS.tally_game[self.statcode1]

	def	get_tally_total(self):
		if self.function:
			return self.function(STATISTICS.tally_total[self.statcode1],
											STATISTICS.tally_total[self.statcode2])
		return "%u" % STATISTICS.tally_total[self.statcode1]

##################################################################
def	stattracker_function_percent(value,total):
	if total > 0:
		percent = (value * 100.0) / total
	else:
		percent = 0
	return "%3.1f%%" % percent

##################################################################
def	stattracker_function_ratio1(value,total):
	if total > 0:
		ratio = float(value) / total
	else:
		ratio = 0
	return "%3.1f" % ratio

##################################################################
def	stattracker_function_ratio_60(value,total):
	if total > 0:
		ratio = float(value * 60) / total
	else:
		ratio = 0
	return "%3.1f" % ratio

##################################################################
def	stattracker_function_time_seconds_helper(time_seconds,fields):
	seconds = time_seconds % 60
	minutes = int( time_seconds) / 60
	hours = int( minutes) / 60
	minutes = minutes % 60
	if fields == 3:
		return "%u:%02u:%02u" % (hours, minutes, seconds)
	if fields == 2:
		return "%02u:%02u" % (minutes, seconds)
	return "%us" % time_seconds

##################################################################
def	stattracker_function_time_seconds_hhmmss(time_seconds,dummy):
	return stattracker_function_time_seconds_helper(time_seconds,3)
def	stattracker_function_time_seconds_mmss(time_seconds,dummy):
	return stattracker_function_time_seconds_helper(time_seconds,2)
def	stattracker_function_time_seconds(time_seconds,dummy):
	return stattracker_function_time_seconds_helper(time_seconds,0)

##################################################################
def canvas_statistics( canvasop):
	if canvasop == CANVASOP_TRANSITION_IN :
		return
	if canvasop != CANVASOP_UPDATE:
		return

	sounds_silence_all()

	pygame_library_screen.fill( (25,25,95))

	VGAPRN.zerowrite = 0
	VGAPRN.color1 = (255, 255, 255)
	VGAPRN.justify = JUSTIFY_CENTER

	VGAPRN.setsize(30)
	nn = 17		# cheesy line spacing onscreen
	VGAPRN.printf( (screen_size[0] / 2, 1 * screen_size[1] / nn),
					"Statistics")
	if CANVAS.debounced:
		VGAPRN.printf( (screen_size[0] / 2, (nn - 2) * screen_size[1] / nn),
						"Press ESC to continue")

	VGAPRN.setsize(20)
	y = 3 * screen_size[1] / nn
	for i in range( len( stattrackers)):
		if i & 1:
			c = (15,15,81)
		else:
			c = (55,55,111)

		pygame.draw.rect( pygame_library_screen, c,
				(20, y, scrx - 40, 24))

		t = stattrackers[i]
		if t == 0:
			VGAPRN.color1 = (100,255,0)
			VGAPRN.justify = JUSTIFY_LEFT
			VGAPRN.printf( (50, y), "Description")
			VGAPRN.justify = JUSTIFY_RIGHT
			VGAPRN.printf( (scrx - 150, y), "Game")
			VGAPRN.justify = JUSTIFY_RIGHT
			VGAPRN.printf( (scrx -  50, y), "Total")
		else:
			VGAPRN.color1 = (200,200,0)
			VGAPRN.justify = JUSTIFY_LEFT
			VGAPRN.printf( (50, y), "%s:" % t.description)
			VGAPRN.justify = JUSTIFY_RIGHT
			#VGAPRN.printf( (scrx - 150, y), "%u" % STATISTICS.tally_game[ t.statcode1])
			VGAPRN.printf( (scrx - 150, y), t.get_tally_game())
			VGAPRN.justify = JUSTIFY_RIGHT
			#VGAPRN.printf( (scrx -  50, y), "%u" % STATISTICS.tally_total[ t.statcode1])
			VGAPRN.printf( (scrx -  50, y), t.get_tally_total())
		y += 24

	if CANVAS.debounced:
		for u in INPUT.unicodeses:
			if u in (chr(27), chr(13), chr(10)):
				canvas_set_current(-1)
				return

	return


GLOBAL_TILESIZE = 24


##################################################################
# a simple "LOADING" notification in case asset streaming takes a while
def	show_loading_screen(additional_messages=None):
	screen.fill((0,0,0))
	message_setcolor_info()
	VGAPRN.setsize(30)
	VGAPRN.zerowrite = 1
	VGAPRN.justify = JUSTIFY_CENTER
	loading_messages = []
	loading_messages.append( "LOADING")
	if additional_messages:
		if isinstance( additional_messages, str):
			loading_messages.append( additional_messages)
		else:
			loading_messages += additional_messages
	message_paint_simple_centered( loading_messages)
	waitclock()
	return

show_loading_screen()


##################################################################

##################################################################
def	colorize_surface(surface,newcolor,oldcolor=None):
	surface.lock()
	for j in range( surface.get_height()):
		for i in range( surface.get_width()):
			c = surface.get_at((i,j))
			if (len(c) < 4) or (c[3] > 0):
				if (oldcolor == None) or (
						(oldcolor[0] == c[0]) and
						(oldcolor[1] == c[1]) and
						(oldcolor[2] == c[2])
					):
					surface.set_at((i,j),newcolor)
	surface.unlock()
	return surface

##################################################################
# This "tints" a given range of colors to another color.
# Testing can be found in the TESTALLSHEET subdirectory.
def	tintify_surface(surface,newtint,oldtint = None,tolerance = None):
	# <WIP> if no oldtint supplied, do a scan of the picture to come
	# up with the most common tint!! (For right now we assume green.)
	if oldtint == None:
		oldtint = (0,255,0)

	newtint = newtint[:3]		# remove alpha
	oldtint = oldtint[:3]		# remove alpha
	if tolerance == None:
		tolerance = 40

	# normalize the tints (make them full-span 0 to 255)
	minoldtint = min( oldtint)
	maxoldtint = max( oldtint)
	if maxoldtint == 0:
		maxoldtint = 1
	normoldtint = (	int((255 * (oldtint[0] - minoldtint)) / maxoldtint),
							int((255 * (oldtint[1] - minoldtint)) / maxoldtint),
							int((255 * (oldtint[2] - minoldtint)) / maxoldtint))
	del minoldtint, maxoldtint

	minnewtint = min( newtint)
	maxnewtint = max( newtint)
	if maxnewtint == 0:
		maxnewtint = 1
	normnewtint = (	int((255 * (newtint[0] - minnewtint)) / maxnewtint),
								int((255 * (newtint[1] - minnewtint)) / maxnewtint),
								int((255 * (newtint[2] - minnewtint)) / maxnewtint))
	del minnewtint, maxnewtint

	surface.lock()
	for j in range( surface.get_height()):
		for i in range( surface.get_width()):
			c = surface.get_at((i,j))
			if (len(c) < 4) or (c[3] > 0):
				mintint = min( c)
				maxtint = max( c)
				thistint = (	int((255 * (c[0] - mintint)) / maxtint),
									int((255 * (c[1] - mintint)) / maxtint),
									int((255 * (c[2] - mintint)) / maxtint))
				# calculate tint distance, check if within tolerance
				distance = (	abs( thistint[0] - oldtint[0]) * 3 +
									abs( thistint[1] - oldtint[1]) * 6 +
									abs( thistint[2] - oldtint[2]) * 1) / 20
				if distance < tolerance:
					# compute new tint color, excluding any (possible) alpha
					highest = max( c[:3])
					lowest = min( c[:3])
					span = highest - lowest
					if span > 1:
						r = lowest + (newtint[0] * span) / 255
						g = lowest + (newtint[1] * span) / 255
						b = lowest + (newtint[2] * span) / 255
						if r < 0: r = 0
						if r > 255: r = 255
						if g < 0: g = 0
						if g > 255: g = 255
						if b < 0: b = 0
						if b > 255: b = 255
						newcolor = (r, g, b)
						surface.set_at((i,j),newcolor)
	surface.unlock()
	return surface

##################################################################
class shapesheet:
	def __init__(self,surface_or_filename,r=None,hotspot=None):
		try:
			a = surface_or_filename.get_width()
			self.surface = surface_or_filename
		except AttributeError:
			self.surface = load_image( surface_or_filename)
		# you can supply a subrect, or it will assume the entire surface
		if r == None:
			self.r = pygame.Rect(0,0,self.surface.get_width(),self.surface.get_height())
		else:
			# create a new transparent surface of the smaller size
			if self.surface.get_bitsize() == 8:
				newsurface = pygame.Surface( (r[2], r[3])).convert(self.surface)
			else:
				newsurface = pygame.Surface( (r[2], r[3]), pygame.SRCALPHA)
			newsurface.set_colorkey( self.surface.get_colorkey())
			newsurface.fill( (0,0,0,0))
			# blit graphics over from original surface
			newsurface.blit( self.surface, (0,0), r)
			# now we use the new smaller surface
			self.surface = newsurface
			# create a rect that reflects this new smaller surface (0,0,xsz,ysz)
			self.r = pygame.Rect( 0, 0, r[2], r[3])
		self.sethotspot(hotspot)
		return

	def plot(self,pos,color1=None):
		if color1:
			self.surface.set_palette_at(1,color1)
		adjusted_pos = (pos[0] - self.hotx, pos[1] - self.hoty)
		pygame_library_screen.blit( self.surface, adjusted_pos, self.r)
		return

	def	mirrorx(self):
		self.surface = self.surface.copy()
		self.surface.lock()
		for j in range( self.r[3]):
			for i in range( self.r[2] >> 1):
				t = self.surface.get_at( (self.r[0] + i, self.r[1] + j))
				self.surface.set_at( (self.r[0] + i, self.r[1] + j),
					self.surface.get_at( (self.r[0] + ((self.r[2] - 1) - i), self.r[1] + j)))
				self.surface.set_at( (self.r[0] + ((self.r[2] - 1) - i), self.r[1] + j), t)
				#self.surface.set_at( (self.r[0] + i, self.r[1] + j), (255,0,0))
		self.surface.unlock()
		return self

	def	rotateright(self,degrees=90):
		degrees = 90 * (int(degrees / 90) & 3)
		oldw = self.r[2]
		oldh = self.r[3]
		if (degrees == 0) or (degrees == 180):
			neww = oldw
			newh = oldh
		else:
			neww = oldh
			newh = oldw
		#print "Rotateright: %u/%u" % ( neww, newh)
		newsurface = pygame.Surface( (neww, newh)).convert(self.surface)
		newsurface.set_colorkey( self.surface.get_colorkey())
		self.surface.lock()
		newsurface.lock()
		for j in range(oldh):
			for i in range(oldw):
				ii = self.r[0] + i
				jj = self.r[1] + j
				if degrees == 0:
					x = i
					y = j
				elif degrees == 90:
					x = (oldh - 1) - j
					y = i
				elif degrees == 180:
					x = (oldw - 1) - i
					y = (oldh - 1) - j
				elif degrees == 270:
					x = j
					y = (oldw - 1) - i
				else:
					print "rotateright(): not 0, 90, 180 or 270 degrees..."
					assert(0)
				c = self.surface.get_at( (ii, jj))
				newsurface.set_at( (x, y), c)
		newsurface.unlock()
		self.surface.unlock()
		self.surface = newsurface
		self.r = pygame.Rect( 0, 0, neww, newh)
		return self

	def	sethotspot(self,hotspot):
		hotspot_sethotspot(self,hotspot)
		return

	def	clone(self):
		ss = shapesheet( self.surface)
		ss.surface = ss.surface.copy()
		ss.r = self.r
		ss.hotx = self.hotx
		ss.hoty = self.hoty
		return ss

	# optionally specify only replacing a single color,
	# otherwise it replaces all non-transparent
	def	colorize(self,newcolor,oldcolor=None):
		colorize_surface( self.surface, newcolor, oldcolor)
		return self


##################################################################
class	rotation:
	def	__init__(self,MAXROTS=None):
		if MAXROTS == None:
			MAXROTS = 32
		self.MAXROTS = 32

		#/ produce the directional tables
		self.xtable = []
		self.ytable = []

		for i in xrange( self.MAXROTS):
			angle = (i * pi * 2) / self.MAXROTS
			xm =  int( 65536 * sin( angle))
			ym = -int( 65536 * cos( angle))
			# print "rot = %d --> (%d,%d)" % (i, xm, ym)
			self.xtable.append(xm)
			self.ytable.append(ym)

		#/ produce the atan2 table
		self.atan2_table = []

		# 02/07/2007 - this is the REFERENCE way to make atan2 tables, so that
		# there is no doubling of a wedge across the zero, and no skewing
		# of a partial wedge sideways
		cx = 25
		cy = 25
		for j in range( 51):
			oneline = ""
			for i in range( 51):
				angle = atan2( j - cy, i - cx)
				# back out half a pie wedge
				angle = angle + (pi / MAXROTS)
				# adjust for 90 degrees being top dead center
				angle = angle + (pi / 2)
				# adjust for sub-zero wrap around (add full 360 degrees)
				if angle < 0:
					angle = angle + 2 * pi
				iangle = int( (angle * MAXROTS) / (2 * pi))
				self.atan2_table.append( iangle)
				oneline += chr( 64 + iangle)
			#	print oneline

		return

	def	atan2( self, x1,y1,x2,y2):
		x = int( x2 - x1)
		y = int( y2 - y1)

		while( (abs(x) > 25) or (abs( y) > 25)):
			x >>= 1
			y >>= 1

		x += 25
		y += 25

		return self.atan2_table[ x + y * 51]

##################################################################
def	xmove360( degrees):
	angle = (degrees * 3.1415926 * 2) / 360
	return sin( angle)

def	ymove360( degrees):
	angle = (degrees * 3.1415926 * 2) / 360
	return -cos( angle)


##################################################################
ASSETS_TILETYPE_TBB = 0
USE_ALLSHEET = 0
if USE_ALLSHEET:
	ASSETS_TILETYPE_ALLSHEET = 1

	assets_tiletype_strings = [
		"Basic Turn-Based Botz tiles",
		"ALLSHEET-based tiles",
	]

	#include allsheet.h

	ALLSHEET = allsheet()

##################################################################
class	gameassets:
	pass

ASSETS = gameassets()

ASSETS.tiletype = ASSETS_TILETYPE_TBB

ASSETS.tilesize = 0

##################################################################
ASSETS.bitmapfont_vic20 = cbf = BITMAP_FONT().load_from_charset( (
".",	# sourced from '_csvic20.h'
"8",
"8",
"32",
"96",
"",
"Vic-20",
"",
"",
"",
"                                                                ",
"  **      **      **      **              **      **            ",
" **  **  **  **  **  **                                         ",
" ** **   ** **  *******  ** **  *******  ** **   ** **          ",
"   **    ****** ** **    *****     **** ******     **           ",
" **   *  **  *      *      *      *      *  **  *   **          ",
" ***    ** **    *** ** ** ***  **  **  **  ***  ***            ",
"   **      **     **                                            ",
"   **     **     **      **      **       **       **           ",
" **       **       **      **      **     **     **             ",
"   *    ** * **   ***   *******   ***   ** * **    *            ",
"          *       *     *****     *       *                     ",
"                                          **      **     **     ",
"                        ******                                  ",
"                                          **      **            ",
"      *      **     **     **     **     **     **              ",
"  ***    ** **  **   ** **   ** **   **  ** **    ***           ",
"  **     ***      **      **      **      **    ******          ",
" *****  **   **      **    ***   ***    **      *******         ",
" *****  **   **      **   ****       ** **   **  *****          ",
"   ***    ****   ** **  **  **  *******     **      **          ",
"******* **      ******  **   **      ** **   **  *****          ",
" *****  **   ** **      ******  **   ** **   **  *****          ",
"******* **   **      **     **     **     **      **            ",
" *****  **   ** **   **  *****  **   ** **   **  *****          ",
" *****  **   ** **   **  ******      ** **   **  *****          ",
"          **      **              **      **                    ",
"          **      **              **      **     **             ",
"   ***    **     **     **       **       **       ***          ",
"                *******         *******                         ",
"***       **       **       **     **     **    ***             ",
" ****   **  **      **     **     **              **            ",
" *****  **   **      **  *** ** ** * ** ** * **  *****          ",
"  ***    ** **  **   ** ******* **   ** **   ** **   **         ",
"******  **   ** **   ** ******  **   ** **   ** ******          ",
" *****  **   ** **      **      **      **   **  *****          ",
"******   **  **  **  **  **  **  **  **  **  ** ******          ",
"******* **      **      ******  **      **      *******         ",
"******* **      **      *****   **      **      **              ",
" *****  **   ** **      ** **** **   ** **   **  *****          ",
"**   ** **   ** **   ** ******* **   ** **   ** **   **         ",
"  ****     **      **      **      **      **     ****          ",
"   ****     **      **      **  **  **  **  **   ****           ",
"**   ** **  **  ** **   ****    ** **   **  **  **   **         ",
"**      **      **      **      **      **      *******         ",
"**   ** *** *** ******* ** * ** **   ** **   ** **   **         ",
"**   ** ***  ** **** ** ** **** **  *** **   ** **   **         ",
" *****  **   ** **   ** **   ** **   ** **   **  *****          ",
"******  **   ** **   ** ******  **      **      **              ",
" *****  **   ** **   ** ** * ** ** ****  *****      ***         ",
"******  **   ** **   ** ******  **  **  **   ** **   **         ",
" *****  **   ** **       *****       ** **   **  *****          ",
" ******    **      **      **      **      **      **           ",
"**   ** **   ** **   ** **   ** **   ** **   **  *****          ",
"**   ** **   ** **   ** **   **  ** **   ** **    ***           ",
"**   ** **   ** **   ** ** * ** ******* *** *** **   **         ",
"**   ** **   **  ** **    ***    ** **  **   ** **   **         ",
" **  **  **  **  **  **   ****     **      **      **           ",
"******* **   **     **    ***    **     **   ** *******         ",
" ****    **      **      **      **      **      ****           ",
"*       **       **       **       **       **       **         ",
" ****      **      **      **      **      **    ****           ",
"   *      ***    ** **  **   **                                 ",
"                                                ********        ",
"  **      **       **                                           ",
"                 ****       **   *****  **  **   **** *         ",
"**      **      ** ***  ***  ** **   ** **   ** ******          ",
"                 *****  **   ** **      **   **  *****          ",
"     **      **  *** ** **  *** **   ** **   **  ******         ",
"                 *****  **   ** ******* **       *****          ",
"   ***    ** **   **    ******    **      **      **            ",
"                 *** ** **  *** **  ***  *** **      **  *****  ",
"**      **      ******  **   ** **   ** **   ** **   **         ",
"   **             ***      **      **      **     ****          ",
"    **             ****     **      **      **  **  **   ****   ",
" **      **      ** **   ****    ***     ****    ** **          ",
" ***      **      **      **      **      **     ****           ",
"                * ****  ** * ** ** * ** ** * ** ** * **         ",
"                * ****  **   ** **   ** **   ** **   **         ",
"                 *****  **   ** **   ** **   **  *****          ",
"                ******  **   ** **   ** ******  **      **      ",
"                 ****** **   ** **   **  ******      **      ** ",
"                ** ***  ***  ** **      **      **              ",
"                 ****** **       *****       ** ******          ",
"  **      **    ******    **      **      ** **    ***          ",
"                **  **  **  **  **  **  **  **   *** *          ",
"                **  **  **  **  **  **   ****     **            ",
"                **   ** ** * ** ** * ** *******  ** **          ",
"                **   **  ** **    ***    ** **  **   **         ",
"                **   ** **   ** **  ***  *** **      **   ****  ",
"                ******     **     **     **     ******          ",
"   ***    **      **     **       **      **       ***          ",
"  **      **      **              **      **      **            ",
"***       **      **       **     **      **    ***             ",
" *** ** ** ***  *   *                                           ",
"   *      ***    ** **   ** **   ** **  **   ** **   ** ******* ",
))

##################################################################
ASSETS.tbb_tga = load_image( "tbb.tga", 0)

ASSETS.tbb_tiles = None

##################################################################
def	load_tile_tbb(coords):
	x = 20 + 10 * coords[0]
	y = 40 + 10 * coords[1]
	s = pygame.Surface( (8,8), pygame.SRCALPHA)
	r = (x,y,8,8)
	s.blit( ASSETS.tbb_tga, (0,0), r)
	large = pygame.transform.scale( s, (ASSETS.tilesize, ASSETS.tilesize))
	return large

def	load_tile_tbb_tiny_centered(coords):
	x = 20 + 10 * coords[0]
	y = 40 + 10 * coords[1]
	s = pygame.Surface( (ASSETS.tilesize, ASSETS.tilesize), pygame.SRCALPHA)
	r = (x,y,8,8)
	s.blit( ASSETS.tbb_tga, 
				((ASSETS.tilesize - 8) >> 1,(ASSETS.tilesize - 8) >> 1), r)
	return s

##################################################################
def	load_tile_allsheet(coords):
	shsh = ALLSHEET.load_sprite(coords)
	scale = float( ASSETS.tilesize) / 32
	s = pygame.Surface( (32,32), pygame.SRCALPHA)
	# I would just do a blit, but when blitting to a transparent surface,
	# it appears to still copy the color value, which causes a magenta
	# fringe around the sprites once they are rescaled by rotozoom.
	#s.blit( shsh.surface, (0,0))
	for j in xrange(32):
		for i in xrange(32):
			c = shsh.surface.get_at((i,j))
			if c[3]:
				s.set_at( (i, j), c)
	large = pygame.transform.rotozoom( s, 0, scale)
	return large

##################################################################
arrow0 = load_image( "arrow_20_0.tga")
arrow1 = load_image( "arrow_20_1.tga")
ASSETS.arrows_20 = (
	shapesheet( arrow0),
	shapesheet( arrow1),
	shapesheet( arrow0).rotateright(90),
	shapesheet( arrow1).rotateright(90),
	shapesheet( arrow0).rotateright(180),
	shapesheet( arrow1).rotateright(180),
	shapesheet( arrow0).rotateright(270),
	shapesheet( arrow1).rotateright(270),
)

ASSETS.arrows_20_selected = [a.clone().colorize((255,0,0)) for a in ASSETS.arrows_20]

##################################################################
arrow0 = load_image( "arrow_14_0.tga")
arrow1 = load_image( "arrow_14_1.tga")
ASSETS.arrows_14 = (
	shapesheet( arrow0),
	shapesheet( arrow1),
	shapesheet( arrow0).rotateright(90),
	shapesheet( arrow1).rotateright(90),
	shapesheet( arrow0).rotateright(180),
	shapesheet( arrow1).rotateright(180),
	shapesheet( arrow0).rotateright(270),
	shapesheet( arrow1).rotateright(270),
)

##################################################################
arrow0 = load_image( "arrow_14_0_faded.tga")
arrow1 = load_image( "arrow_14_1_faded.tga")
ASSETS.arrows_14_faded = (
	shapesheet( arrow0),
	shapesheet( arrow1),
	shapesheet( arrow0).rotateright(90),
	shapesheet( arrow1).rotateright(90),
	shapesheet( arrow0).rotateright(180),
	shapesheet( arrow1).rotateright(180),
	shapesheet( arrow0).rotateright(270),
	shapesheet( arrow1).rotateright(270),
)

##################################################################
def	assets_load_tiles_tbb(tilesize):
	ASSETS.tilesize = tilesize
	ASSETS.tbb_tiles = TBBT_MAXIMUM * [None]

	ASSETS.tbb_tiles[TBBT_BLANK] = (
		load_tile_tbb_tiny_centered( (0,0)),
		load_tile_tbb( (1,0)),
	)

	ASSETS.tbb_tiles[TBBT_YOU] = (
		load_tile_tbb( (0,3)),
	)

	ASSETS.tbb_tiles[TBBT_ROBOT1] = (
		load_tile_tbb( (0,2)),
		load_tile_tbb( (1,2)),
		load_tile_tbb( (2,2)),
		load_tile_tbb( (3,2)),
		load_tile_tbb( (4,2)),
		load_tile_tbb( (2,2)),
		load_tile_tbb( (4,2)),
		load_tile_tbb( (2,2)),
		load_tile_tbb( (4,2)),
	)

	ASSETS.tbb_tiles[TBBT_ROBOT2] = (
		load_tile_tbb( (10,2)),
		load_tile_tbb( (11,2)),
		load_tile_tbb( (12,2)),
		load_tile_tbb( (13,2)),
		load_tile_tbb( (14,2)),
		load_tile_tbb( (12,2)),
		load_tile_tbb( (14,2)),
		load_tile_tbb( (12,2)),
		load_tile_tbb( (14,2)),
	)

	ASSETS.tbb_tiles[TBBT_DOLLAR] = (
		load_tile_tbb( (0,4)),
		load_tile_tbb( (1,4)),
		load_tile_tbb( (2,4)),
		load_tile_tbb( (3,4)),
		load_tile_tbb( (4,4)),
		load_tile_tbb( (5,4)),
	)

	ASSETS.tbb_tiles[TBBT_ELECTRODE] = (
		load_tile_tbb( (0,5)),
		load_tile_tbb( (1,5)),
		load_tile_tbb( (2,5)),
		load_tile_tbb( (3,5)),
		load_tile_tbb( (4,5)),
		load_tile_tbb( (5,5)),
		load_tile_tbb( (6,5)),
		load_tile_tbb( (7,5)),
	)

	ASSETS.tbb_tiles[TBBT_BRICK] = (
		load_tile_tbb( (0,1)),
	)

	ASSETS.tbb_tiles[TBBT_STONE1] = (
		load_tile_tbb( (3,1)),
	)

	ASSETS.tbb_tiles[TBBT_STONE2] = (
		load_tile_tbb( (2,1)),
	)

	ASSETS.tbb_tiles[TBBT_STONE3] = (
		load_tile_tbb( (1,1)),
	)

	ASSETS.tbb_tiles[TBBT_BOMBOFF] = (
		load_tile_tbb( (0,7)),
	)

	ASSETS.tbb_tiles[TBBT_BOMBON] = (
		load_tile_tbb( (1,7)),
		load_tile_tbb( (2,7)),
		load_tile_tbb( (3,7)),
		load_tile_tbb( (4,7)),
	)

	ASSETS.tbb_tiles[TBBT_BOMBARMED] = (
		load_tile_tbb( (1,7)),
		load_tile_tbb( (2,7)),
		load_tile_tbb( (3,7)),
		load_tile_tbb( (4,7)),
	)

	ASSETS.tbb_tiles[TBBT_BOMBFLAME] = (
		load_tile_tbb( (0,8)),		# not used?
	)

	ASSETS.tbb_tiles[TBBT_MINE] = (
		load_tile_tbb( (0,8)),		# not exist?
	)

	ASSETS.tbb_tiles[TBBT_WARPLINK] = (
		load_tile_tbb( (0,9)),
		load_tile_tbb( (1,9)),
		load_tile_tbb( (2,9)),
		load_tile_tbb( (3,9)),
		load_tile_tbb( (4,9)),
	)

	ASSETS.tbb_tiles[TBBT_WARPLINK] = (
		load_tile_tbb( (0,9)),
		load_tile_tbb( (1,9)),
		load_tile_tbb( (2,9)),
		load_tile_tbb( (3,9)),
		load_tile_tbb( (4,9)),
	)

	ASSETS.tbb_tiles[TBBT_CORPSE] = (
		load_tile_tbb( (0,3)),
		load_tile_tbb( (1,3)),
		load_tile_tbb( (2,3)),
		load_tile_tbb( (3,3)),
	)

	ASSETS.tbb_tiles[TBBT_EXTRALIFE] = (
		load_tile_tbb( (0,10)),
		load_tile_tbb( (1,10)),
	)

	ASSETS.tbb_tiles[TBBT_EXTRAMOVES] = (
		load_tile_tbb( (0,12)),
		load_tile_tbb( (1,12)),
		load_tile_tbb( (2,12)),
		load_tile_tbb( (3,12)),
	)

	ASSETS.tbb_tiles[TBBT_TIMES2] = (
		load_tile_tbb( (10,0)),
	)

	ASSETS.tbb_tiles[TBBT_TIMES3] = (
		load_tile_tbb( (11,0)),
	)

	ASSETS.tbb_tiles[TBBT_TIMES4] = (
		load_tile_tbb( (12,0)),
	)

	ASSETS.tbb_tiles[TBBT_TIMES5] = (
		load_tile_tbb( (13,0)),
	)

	ASSETS.tile_explosions = (
		load_tile_tbb( (18,0)),
		load_tile_tbb( (19,0)),
		load_tile_tbb( (20,0)),
		load_tile_tbb( (21,0)),
		load_tile_tbb( (22,0)),
		load_tile_tbb( (23,0)),
	)

	return

##################################################################
def	assets_load_tiles_allsheet(tilesize):
	ASSETS.tilesize = tilesize

	ASSETS.tbb_tiles[TBBT_YOU] = (
		#load_tile_allsheet( (32,3)),		#  blue grobed guy
		load_tile_allsheet( (63,3)),		# white robed guy
	)

	ASSETS.tbb_tiles[TBBT_ROBOT1] = (
		load_tile_allsheet( (58, 20)),			# skeleton
		load_tile_allsheet( (59, 20)),
		load_tile_allsheet( (60, 20)),
		load_tile_allsheet( (61, 20)),
		load_tile_allsheet( (62, 20)),
	)

	return

##################################################################
def	assets_load_tiles(tilesize):
	if USE_ALLSHEET:
		if ASSETS.tilesize == 0:
			message_setcolor_info(30)
			result = message_list_select(
					assets_tiletype_strings,
					"Please select tiletype:",
					ASSETS.tiletype)
			if result >= 0:
				ASSETS.tiletype = result

	assets_load_tiles_tbb(tilesize)

	if USE_ALLSHEET:
		if ASSETS.tiletype == ASSETS_TILETYPE_ALLSHEET:
			assets_load_tiles_allsheet(tilesize)

	return

ASSETS.dimmer = pygame.Surface((scrx,scry)).convert_alpha()

##################################################################
def	sound_fire1():
	return

##################################################################
def	sound_fire2():
	return

##################################################################
def	sound_death1():
	return

##################################################################
def	sound_bonus():
	return


##################################################################
# Kurtles module for DALEKS game

##################################################################

##################################################################
KURTLES.graphics_icons_filename = "kurtles_daleks_icons_32x32.tga"

kurtle_100_robots = Kurtle( "We'll Make More!", ("Destroy 100 robots.",), 10)
kurtle_1000_robots = Kurtle( "Some Disassembly Required", ("Destroy 1000 robots.",), 20)
kurtle_10000_robots = Kurtle( "Destroy Them All", ("Destroy 10000 robots.",), 50)
kurtle_1000_gold = Kurtle( "It's MY Gold!", ("Collect 1000 gold pieces.",), 10)
kurtle_100_games = Kurtle( "Centenarian", ("Play 100 games.",), 25)
kurtle_speed_game = Kurtle( "Go Go Go Speed Racer!", ("Finish a game with at least 1000 score per minute.",), 10)
kurtle_destroy_8_robots = Kurtle( "Giant Kaboom!", ("Explode 8 or more robots on one turn.",), 25)
kurtle_1000_waves = Kurtle( "Wave After Wave", ("Complete 1000 waves.",), 10)
kurtle_1000_moves = Kurtle( "One Thousand Steps", ("Execute 1000 moves in one game.",), 10)
kurtle_max_multiplier = Kurtle( "Max Multiplier", ("Reach 5x points multiplier.",), 20)
kurtle_marathon_man = Kurtle( "Marathon Man", ("Complete wave #26 in any game.",), 30)
kurtle_untouchable = Kurtle( "Untouchable", ("Complete wave #10 without dying.",), 30)

KURTLES.finished_adding( "daleks_kurtles_unlocked.txt")



##################################################################
SETTINGSOFFSET_ENABLE_VI_KEYS = 0
SETTINGSOFFSET_ENABLE_ALLSCREEN = 1
SETTINGSOFFSET_MAXIMUM = 10

##################################################################
SETTINGS_FILENAME = "daleks_settings.txt"

##################################################################
def	settings_initonce():
	STATE.settings_array = SETTINGSOFFSET_MAXIMUM * [0]
	f = None
	try:
		f = open( SETTINGS_FILENAME, "rt")
	except IOError:
		pass
	if f:
		try:
			STATE.settings_array = pickle.load(f)
		except:
			pass
		f.close()
	if len( STATE.settings_array) != SETTINGSOFFSET_MAXIMUM:
		STATE.settings_array = SETTINGSOFFSET_MAXIMUM * [0]

	return

##################################################################
def	settings_write():
	try:
		f = open( SETTINGS_FILENAME, "wt")
		pickle.dump( STATE.settings_array, f)
		f.close()
	except IOError:
		pass
	return

##################################################################
class	gamestate:
	def	__init__(self):


##################################################################
# gamestate information common to all game

		self.score = 0
#		self.highscore = 0		# REMOVED - use hiscores.h module instead!
		self.ships = 0			# lives
		self.wave = 0			# steadily counts up

		self.bonus = 0			# when do you get your bonus ships?
		self.boninc = 0			# bonus ship interval

		self.worldx = 0			# control scrollview of the world
		self.worldy = 0

		self.cheating = 0
		self.mystuff = 0

STATE = gamestate()

##################################################################
CANVAS.ht = HISC_TABLE( "daleks_hiscores.txt")

settings_initonce()

STATE.framerandomizer = 0

STATE.irregulartimer = 50


#/ <WIP> load the settings from disk

##################################################################
STATTYPE_ROBOTS_DESTROYED = 1
STATTYPE_GOLD_COLLECTED = 10
STATTYPE_GOLD_LOST = 11
STATTYPE_GOLD_INVOLVED = 12
STATTYPE_WAVE_COMPLETED = 20
STATTYPE_MOVES_TAKEN = 30
STATTYPE_GAMES_PLAYED = 31
STATTYPE_SECONDS_PLAYED = 32
STATTYPE_ATTRACT_MODES_PLAYED = 50
STATTYPE_SCORE = 99

# None of the above values should exceed this value!!
STATTYPE_MAXIMUM	= 100

##################################################################
ROT8 = rotation(8)

##################################################################
BOARDTYPE_SQUARE = 1
BOARDTYPE_ALLSCREEN = 2

##################################################################
def rtns_addscore(points):
	STATE.score += points
	if STATE.score >= STATE.bonus:
		STATE.ships += 1
		STATE.bonus += STATE.boninc
	return

##################################################################
def	rtns_newgame(setcanvas=1):
	if STATE.settings_array[SETTINGSOFFSET_ENABLE_ALLSCREEN]:
		rtns_set_boardtype( BOARDTYPE_ALLSCREEN)
	else:
		rtns_set_boardtype( BOARDTYPE_SQUARE)
	input_initgame()
	STATISTICS.resetgamevalues()
	STATE.cheating = 0
	print "rtns_newgame(): cheating = 0"
	tbb_initgame()
	tbb_initwave()
	if not ASSETS.tbb_tiles:
		assets_load_tiles(GLOBAL_TILESIZE)
	if setcanvas:
		canvas_set_current( canvas_waveintro)
	ai_initwave()
	return

##################################################################
def	rtns_gameover():
	if STATE.cheating:
		canvas_set_current( canvas_gameover)
		return

	sounds_silence_all()

	STATISTICS.tallyup(	STATTYPE_ROBOTS_DESTROYED,
										tbbp.tbbstats_robots_destroyed)
	STATISTICS.tallyup(	STATTYPE_GOLD_COLLECTED,
										tbbp.tbbstats_dollars_collected)
	STATISTICS.tallyup(	STATTYPE_GOLD_LOST,
										tbbp.tbbstats_dollars_lost)
	STATISTICS.tallyup(	STATTYPE_GOLD_INVOLVED,
										(tbbp.tbbstats_dollars_collected + tbbp.tbbstats_dollars_lost))
	STATISTICS.tallyup(	STATTYPE_WAVE_COMPLETED,
										tbbp.waveno - 1)
	STATISTICS.tallyup(	STATTYPE_MOVES_TAKEN,
										tbbp.moveno)
	STATISTICS.tallyup(	STATTYPE_SECONDS_PLAYED,
										tbbp.seconds_played)
	STATISTICS.tallyup(	STATTYPE_GAMES_PLAYED)
	STATISTICS.tallyup(	STATTYPE_SCORE,
										tbbp.score)
	statistics_save()

	if tbbp.seconds_played >= 60:
		tbbp.scoreperminute = (tbbp.score * 60) / tbbp.seconds_played
		print "Game score per minute: %u" % tbbp.scoreperminute
		if not STATE.cheating:
			if tbbp.scoreperminute >= 1000:
				kurtle_speed_game.unlock()

	if not STATE.cheating:
		if STATISTICS.tally_total[ STATTYPE_GAMES_PLAYED] >= 100:
			kurtle_100_games.unlock()

	extra = "R:%u G:%u Mv:%u/%u" % (
			tbbp.tbbstats_robots_destroyed, tbbp.tbbstats_dollars_collected,
			tbbp.moveno, tbbp.maxmoveno,
			)

	VGAPRN.setsize(30)
	message_setcolor_good()
	hiscores_add_score_simple(CANVAS.ht, tbbp.score, extra = extra)

	canvas_set_current( canvas_gameover)
	return

##################################################################
def	rtns_show_help():
	message_setcolor_text(20)
	message_simple_text_file("readme.txt")
	return

##################################################################
def	rtns_set_boardtype(bt):
	tbbp.boardtype = bt
	if tbbp.boardtype == BOARDTYPE_SQUARE:
		tbbp.TBBMAXX = 20
		tbbp.TBBMAXY = 20

		STATE.ui_ulx = scry
		STATE.ui_uly = 0

		STATE.ui_w = scrx - scry
		STATE.ui_h = scry

		STATE.playfield_rect = pygame.Rect( 0, 0, scry, scry)
	elif tbbp.boardtype == BOARDTYPE_ALLSCREEN:
		tbbp.TBBMAXX = 27		# requires slight pixel overlap in 640x480
		tbbp.TBBMAXY = 20

		STATE.ui_ulx = scrx		# offscreen!
		STATE.ui_uly = 0

		STATE.ui_w = 0
		STATE.ui_h = scry

		STATE.playfield_rect = pygame.Rect( 0, 0, scrx, scry)
	else:
		print "rtns_set_boardtype(): Unhandled boardtype = %u" % tbbp.boardtype
		sys.exit()

	tbbp.MAXROBOTS = (tbbp.TBBMAXX * tbbp.TBBMAXY)
	return

##################################################################
def	rtns_tilex(a):
	if tbbp.boardtype == BOARDTYPE_ALLSCREEN:
		return (scrx * a) / tbbp.TBBMAXX
	return a * ASSETS.tilesize

def	rtns_tiley(a):
	return a * ASSETS.tilesize

def	rtns_cellx(a):
	if tbbp.boardtype == BOARDTYPE_ALLSCREEN:
		return int( (a * tbbp.TBBMAXX) / scrx)
	return int( a / ASSETS.tilesize)

def	rtns_celly(a):
	return int( a / ASSETS.tilesize)


##################################################################
statistics_savefile = "daleks_statistics.txt"

##################################################################
stattrackers = [
	0,		# triggers header to be displayed
	stattracker( "Score", "Total Points Scored", STATTYPE_SCORE),
	stattracker( "RobotsDestroyed", "Robots Destroyed", STATTYPE_ROBOTS_DESTROYED),
	stattracker( "GoldCollected", "Gold Collected", STATTYPE_GOLD_COLLECTED),
	stattracker( "GoldLost", "Gold Lost", STATTYPE_GOLD_LOST),
	stattracker( "GoldRecoveryFactor", "Gold Recovery Factor",
					STATTYPE_GOLD_COLLECTED,
					STATTYPE_GOLD_INVOLVED,
					stattracker_function_percent),
	stattracker( "GamePlayed", "Games Played", STATTYPE_GAMES_PLAYED),
	stattracker( "ScorePerGame", "Score Per Game", 
					STATTYPE_SCORE,
					STATTYPE_GAMES_PLAYED,
					stattracker_function_ratio1),
	stattracker( "TimePlayed", "Time Played",
					STATTYPE_SECONDS_PLAYED,
					0,
					stattracker_function_time_seconds_hhmmss),
	stattracker( "ScorePerSecond", "Score Per Second", 
					STATTYPE_SCORE,
					STATTYPE_SECONDS_PLAYED,
					stattracker_function_ratio1),
	stattracker( "ScorePerMinute", "Score Per Minute", 
					STATTYPE_SCORE,
					STATTYPE_SECONDS_PLAYED,
					stattracker_function_ratio_60),
	stattracker( "WaveCompleted", "Waves Completed", STATTYPE_WAVE_COMPLETED),
	stattracker( "MovesTaken", "Moves Taken", STATTYPE_MOVES_TAKEN),
	stattracker( "AttractModeGames", "Attract Mode Games", STATTYPE_ATTRACT_MODES_PLAYED),
]


##################################################################
def canvas_attract(canvasop):
	if canvasop == CANVASOP_TRANSITION_IN:
		CANVAS.fullscreen_toggle_pos = None
		rtns_newgame(0)		# just to run the attract mode
		STATE.cheating = 1	# no achievements during attract
		ASSETS.darkening = pygame.Surface( (scrx, scry)).convert_alpha()
		ASSETS.darkening.fill( (0,0,0,88))
		rtns_set_boardtype( BOARDTYPE_ALLSCREEN)
		tbbp.waveno = 5 + Random(30)
		tbb_initwave()
		STATE.attract_ypos = 5
		return
	if canvasop != CANVASOP_UPDATE:
		return

	if len(INPUT.unicodeses) or (
			(not INPUT.mousebuttons[0]) and INPUT.prevmousebuttons[0]
		):
		canvas_set_current( canvas_greet)
		return

	pygame_library_screen.fill( (0,0,0))

	ui_draw_field()
	ui_draw_explosions()
	if ui_introduce_you():
		pass
	else:
		if tbbp.youdead:
			tbbp.youdead += 1
			if tbbp.youdead > 20:
				tbb_inityou()
		else:
			if (CANVAS.timer & 7) == 0:
				ai_make_1_move()
	if not tbbp.waveinitted:
		tbbp.waveno = 5 + Random(30)
		tbb_initwave()
	if tbbp.gameover:
		print "Attract mode game over..."
		STATISTICS.tallyup( STATTYPE_ATTRACT_MODES_PLAYED)
		statistics_save()
		canvas_set_current(-1)
		return

	if tbbp.youy < 8:
		STATE.attract_ypos = scry - 25
	if tbbp.youy >= tbbp.TBBMAXY - 8:
		STATE.attract_ypos = 5
	VGAPRN.setsize(20)
	VGAPRN.color0 = (0,0,0)
	VGAPRN.color1 = (222,222,222)
	VGAPRN.justify = JUSTIFY_LEFT
	VGAPRN.zerowrite = 1
	VGAPRN.printf( (5, STATE.attract_ypos), " ATTRACT MODE - PRESS ANY KEY TO EXIT! ")

	return

##################################################################
ATTRACT_MODE_SECONDS = 12

##################################################################
def canvas_greet(canvasop):
	if canvasop == CANVASOP_TRANSITION_IN:
		CANVAS.fullscreen_toggle_pos = None
		STATE.attract_mode_timer = 0
		STATE.attract_mode_codes = []
		for i in xrange( ATTRACT_MODE_SECONDS):
			robottype = ASSETS.tbb_tiles[TBBT_ROBOT1][0]
			if Random(5) == 0:
				robottype = ASSETS.tbb_tiles[TBBT_ROBOT2][0]
			STATE.attract_mode_codes.append( (15 + Random(15), robottype))
		return
	if canvasop != CANVASOP_UPDATE:
		return

	pygame_library_screen.fill( (0,40,40))

	STATE.attract_mode_timer += 1
	attract_seconds = int(STATE.attract_mode_timer / 30)
	if attract_seconds > ATTRACT_MODE_SECONDS:
		canvas_set_current( canvas_attract)
		return
	else:
		for i in xrange( attract_seconds):
			plot( (((1 + i) * (scrx - 50)) / ATTRACT_MODE_SECONDS,
							STATE.attract_mode_codes[i][0]),
					STATE.attract_mode_codes[i][1])

	VGAPRN.setsize(150)
	VGAPRN.color1 = (222,222,222)
	VGAPRN.justify = JUSTIFY_CENTER
	VGAPRN.zerowrite = 0
	VGAPRN.printf( (scrx / 2, 20), "DALEKS")

	VGAPRN.setsize(60)
	VGAPRN.color1 = (222,222,222)
	VGAPRN.justify = JUSTIFY_CENTER
	VGAPRN.zerowrite = 0
	VGAPRN.printf( (scrx / 2, 170), "Attack Of The Robots!")

	VGAPRN.setsize(30)

	if CANVAS.debounced:
		VGAPRN.setsize(20)
		VGAPRN.justify = JUSTIFY_LEFT
		VGAPRN.printf( (5, scry - 25), "F1-Help")
		if 1:
			VGAPRN.setsize(30)
			greeting_strings = (
				"Press A to toggle 'allscreen' (%s)" %
							enadis( STATE.settings_array[SETTINGSOFFSET_ENABLE_ALLSCREEN]),
				"Press V to toggle vi keys (%s)" %
								enadis( STATE.settings_array[SETTINGSOFFSET_ENABLE_VI_KEYS]),
				"Press H to view High Scores",
				"Press S to view Statistics",
				"Press K to view Kurtles (Achievements)",
				"Press ENTER or click to start a game",
			)
			maxwidth = VGAPRN.getwidth( max( greeting_strings, key = lambda a: VGAPRN.getwidth(a)))
			VGAPRN.justify = JUSTIFY_LEFT
			x = (scrx - maxwidth) / 2
			ys = 35
			y = (scry - 30) - ys * len( greeting_strings)
			for s in greeting_strings:
				VGAPRN.printf( (x, y), s)
				y += ys
		else:
			VGAPRN.setsize(20)
			thebuttons = (
				textbutton( text = "S - view Statistics", canvas = canvas_statistics),
				textbutton( text = "K - view Kurtles (Achievements)", canvas = canvas_kurtles),
				textbutton( text = "H - view High Score Chart", canvas = canvas_hiscores),
				textbutton( text = "[ENTER] - Start Game", function = rtns_newgame),
			)
			buttonstackheight = 3
			yy = y
			for i in xrange( len( thebuttons)):
				b = thebuttons[i]
				x = 16 + (scrx / 2) * (i / buttonstackheight)
				y = yy + 50 * (i % buttonstackheight)
				b.gotoxy( (x, y))
				b.think()
				b.paint()
				y -= 60

	joystick_greet_paint()

	if CANVAS.debounced:
		if (not INPUT.mousebuttons[0]) and INPUT.prevmousebuttons[0]:
			rtns_newgame()
			return
		if len(INPUT.unicodeses):
			STATE.attract_mode_timer = 0
		for u in INPUT.unicodeses:
			if u in (chr(27),):
				canvas_set_current(0)
				return
			if u in (chr(10), chr(13)):
				rtns_newgame()
				return
			if u in ('a', 'A',):
				STATE.settings_array[ SETTINGSOFFSET_ENABLE_ALLSCREEN] = (
					1 - STATE.settings_array[SETTINGSOFFSET_ENABLE_ALLSCREEN])
				settings_write()
			if u in ('v', 'V',):
				STATE.settings_array[ SETTINGSOFFSET_ENABLE_VI_KEYS] = (
					1 - STATE.settings_array[SETTINGSOFFSET_ENABLE_VI_KEYS])
				settings_write()
			if u in ('s', 'S',):
				canvas_set_current(canvas_statistics)
				return
			if u in ('h', 'H',):
				canvas_set_current(canvas_hiscores)
				return
			if u in ('k', 'K',):
				canvas_set_current(canvas_kurtles)
				return
		for k in INPUT.keypresses:
			if k in (K_F1,):
				rtns_show_help()
			if k in (K_TAB,):
				canvas_set_current( canvas_attract)
				return
	return


##################################################################
def	canvas_waveintro(canvasop):
	if canvasop == CANVASOP_TRANSITION_OUT:
		tbb_mark_seen_items()
		return

	if canvasop != CANVASOP_UPDATE:
		return

	screen.fill( (0,0,0))

	VGAPRN.setsize(30)
	VGAPRN.color1 = (222,222,222)
	VGAPRN.justify = JUSTIFY_CENTER
	VGAPRN.zerowrite = 0
	y = 40
	VGAPRN.printf( (scrx / 2, y), "WAVE %u BEGIN!" % tbbp.waveno)
	y += 40

	y += 40

	#/ show only the "new" things you've not seen yet
	for a in xrange( len( tbbt_stringdefs)):
		s = tbbt_stringdefs[a]
		fr = CANVAS.timer >> 1
		if tbbp.counts[a] and (s != "<no desc>"):
			if tbbp.haveseen[a] == 0:
				i = a % tbbp.TBBMAXX
				j = a / tbbp.TBBMAXX
				fr += 7 + i + j
				x = 100
				# temporarily jam this into the upper left corner
				# so that the animation function can use it
				z = tbbp.field[(i,j)]
				tbbp.field[(i,j)] = a
				(n,frameno) = ui_apply_animation((i,j),fr)
				tbbp.field[(i,j)] = z
				if n >= 0:
					pygame_library_screen.blit( ASSETS.tbb_tiles[n][frameno], (x, y + 4))
					x += 40
					VGAPRN.color1 = (222,222,222)
					VGAPRN.justify = JUSTIFY_LEFT
					VGAPRN.zerowrite = 0
					VGAPRN.printf( (x, y), tbbt_stringdefs[a])
				y += 40

	if CANVAS.debounced:
		VGAPRN.setsize(20)
		VGAPRN.justify = JUSTIFY_LEFT
		VGAPRN.printf( (5, scry - 25), "F1-Help")

		VGAPRN.setsize(30)
		VGAPRN.color1 = (222,222,222)
		VGAPRN.justify = JUSTIFY_CENTER
		VGAPRN.printf( (scrx / 2, scry - 60), "Press ENTER or click to Continue")

		if (not INPUT.mousebuttons[0]) and INPUT.prevmousebuttons[0]:
			STATE.mouse_distance = 100
			canvas_set_current(canvas_playing)
			return

		for u in INPUT.unicodeses:
			if u in (chr(10), chr(13), chr(27), chr( 32), ):
				canvas_set_current(canvas_playing)
				return

		for k in INPUT.keypresses:
			if k in (K_F1,):
				rtns_show_help()

	return

##################################################################
cheat_warnings = (
	"Your high score and statistics",
	"will not be saved for this game!",
	"You will not unlock any Kurtles.",
	"Are you sure about this?",
)

##################################################################
def	canvas_playing():
	pygame_library_screen.fill( (0,0,50))

	ui_draw_field()
	ui_draw_explosions()

	ui_draw_sidebar()

	ui_draw_mouse_arrows()

	ui_introduce_you()

	tbbp.framecount += 1
	tbbp.seconds_played = 1 + int( tbbp.framecount / 30)

	if tbbp.youdead:
		tbbp.youdead += 1
		if tbbp.youdead > 60:
			if tbbp.ships > 0:
				tbbp.ships -= 1
				tbb_inityou()
				#/ allows wave to end on your death
				tbb_finalchecks()
			else:
				tbb_gameover()
	else:
		if tbbp.anyexpls:
			#/ to make sure .anyexpls gets set to zero
			tbb_tallyup()
		input_process()
		if not tbbp.waveinitted:
			canvas_set_current( canvas_waveoutro)
			return

	STATE.buttondowns = STATE.MAXBUTTONS * [0]

	for i in xrange(9):
		if STATE.buttonrects[i].collidepoint((
				INPUT.mousecursor_x, INPUT.mousecursor_y)):
			STATE.buttondowns[i] = INPUT.mousebuttons[0]
			if (not INPUT.mousebuttons[0]) and INPUT.prevmousebuttons[0]:
				tbb_docmd(arrow_layout_cmds[i])
	if STATE.buttonrects[10].collidepoint((
			INPUT.mousecursor_x, INPUT.mousecursor_y)):
		STATE.buttondowns[10] = INPUT.mousebuttons[0]
		if (not INPUT.mousebuttons[0]) and INPUT.prevmousebuttons[0]:
			tbb_docmd(TBBCMD_WAIT)
	if STATE.buttonrects[11].collidepoint((
			INPUT.mousecursor_x, INPUT.mousecursor_y)):
		STATE.buttondowns[11] = INPUT.mousebuttons[0]
		if (not INPUT.mousebuttons[0]) and INPUT.prevmousebuttons[0]:
			tbb_docmd(TBBCMD_WARP)

	for k in INPUT.keypresses:
		if k in (K_F1,):
			rtns_show_help()

	for u in INPUT.unicodeses:
		if u in (chr(27),):
			STATE.score = tbbp.score
			canvas_set_current( canvas_pause)
			return
		if u in (chr(9),):
			VGAPRN.justify = JUSTIFY_CENTER
			message_setcolor_bad(30)
			result = (
					(STATE.cheating * INPUT_RESULT_ACCEPT) or
					message_simple_yesno( (
							("Activating skip wave cheat!",) +
							cheat_warnings
			)))
			if result == INPUT_RESULT_ACCEPT:
				STATE.cheating = 1
				tbb_initwave()
				canvas_set_current( canvas_waveintro)
				return
		if u in ('X',):
			VGAPRN.justify = JUSTIFY_CENTER
			message_setcolor_bad(30)
			result = (
					(STATE.cheating * INPUT_RESULT_ACCEPT) or
					message_simple_yesno( (
							("Activating extra life cheat!",) +
							cheat_warnings
			)))
			if result == INPUT_RESULT_ACCEPT:
				STATE.cheating = 1
				if tbbp.ships < 4:
					tbbp.ships += 1
				return
		if 0:
			if u in ('a','A',):
				ai_make_1_move()

	if tbbp.gameover:
		rtns_gameover()
		return

	return

##################################################################
def	canvas_waveoutro():
	screen.fill( (0,0,50))

	ui_draw_field()
	ui_draw_explosions()

	ui_draw_sidebar()

	darkness = CANVAS.timer * 10
	if darkness > 255:
		darkness = 255
	ASSETS.dimmer.fill( (0,0,0,darkness))
	pygame_library_screen.blit( ASSETS.dimmer, (0,0))

	tbbp.framecount += 1
	tbbp.seconds_played = 1 + int( tbbp.framecount / 30)

	tbb_tallyup()

	if CANVAS.timer >= 60:
		tbb_initwave()
		canvas_set_current(canvas_waveintro)
		return

	if tbbp.gameover:
		rtns_gameover()
		return

	return

##################################################################
def	canvas_gameover(canvasop):
	if canvasop == CANVASOP_TRANSITION_IN:
		STATE.canvas_gameover_robots = []
		STATE.canvas_gameover_golds = []
		return
	if canvasop != CANVASOP_UPDATE:
		return

	w = scrx / 2 - 40
	y = 300
	h = 130
	rect_robots = pygame.Rect( 20,            y, w, h)
	rect_golds  = pygame.Rect( scrx / 2 + 20, y, w, h)

	redness = 155 - CANVAS.timer
	if redness < 0:
		redness = 0
	screen.fill( (redness,0,0))

	VGAPRN.setsize(30)
	VGAPRN.color1 = (222,222,222)
	VGAPRN.justify = JUSTIFY_CENTER
	VGAPRN.zerowrite = 0
	y = 40
	VGAPRN.printf( (scrx / 2, y), "GAME OVER!")
	y += 40

	temp_tbbstats_robots_destroyed  = 0
	temp_tbbstats_dollars_collected = 0

	temp_tbbstats_robots_destroyed = CANVAS.timer
	if temp_tbbstats_robots_destroyed > tbbp.tbbstats_robots_destroyed:
		temp_tbbstats_robots_destroyed = tbbp.tbbstats_robots_destroyed
	else:
		STATE.canvas_gameover_robots.append( RandomRect( rect_robots))
	temp_tbbstats_dollars_collected = CANVAS.timer
	if temp_tbbstats_dollars_collected > tbbp.tbbstats_dollars_collected:
		temp_tbbstats_dollars_collected = tbbp.tbbstats_dollars_collected
	else:
		STATE.canvas_gameover_golds.append( RandomRect( rect_golds))

	statistics_table = (
		("Base score:", "%u" % tbbp.basescore),
		("Bonus for lives:", "%u" % tbbp.bonus_livesremaining),
		("Bonus for speed (%u SPM):" % tbbp.scoreperminute, "%u" % tbbp.bonus_speedplay),
		0,
		("Final score:", "%u" % tbbp.score),
		("Final moves (max %u):" % tbbp.maxmoveno, "%u" % tbbp.moveno),
		("Final wave:", "%u" % tbbp.waveno),
		0,
		("Robots destroyed:", "%u" % temp_tbbstats_robots_destroyed),
		("Gold collected:", "%u" % temp_tbbstats_dollars_collected),
		("Gold lost:", "%u" % tbbp.tbbstats_dollars_lost),
	)
	VGAPRN.setsize(20)
	VGAPRN.color1 = (222,222,222)
	for s in statistics_table:
		if s:
			VGAPRN.justify = JUSTIFY_LEFT
			VGAPRN.printf( (100, y), s[0])
			VGAPRN.justify = JUSTIFY_RIGHT
			VGAPRN.printf( (scrx - 100, y), s[1])
			y += 20
		else:
			y += 10

	#/ <WIP> show a visual pile of all destroyed robots here
	#/ <WIP> show a visual pile of all collected gold here
	if 0:
		pygame.draw.rect( pygame_library_screen, (0,50,50), rect_golds)
		pygame.draw.rect( pygame_library_screen, (0,50,50), rect_robots)
	for c in STATE.canvas_gameover_robots:
		s = ASSETS.tbb_tiles[TBBT_ROBOT1][0]
		# <WIP> shake some robot fists?
		# lay the robots down to die?? (doesn't really look right...)
		if 0:
			if c[0] & 1:
				s = pygame.transform.rotate( s, 90)
			else:
				s = pygame.transform.rotate( s, 270)
		plot( c, s)
	for c in STATE.canvas_gameover_golds:
		plot( c, ASSETS.tbb_tiles[TBBT_DOLLAR][0])
		# <WIP> twinkle some gold?

	if CANVAS.debounced:
		VGAPRN.setsize(30)
		VGAPRN.color1 = (222,222,222)
		VGAPRN.justify = JUSTIFY_CENTER
		VGAPRN.printf( (scrx / 2, scry - 40), "Press ENTER to Continue")
		for u in INPUT.unicodeses:
			if u in (chr(10), chr(13), chr(27), chr( 32), ):
				canvas_set_current(canvas_statistics, canvas_greet)
		for k in INPUT.keypresses:
			if k in (K_F1,):
				rtns_show_help()

	return


##################################################################
class	MINIOBJ:
	def	__init__(self):
		self.x = 0
		self.y = 0
		self.type = 0
		return

##################################################################
class	tbbgame:
	def	__init__(self):
		return

tbbp = tbbgame()

##################################################################
#/ ORIGINAL TBB.H:

##################################################################
#/ the actual denizens of turn based botz world
TBBT_BLANK = 0
TBBT_YOU = 1
TBBT_ROBOT1 = 2
TBBT_ROBOT2 = 3					#/ can move diagonally!
TBBT_DOLLAR = 4
TBBT_ELECTRODE = 5
TBBT_BRICK = 6						#/ unbreakable
TBBT_STONE1 = 7					#/ almost broken
TBBT_STONE2 = 8
TBBT_STONE3 = 9					#/ toughest
TBBT_BOMBOFF = 10			#/ unarmed
TBBT_BOMBON = 11				#/ it has been nudged
TBBT_BOMBARMED = 12		#/ will explode at end of turn
TBBT_BOMBFLAME = 13		#/ keeps killing
TBBT_MINE = 14
TBBT_WARPLINK = 15
TBBT_CORPSE = 16
TBBT_EXTRALIFE = 17
TBBT_EXTRAMOVES = 18
TBBT_TIMES2	= 19
TBBT_TIMES3	= 20
TBBT_TIMES4	= 21
TBBT_TIMES5	= 22
TBBT_MAXIMUM = 24

##################################################################
tbbt_stringdefs = TBBT_MAXIMUM * ["<no desc>"]

tbbt_stringdefs[ TBBT_BLANK]		= "Blank open space"
tbbt_stringdefs[ TBBT_BRICK]		= "Brick - impassable"
tbbt_stringdefs[ TBBT_STONE1]		= "Loose rubble - touch to clear"
tbbt_stringdefs[ TBBT_STONE2]		= "Loose-packed stone"
tbbt_stringdefs[ TBBT_STONE3]		= "Hard-packed stone"
tbbt_stringdefs[ TBBT_YOU]			= "You!"
tbbt_stringdefs[ TBBT_ROBOT1]		= "Basic Robot"
tbbt_stringdefs[ TBBT_ROBOT2]		= "Uber Robot - CAUTION!!"
tbbt_stringdefs[ TBBT_DOLLAR]		= "Gold - harvest for points!"
tbbt_stringdefs[ TBBT_ELECTRODE]	= "Electrode - DANGER!"
tbbt_stringdefs[ TBBT_BOMBOFF]		= "Jostle Bomb - touch to arm it"
tbbt_stringdefs[ TBBT_WARPLINK]		= "Warp link - teleports randomly"
tbbt_stringdefs[ TBBT_EXTRALIFE]	= "Extra life - collect it!"
tbbt_stringdefs[ TBBT_EXTRAMOVES]	= "Extra moves - grab 'em!"
tbbt_stringdefs[ TBBT_TIMES2]		= "Gold earns 2x points!"
tbbt_stringdefs[ TBBT_TIMES3]		= "Gold earns 3x points!"
tbbt_stringdefs[ TBBT_TIMES4]		= "Gold earns 4x points!"
tbbt_stringdefs[ TBBT_TIMES5]		= "Gold earns 5x points!"

##################################################################
#/ the commands you can pass into the game world
TBBCMD_NULL  = 0			#/ do nothing
TBBCMD_WAIT  = 1			#/ wait in place (do 1 turn)
TBBCMD_MOVE0 = 2			#/ north
TBBCMD_MOVE1 = 3			#/ north-east
TBBCMD_MOVE2 = 4			#/ east
TBBCMD_MOVE3 = 5			#/ south-east
TBBCMD_MOVE4 = 6			#/ south
TBBCMD_MOVE5 = 7			#/ south-west
TBBCMD_MOVE6 = 8			#/ west
TBBCMD_MOVE7 = 9			#/ north-west
TBBCMD_WARP  = 10			#/ warp to random location
TBBCMD_MENU = 100			#/ bring up the menu
TBBCMD_HIDE = 101			#/ hide the keypad - eh?

#/ ORIGINAL TBB.C:

##################################################################
def	tbb_initgame():
	tbbu_dirty_all()

	tbbp.basescore = 0
	tbbp.score		= 0
	tbbp.ships		= 3
	tbbp.waveno	= 0
	tbbp.moveno	= 0
	tbbp.maxmoveno	= 500
	tbbp.scoreperminute = 0

	if tbbp.boardtype == BOARDTYPE_ALLSCREEN:
		tbbp.maxmoveno += 200

	tbbp.framecount = 0
	tbbp.seconds_played = 0

	tbbp.youdead = 0
	tbbp.deathreason = ""
	tbbp.deathcounter = 0

	tbbp.waveinitted = 0
	tbbp.gameover = 0

	tbbp.times_multiplier = 1

	tbbp.haveseen = TBBT_MAXIMUM * [0]

	tbbp.counts = TBBT_MAXIMUM * [0]
	tbbp.anyexpls = 0

	#/ reset statistics before each game
	tbbp.tbbstats_robots_destroyed  = 0
	tbbp.tbbstats_dollars_collected = 0
	tbbp.tbbstats_dollars_lost      = 0

	tbbp.bonus_livesremaining = 0
	tbbp.bonus_speedplay = 0

	tbbp.expls = dict()
	tbbp.animseq = dict()

	tbbp.field = dict()

	for j in xrange( tbbp.TBBMAXY):
		for i in xrange( tbbp.TBBMAXX):
			tbb_set( (i,j), TBBT_BLANK)

	tbbp.introyou_timer = 0

	tbbp.carryover_robot1 = 0
	tbbp.carryover_robot2 = 0

	return

##################################################################
def	tbb_tally_robot_destroyed(numdestroyed=1):
	tbbp.tbbstats_robots_destroyed += numdestroyed
	if STATE.cheating:
		return
	# achievement (kurtles) checks here
	total_robots_destroyed = (tbbp.tbbstats_robots_destroyed +
		STATISTICS.tally_total[STATTYPE_ROBOTS_DESTROYED]
	)
	if total_robots_destroyed >= 100:
		kurtle_100_robots.unlock()
	if total_robots_destroyed >= 1000:
		kurtle_1000_robots.unlock()
	if total_robots_destroyed >= 10000:
		kurtle_10000_robots.unlock()
	return

##################################################################
def	tbb_check_completed_waves():
	if STATE.cheating:
		return
	total_waves_completed = (
		STATISTICS.tally_total[STATTYPE_WAVE_COMPLETED] +
		(tbbp.waveno - 1)
	)
	if total_waves_completed >= 1000:
		kurtle_1000_waves.unlock()
	return

##################################################################
def	tbb_tally_gold_collected(gold=1):
	tbbp.tbbstats_dollars_collected += gold
	if STATE.cheating:
		return
	# achievement (kurtles) checks here
	total_gold_collected = (tbbp.tbbstats_dollars_collected +
		STATISTICS.tally_total[STATTYPE_GOLD_COLLECTED]
	)
	if total_gold_collected >= 1000:
		kurtle_1000_gold.unlock()
	return

##################################################################
def	tbb_set( (x,y), c):
	if (x >= 0) and (x < tbbp.TBBMAXX) and (y >= 0) and (y < tbbp.TBBMAXY):
		tbbp.field[(x,y)] = c
		tbbu_dirty_xy( (x, y))
	else:
		assert 0, ("tbb_set: bad coords: (%d,%d)" % (x, y))
	return

##################################################################
def	tbb_get((x,y)):
	if (x >= 0) and (x < tbbp.TBBMAXX) and (y >= 0) and (y < tbbp.TBBMAXY):
		return tbbp.field[(x,y)]
	return TBBT_BRICK

##################################################################
def	tbb_findrandomopen():
	for retries in xrange(10000):
		x = Random( tbbp.TBBMAXX)
		y = Random( tbbp.TBBMAXY)
		if (tbb_get((x,y)) == TBBT_BLANK):
			return (x,y)
	#/ if this fails to find an open one, oh well, it overwrites!!
	return (x,y)

##################################################################
def	tbb_sprinkle_random( type, count):
	while count > 0:
		(x,y) = tbb_findrandomopen()
		tbb_set( (x, y), type)
		count -= 1
	return

##################################################################
def	tbb_inityou():
	#/ remove any corpses that might be about
	for j in xrange( tbbp.TBBMAXY):
		for i in xrange( tbbp.TBBMAXX):
			c = tbb_get((i,j))
			if c == TBBT_CORPSE:
				tbb_set((i,j), TBBT_BLANK)
				tbbu_dirty_xy( (i, j))

	(x,y) = tbb_findrandomopen()
	tbb_set( (x, y), TBBT_YOU)
	tbbp.youx = x
	tbbp.youy = y

	introyou_reset()

	tbbp.youdead = 0
	tbbp.deathreason = ""

	tbbu_dirty_all()

	return

##################################################################
def	tbb_choose_wall_tile(canzero):
	if (canzero):
		n = Random( 8)
	else:
		n = 1 + Random( 7)

	if n == 0:
		return TBBT_BLANK
	elif n == 1:
		return TBBT_BRICK
	elif n == 2 :
		return TBBT_STONE1
	elif n == 3 :
		return TBBT_STONE2
	elif n == 4 :
		return TBBT_STONE3
	elif n == 5 :
		return TBBT_ELECTRODE
	elif n == 6 :
		return TBBT_BOMBOFF
	elif n == 7 :
		return TBBT_DOLLAR

	return TBBT_BLANK

##################################################################
def	tbb_initwave():
	tbbp.waveinitted = 1

	#/ all this taken from original BASIC prototype...

	tbbp.waveno += 1

	tbb_check_completed_waves()

	if not STATE.cheating:
		if tbbp.waveno >= 11:
			if tbbp.deathcounter == 0:
				kurtle_untouchable.unlock()
		if tbbp.waveno >= 27:
			kurtle_marathon_man.unlock()

	if 0:
		print "tbb_initwave(); waveno = %u" % tbbp.waveno

	#/ choose size of playable area
	tbbp.xsz = 8 + tbbp.waveno
	tbbp.ysz = 7 + tbbp.waveno

	if tbbp.boardtype == BOARDTYPE_ALLSCREEN:
		tbbp.xsz += 4
		tbbp.ysz += 2

	if tbbp.xsz >= tbbp.TBBMAXX:
		tbbp.xsz = tbbp.TBBMAXX
	if tbbp.ysz >= tbbp.TBBMAXY:
		tbbp.ysz = tbbp.TBBMAXY

	if tbbp.waveno >= 13:
		tbbp.xsz -= (tbbp.waveno % 5)
		tbbp.ysz -= (tbbp.waveno % 4)

	tbbp.ulx = (tbbp.TBBMAXX - tbbp.xsz) / 2
	tbbp.uly = (tbbp.TBBMAXY - tbbp.ysz) / 2

	if tbbp.times_multiplier < 1:
		tbbp.times_multiplier = 1

	#/ clear entire screen to brick (impassable)
	#/ and clear explosions and animseqs too
	for j in xrange( tbbp.TBBMAXY):
		for i in xrange( tbbp.TBBMAXX):
			tbb_set( (i,j), TBBT_BRICK)
			tbbp.expls[(i,j)] = 0
			tbbp.animseq[(i,j)] = 0

	#/ clear playable area to blank
	for j in xrange( tbbp.ysz):
		for i in xrange( tbbp.xsz):
			tbb_set( (tbbp.ulx + i, tbbp.uly + j), TBBT_BLANK)

	#/ 10/16/2004 - now some possible walls and boxes...
	if tbbp.waveno > 5:
		n = Random(10)
		if n == 0:			#/ horizontal wall
			if ((tbbp.xsz > 4) and
				(tbbp.ysz > 4)):		#/ cross-check just in case!
				pre_chosen = 0		#/ are we pre-choosing?
				pre_chosen = tbb_choose_wall_tile( 1)
				w = Random( tbbp.xsz)
				if w < 3:
					w = 3		#/ minimum wall length
				x = tbbp.ulx + Random( (tbbp.xsz - w) + 1)
				y = tbbp.uly + 1 + Random( tbbp.ysz - 2)
				for i in xrange(w):
					if pre_chosen:
						tbb_set( (x + i, y), pre_chosen)
					else:
						tbb_set( (x + i, y), tbb_choose_wall_tile(0))
		elif n == 1 :			#/ vertical wall
			if ((tbbp.xsz > 4) and
				(tbbp.ysz > 4)):	#/ cross-check just in case!
				pre_chosen = 0		#/ are we pre-choosing?
				pre_chosen = tbb_choose_wall_tile( 1)
				h = Random( tbbp.ysz)
				if h < 3:
					h = 3	#/ minimum wall length
				x = tbbp.ulx + 1 + Random( tbbp.xsz - 2)
				y = tbbp.uly + Random( (tbbp.ysz - h) + 1)
				for j in xrange(h):
					if pre_chosen:
						tbb_set( (x, y + j), pre_chosen)
					else:
						tbb_set( (x, y + j), tbb_choose_wall_tile(0))

#/ a block of unit tests for inter-robot collisions of the different
#/ flavors of robots, and whether they are first in the process
#/ list or second.  Sweet, it works now!  10/17/2004 for v1.2.1
	if 0:
		tbb_set( (11,  7), TBBT_ROBOT2)
		tbb_set( (12,  7), TBBT_ROBOT2)
		tbb_set( (9,  7), TBBT_BRICK)
		tbb_set( (11, 11), TBBT_DOLLAR)
		tbb_inityou()
		tbb_set( (tbbp.youx, tbbp.youy), TBBT_BLANK)
		tbbp.youx =  7
		tbbp.youy =  7
		tbb_set( (tbbp.youx, tbbp.youy), TBBT_YOU)
		tbbu_dirty_all()
		return

	#/ convert original QBASIC code here...

	#/ how many bricks?
	numbricks = Random( 1 + (tbbp.waveno - 1) * 2)

	if tbbp.boardtype == BOARDTYPE_ALLSCREEN:
		numbricks *= 2

	#/ quite frequently you get no bricks
	if Random(2) == 0:
		numbricks = 0

	blocktypes = [
			TBBT_BRICK,
			TBBT_BRICK,
			TBBT_STONE1,
			TBBT_STONE1,
			TBBT_STONE2,
			TBBT_STONE3,
	]

	for i in xrange(numbricks):
		c = RandomList( blocktypes)
		tbb_sprinkle_random( c, 1)

	#/ how much gold (dollars)?
	numdollars = tbbp.waveno + 3

	if tbbp.boardtype == BOARDTYPE_ALLSCREEN:
		numdollars = numdollars + numdollars / 2

	tbb_sprinkle_random( TBBT_DOLLAR, numdollars)

	#/ how many robots?
	numrobot1s = tbbp.waveno + 1

	if tbbp.boardtype == BOARDTYPE_ALLSCREEN:
		numrobot1s = numrobot1s + numrobot1s / 2 + 1

	if 0:
		if tbbp.carryover_robot1:
			print "Carrying over %u ROBOT1s!" % tbbp.carryover_robot1

	numrobot1s += tbbp.carryover_robot1

	if numrobot1s > 30:
		numrobot1s = 30
	tbb_sprinkle_random( TBBT_ROBOT1, numrobot1s)

	numrobot2s = 0

	robot2_frequency = 7
	if tbbp.boardtype == BOARDTYPE_ALLSCREEN:
		robot2_frequency = 6

	#/ any uber-robots?? (they are rather rare!)
	if (tbbp.waveno % robot2_frequency) == 0:
		numrobot2s = tbbp.waveno / robot2_frequency
		if numrobot2s > 4:
			numrobot2s = 4
	if 0:
		if tbbp.carryover_robot2:
			print "Carrying over %u ROBOT2s!" % tbbp.carryover_robot2

	numrobot2s += tbbp.carryover_robot2
	tbb_sprinkle_random( TBBT_ROBOT2, numrobot2s)

	if 0:
		tbb_sprinkle_random( TBBT_ROBOT2, 3)
		tbb_sprinkle_random( TBBT_BOMBOFF, 10)

	#/ how many electrodes?
	numelectrodes = Random( 6 + (tbbp.waveno / 4))
	#/ sometimes you get no electrodes... and you LIKE it!
	if ((Random(3) == 0) or (tbbp.waveno < 3)):
		numelectrodes = 0

	#/ BUT, if there are Uber robots, there are always electrodes
	#/ because they actually protect you!
	if numelectrodes == 0:
		if numrobot2s > 0:
			numelectrodes = 3 + Random( 3)

	tbb_sprinkle_random( TBBT_ELECTRODE, numelectrodes)

	#/ add a warp link maybe??
	if tbbp.waveno >= 3:
		if (tbbp.waveno % 4) == 1:
			tbb_sprinkle_random( TBBT_WARPLINK, 1)

	#/ any bombs?
	if tbbp.waveno >= 3:
		tbb_sprinkle_random( TBBT_BOMBOFF, ((not Random(3)) * (1 + Random( 3))))

	#/ add a multiplier maybe
	if (tbbp.waveno % 4) == 0:
		if tbbp.times_multiplier == 1:
			tbb_sprinkle_random( TBBT_TIMES2, 1)
		elif tbbp.times_multiplier == 2:
			tbb_sprinkle_random( TBBT_TIMES3, 1)
		elif tbbp.times_multiplier == 3:
			tbb_sprinkle_random( TBBT_TIMES4, 1)
		elif tbbp.times_multiplier == 4:
			tbb_sprinkle_random( TBBT_TIMES5, 1)
		else:
			pass

	#/ add an extra life maybe
	if (tbbp.waveno % 10) == 0:
		tbb_sprinkle_random( TBBT_EXTRALIFE, 1)

	#/ add an extra timer maybe
	if (tbbp.waveno % 4) == 3:
		tbb_sprinkle_random( TBBT_EXTRAMOVES, 1)

	#/ finally stick you on
	tbb_inityou()

	tbbu_dirty_all()

	tbb_tallyup()

	return

##################################################################
def	tbb_youdied( deathreason):
	#print "tbb_youdied( '%s')" % deathreason

	sound_death1()

	#/ only the first reason you died counts
	if tbbp.youdead == 0:
		tbbp.youdead = 1
		tbbp.deathreason = deathreason
		tbbp.deathcounter += 1

	return

##################################################################
def	tbb_addscore( points):
	converted_points = int( points * tbbp.waveno * tbbp.times_multiplier)
	tbbp.score = tbbp.score + converted_points
	return converted_points

##################################################################
def	tbb_explodexy( (x, y)):
	if tbbp.expls[(x,y)] == 0:
		tbbp.expls[(x,y)] = 1
	return

##################################################################
def	tbb_touchbombxy( (x, y)):
	#/ switches "on" an "off" bomb...
	if tbbp.field[(x,y)] == TBBT_BOMBOFF:
		tbbp.field[(x,y)] = TBBT_BOMBON
		tbbu_dirty_xy( (x, y))
	return

##################################################################
def	tbb_remove_random_item( tbbtype):
	for retries in xrange( 10000):
		x = Random( tbbp.TBBMAXX)
		y = Random( tbbp.TBBMAXY)
		if tbbp.field[(x,y)] == tbbtype:
			tbbp.field[(x,y)] = TBBT_BLANK
			tbbu_dirty_xy( (x, y))
			tbb_explodexy( (x, y))
			if tbbtype == TBBT_DOLLAR:
				tbbp.tbbstats_dollars_lost += 1
			return
	return

##################################################################
def	tbb_remove_random_item_minimum( tbbtype, minimum):
	#/ run a fresh histogram
	tbb_tallyup()

	if tbbp.counts[tbbtype] > minimum:
		#/ find a random one and remove it
		tbb_remove_random_item( tbbtype)
		return 1

	#/ couldn't do it
	return 0

##################################################################
def	tbb_moveyou( youxm, youym):
	tbb_set( (tbbp.youx, tbbp.youy), TBBT_BLANK)

	#/ 10/16/2004 - fixed undiscovered bug: x1,y1 might not be initialized
	#/ on those times when you warped and there weren't enough gold to
	#/ support your warp!  Whew!!
	x1 = tbbp.youx
	y1 = tbbp.youy

	#/ this means it was a request to warp
	if (youxm == 100) and (youym == 100):
		#/ warping now costs you one gold piece, unless it's the last gold
		#/ piece.  this avoid cheating!  You cannot warp if you cannot
		#/ remove a dollar and still have one left.
		if tbb_remove_random_item_minimum( TBBT_DOLLAR, 1):
			(x1,y1) = tbb_findrandomopen()

			#/ successful warping also costs you as many squares of movement
			#/ as you actually moved, calculated in Manhattan distance.
			tbbp.moveno = tbbp.moveno + abs( x1 - tbbp.youx)
			tbbp.moveno = tbbp.moveno + abs( y1 - tbbp.youy)

			if not STATE.cheating:
				if tbbp.moveno >= 1000:
					kurtle_1000_moves.unlock()

			introyou_reset()
	else:
		#/ move you to your new proposed location
		x1 = tbbp.youx + youxm
		y1 = tbbp.youy + youym

		#/ clip you to the available playfield
		if x1 < tbbp.ulx:
			x1 = tbbp.ulx
		if x1 >= tbbp.ulx + tbbp.xsz:
			x1 =  tbbp.ulx + tbbp.xsz - 1
		if y1 < tbbp.uly:
			y1 = tbbp.uly
		if y1 >= tbbp.uly + tbbp.ysz:
			y1 =  tbbp.uly + tbbp.ysz - 1

	#/ now see what you attempted to move into...
	c = tbb_get( (x1, y1))

	#/ switch( c)...
	if c == TBBT_BRICK :			#/ impassable
		x1 = tbbp.youx
		y1 = tbbp.youy
	elif (
				(c == TBBT_STONE3) or			#/ stone3 becomes stone2
				(c == TBBT_STONE2) or			#/ stone2 becomes stone1
				(c == TBBT_STONE1) or			#/ stone1 becomes blank
		0):
		tbbu_dirty_xy( (x1, y1))
		tbbp.field[(x1,y1)] -= 1		# degrade the stone
		if c == TBBT_STONE1:
			tbbp.field[(x1,y1)] = TBBT_BLANK
			tbb_explodexy( (x1, y1))
		x1 = tbbp.youx
		y1 = tbbp.youy
		sound_fire2()
	elif c == TBBT_WARPLINK:		#/ teleport randomly
		(x1,y1) = tbb_findrandomopen()
		sound_fire1()
		introyou_reset()
	elif c == TBBT_ROBOT1 :
		tbb_youdied( "RAN INTO A ROBOT!")
		tbb_tally_robot_destroyed()
	elif c == TBBT_ROBOT2 :
		tbb_youdied( "RAN INTO AN UBER-ROBOT!")
		tbb_tally_robot_destroyed()
	elif c == TBBT_ELECTRODE :
		tbb_youdied( "RAN INTO AN ELECTRODE!")
		#/ note: this destroys the electrode too
	elif c == TBBT_DOLLAR :
		tbb_addscore( 1)
		sound_fire1()
		tbb_tally_gold_collected()
	elif (
				(c == TBBT_BOMBOFF) or			#/ you stop against bomb, and touch it!
				(c == TBBT_BOMBON) or
				(c == TBBT_BOMBARMED) or
		0):
		tbb_touchbombxy( (x1, y1))
		x1 = tbbp.youx
		y1 = tbbp.youy
		sound_fire2()
	elif c == TBBT_EXTRALIFE :		#/ you collect an extra life
		tbbp.ships = tbbp.ships + 1
		#/ make some kind of extra life sound
		sound_bonus()
	elif c == TBBT_EXTRAMOVES :		#/ you are allowed extra moves
		tbbp.maxmoveno += 10 * (5 + Random(16))

		if tbbp.boardtype == BOARDTYPE_ALLSCREEN:
			tbbp.maxmoveno += 50 + (5 * Random(10))
		#/ some kind of extra moves sound?
		sound_fire1()
	elif c == TBBT_TIMES2 :
		tbbp.times_multiplier = 2
		#/ some kind of extra moves sound?
		sound_fire1()
	elif c == TBBT_TIMES3 :
		tbbp.times_multiplier = 3
		#/ some kind of extra moves sound?
		sound_fire1()
	elif c == TBBT_TIMES4 :
		tbbp.times_multiplier = 4
		#/ some kind of extra moves sound?
		sound_fire1()
	elif c == TBBT_TIMES5 :
		if not STATE.cheating:
			kurtle_max_multiplier.unlock()
		tbbp.times_multiplier = 5
		#/ some kind of extra moves sound?
		sound_fire1()

	if tbbp.youdead:
		tbb_set( (x1, y1), TBBT_CORPSE)
	else:
		tbb_set( (x1, y1), TBBT_YOU)

	tbbp.youx = x1
	tbbp.youy = y1

	return

##################################################################
#/
#/ tally up each different thing (build a histogram)
#/
def	tbb_tallyup():
	tbbp.counts = TBBT_MAXIMUM * [0]
	tbbp.anyexpls = 0
	for j in xrange( tbbp.TBBMAXY):
		for i in xrange( tbbp.TBBMAXX):
			c = tbbp.field[(i,j)]
			if (c >= 0) and (c < TBBT_MAXIMUM):
				tbbp.counts[c] += 1
			if tbbp.expls[(i,j)]:
				tbbp.anyexpls = 1

	if 0:
		print "tbb_tallyup():"
		for i in xrange( TBBT_MAXIMUM):
			print "%u" % tbbp.counts[i],
		print

	return

##################################################################
#/
#/ mark the things we tallied up as having been seen already.
#/
def	tbb_mark_seen_items():
	for i in xrange( TBBT_MAXIMUM):
		if tbbp.counts[i]:
			tbbp.haveseen[i] = 1
	return

##################################################################
def	tbb_movethem():
#/ take all robots offscreen, put them into the MINIOBJ array for processing
	tbbp.mos = []
	for j in xrange( tbbp.TBBMAXY):
		for i in xrange( tbbp.TBBMAXX):
			c = tbbp.field[(i,j)]
			if ( c == TBBT_ROBOT1) or (c == TBBT_ROBOT2):
				mop = MINIOBJ()
				mop.x = i
				mop.y = j
				mop.type = c
				tbbp.mos.append(mop)
				tbbp.field[(i,j)] = TBBT_BLANK
				tbbu_dirty_xy( (i, j))

	robot_count_start = len( tbbp.mos)

	if 0:
		print "tbb_movethem: we found %u robots" % len( tbbp.mos)

	def	put_it_back(mop):
		#/ what if we're NOT moving, and a robot already occupies
		#/ this spot?! We weren't handling this until 10/17/2004
		c2 = tbbp.field[(mop.x,mop.y)]
		if c2 == TBBT_ROBOT1:
			tbb_explodexy( (mop.x, mop.y))
			tbb_tally_robot_destroyed()			#/ him
			tbbp.field[(mop.x,mop.y)] = TBBT_BLANK		#/ *BOOM*
			tbbu_dirty_xy( (mop.x, mop.y))
			if mop.type == TBBT_ROBOT1:
				tbb_tally_robot_destroyed()			#/ me
				return
		if c2 == TBBT_ROBOT2:
			tbb_explodexy( (mop.x, mop.y))
			tbb_tally_robot_destroyed()			#/ me
			#/ only an uber robot can kill another uber robot!
			if mop.type == TBBT_ROBOT2:
				tbb_tally_robot_destroyed()				#/ him
				tbbp.field[(mop.x,mop.y)] = TBBT_BLANK		#/ *BOOM*
			tbbu_dirty_xy( (mop.x, mop.y))
			return
		#/ stick 'im back on!
		tbbp.field[(mop.x,mop.y)] = mop.type
		tbbu_dirty_xy( (mop.x, mop.y))
		return

	#/ now move all the robots towards you
	for i in xrange( len( tbbp.mos)):
		mop = tbbp.mos[i]
		if (
					(mop.type == TBBT_ROBOT1) or		#/ Basic robot
					(mop.type == TBBT_ROBOT2) or		#/ UBER robot
			0):
			dx = (tbbp.youx - mop.x)
			dy = (tbbp.youy - mop.y)

			# prevent ROBOT1s from moving diagonally
			if mop.type == TBBT_ROBOT1:
				if abs(dx) > abs(dy):		#/ move primarily in the X direction?
					dy = 0
				else:
					if abs(dx) < abs(dy):		#/ move primarily in the Y direction?
						dx = 0
					else:
						#/ at this point you are 45 degrees away, so
						#/ you could move in either direction
						if Random(10) == 0:		#/ do nothing 10% of the time
							dx = 0
							dy = 0
						else:
							if Random(2):	#/ halfsies-halfsies
								dx = 0
							else:
								dy = 0

			xm = SIGN( dx)
			ym = SIGN( dy)

			x1 = mop.x + xm
			y1 = mop.y + ym

			tbbu_dirty_xy( (x1, y1))
			tbbu_dirty_xy( (mop.x, mop.y))

			#/ did we hit the player?
			if (x1 == tbbp.youx) and (y1 == tbbp.youy):
				if mop.type == TBBT_ROBOT2:
					tbb_youdied( "AN UBER-ROBOT STOMPED YOU!")
				else:
					tbb_youdied( "A ROBOT STOMPED YOU!")

				tbb_tally_robot_destroyed()
				mop.x = x1
				mop.y = y1

				#/ robot becomes your corpse basically
				mop.type = TBBT_CORPSE
				put_it_back(mop)
				continue

			#/ now what has this robot moved onto here?
			c = tbbp.field[(x1,y1)]
			if c == TBBT_DOLLAR:		#/ robot grabs gold back
				#/ tally stolen gold
				tbbp.tbbstats_dollars_lost += 1

			if (
						(c == TBBT_DOLLAR) or				#/ fall-through
						(c == TBBT_EXTRALIFE) or			#/ bummer dude!!
						(c == TBBT_EXTRAMOVES) or	#/ you lose your extra moves
						(c == TBBT_TIMES2) or					#/ sorry, these go too!
						(c == TBBT_TIMES3) or					#/ sorry, these go too!
						(c == TBBT_TIMES4) or					#/ sorry, these go too!
						(c == TBBT_TIMES5) or					#/ sorry, these go too!
						(c == TBBT_BLANK) or					#/ go ahead and move to it
				0):
				mop.x = x1
				mop.y = y1

			if c == TBBT_STONE3:		#/ robot freezes, stone3 becomes stone2
				#/ Uber robots RIP right through stone
				if mop.type == TBBT_ROBOT2:
					mop.x = x1
					mop.y = y1
					tbb_explodexy( (x1, y1))
				tbbp.field[(x1,y1)] = TBBT_STONE2
				tbbu_dirty_xy( (x1, y1))

			if c == TBBT_STONE2:		#/ robot freezes, stone2 becomes stone1
				#/ Uber robots RIP right through stone
				if mop.type == TBBT_ROBOT2:
					mop.x = x1
					mop.y = y1
					tbb_explodexy( (x1, y1))
				tbbp.field[(x1,y1)] = TBBT_STONE1
				tbbu_dirty_xy( (x1, y1))

			if c == TBBT_STONE1:		#/ robot freezes, destroys stone1
				#/ Uber robots RIP right through stone
				if mop.type == TBBT_ROBOT2:
					mop.x = x1
					mop.y = y1
					tbb_explodexy( (x1, y1))
				tbbp.field[(x1,y1)] = TBBT_BLANK
				tbbu_dirty_xy( (x1, y1))
				tbb_explodexy( (x1, y1))

			if c == TBBT_BRICK:		#/ nothing happens, the robot gets stuck on the block.
				#/ actually, ROBOT2s can pound BRICK into STONE3...
				if mop.type == TBBT_ROBOT2:
					tbbp.field[(x1,y1)] = TBBT_STONE3
					tbbu_dirty_xy( (x1, y1))
					tbb_explodexy( (x1, y1))

			if c == TBBT_BOMBFLAME:	#/ evaporates
				tbb_tally_robot_destroyed()
				continue

			if c == TBBT_ELECTRODE:	#/ robot dies, leaves the electrode in place
				tbb_tally_robot_destroyed()
				tbb_explodexy( (x1, y1))
				if Random(10) == 0:			#/ 10% chance the electrode is wiped out too
					tbbp.field[(x1,y1)] = TBBT_BLANK
				continue

			if c == TBBT_WARPLINK:		#/ teleport randomly
				(x1,y1) = tbb_findrandomopen()
				mop.x = x1
				mop.y = y1

			if c ==TBBT_BOMBOFF:		#/ stop at this bomb, touch it
				if mop.type == TBBT_ROBOT2:
					#/ <WIP> make Uber robots EXPLODE bombs immediately?
					pass

			if (
						(c == TBBT_BOMBOFF) or
						(c == TBBT_BOMBON) or
						(c == TBBT_BOMBARMED) or
				0):
				tbb_touchbombxy( (x1, y1))

			if c ==  TBBT_ROBOT1:		#/ hitting a regular robot
				tbbp.field[(x1,y1)] = TBBT_BLANK
				tbbu_dirty_xy( (x1, y1))
				tbb_explodexy( (x1, y1))
				tbb_tally_robot_destroyed()		#/ him
				if mop.type == TBBT_ROBOT2:
					#/ ROBOT2 will crush a ROBOT1
					mop.x = x1
					mop.y = y1
					put_it_back(mop)
					continue
				tbb_tally_robot_destroyed()		#/ me
				continue

			if c == TBBT_ROBOT2:		#/ STOMPS regular robots
				#/ only an uber robot can kill another uber robot!
				if mop.type == TBBT_ROBOT2:
					tbb_tally_robot_destroyed()		#/ him
					tbbp.field[(x1,y1)] = TBBT_BLANK
				tbbu_dirty_xy( (x1, y1))
				tbb_explodexy( (x1, y1))
				tbb_tally_robot_destroyed()		#/ me
				continue

			put_it_back(mop)

	tbb_tallyup()
	robot_count_now = tbbp.counts[TBBT_ROBOT1] + tbbp.counts[TBBT_ROBOT2]
	if robot_count_now < robot_count_start:
		#print "Destroyed %u robots" % (robot_count_start - robot_count_now)
		if not STATE.cheating:
			if (robot_count_start - robot_count_now) >= 8:
				kurtle_destroy_8_robots.unlock()

	return

##################################################################
def	tbb_explode_armed_bombs():
	def	explode_tile_spot((x,y)):
		tbb_explodexy( (x, y))
		tbbp.field[(x,y)] = TBBT_BOMBFLAME
		tbbu_dirty_xy( (x, y))
		return

	for j in xrange( tbbp.TBBMAXY):
		for i in xrange( tbbp.TBBMAXX):
			c = tbbp.field[(i,j)]
			if c == TBBT_BOMBARMED:
				tbbp.field[(i,j)] = TBBT_BLANK		#/ remove bomb
				tbbu_dirty_xy( (i, j))
				for l in xrange(-1, 2):
					for k in xrange(-1, 2):
						x = i + k
						y = j + l
						if (x >= 0) and (x < tbbp.TBBMAXX) and (y >= 0) and (y < tbbp.TBBMAXY):
							#/ what kind of object are we blowing up?
							c = tbbp.field[(x,y)]
							if c == TBBT_BOMBOFF :	#/ chain reaction baby!!
								tbb_explodexy( (x, y))
								tbbp.field[(x,y)] = TBBT_BOMBON
								tbbu_dirty_xy( (x, y))
							elif c == TBBT_DOLLAR:		#/ these are the things a bomb DOES blow up
								tbbp.tbbstats_dollars_lost += 1
								explode_tile_spot((x,y))
							elif (									#/ these are the things a bomb DOES blow up
									( c == TBBT_ROBOT1) or
									( c == TBBT_ROBOT2) or
								0):
								tbb_tally_robot_destroyed()
								explode_tile_spot((x,y))
							elif (							#/ these are the things a bomb DOES blow up
									( c == TBBT_EXTRALIFE) or
									( c == TBBT_EXTRAMOVES) or
									( c ==  TBBT_BLANK) or
									( c ==  TBBT_ELECTRODE) or
									( c ==  TBBT_WARPLINK) or
									( c ==  TBBT_STONE1) or
									( c ==  TBBT_STONE2) or
									( c ==  TBBT_STONE3) or
									( c ==  TBBT_TIMES2) or
									( c ==  TBBT_TIMES3) or
									( c ==  TBBT_TIMES4) or
									( c ==  TBBT_TIMES5) or
								0):
								explode_tile_spot((x,y))
							elif c == TBBT_YOU:			#/ how crispy of you!
								tbb_explodexy( (x, y))
								tbbp.field[(x,y)] = TBBT_CORPSE
								tbbu_dirty_xy( (x, y))
								tbb_youdied( "BLOWN TO SMITHEREENS!!")

	return

##################################################################
def	tbb_arm_touched_bombs():
	for j in xrange( tbbp.TBBMAXY):
		for i in xrange( tbbp.TBBMAXX):
			c = tbbp.field[(i,j)]
			if c == TBBT_BOMBON:
				tbbp.field[(i,j)] = TBBT_BOMBARMED
				tbbu_dirty_xy( (i, j))
			if c == TBBT_BOMBFLAME:
				tbbp.field[(i,j)] = TBBT_BLANK
				tbbu_dirty_xy( (i, j))
	return

##################################################################
#/
#/ this basically does all the other game processing
#/
def	tbb_calcother():
	tbb_tallyup()

	#/ only move the enemies if there are still dollars left
	if tbbp.counts[ TBBT_DOLLAR]:
		#/ explode all bombs that are armed
		tbb_explode_armed_bombs()

		#/ move the robots that are left
		tbb_movethem()

		#/ arm all bombs that are "on"
		tbb_arm_touched_bombs()

	return

##################################################################
def	tbb_gameover():
	#/ 10/27/2011 - break this out:
	#/	- keep your original base score
	tbbp.basescore = tbbp.score

	#/	- calculate bonus for extra lives
	tbbp.bonus_livesremaining = tbb_addscore( tbbp.ships * 10)

	#/	- calculate bonus for moves per minute
	print "tbb_gameover: seconds = %u" % tbbp.seconds_played
	print "tbb_gameover: moveno = %u" % tbbp.moveno
	speedplay = 0
	if tbbp.seconds_played > 10:
		speedplay = float( tbbp.moveno) / tbbp.seconds_played
	print "tbb_gameover: speedplay = %f" % speedplay
	tbbp.bonus_speedplay = tbb_addscore( speedplay)

	#/	- then go display it all in the end-game canvas
	tbbp.gameover = 1

	return

##################################################################
def	tbb_finalchecks():
	tbb_tallyup()

	tbbp.moveno += 1

	if not STATE.cheating:
		if tbbp.moveno >= 1000:
			kurtle_1000_moves.unlock()

	#/ end of game because maxmoves reached?
	if tbbp.moveno >= tbbp.maxmoveno:
		tbb_gameover()
		return

	#/ end of wave because dollars were all cleared up?
	if tbbp.counts[TBBT_DOLLAR] == 0:
		#print "No More Dollars!"
		tbbp.waveinitted = 0
		#/ tally up robots remaining, add them to the next wave
		tbbp.carryover_robot1 = tbbp.counts[TBBT_ROBOT1]
		tbbp.carryover_robot2 = tbbp.counts[TBBT_ROBOT2]
		return

	#/ end of wave because all robots are dead?
	#/ <WIP> add in any other badguys we want counted
	totalbadguys = tbbp.counts[TBBT_ROBOT1] + tbbp.counts[TBBT_ROBOT2]

	if totalbadguys == 0:
		#/ award points for outstanding gold pieces (dollars) just so
		#/ that the player doesn't need to go manually get them
		tbb_addscore( tbbp.counts[TBBT_DOLLAR])
		tbb_tally_gold_collected( tbbp.counts[TBBT_DOLLAR])
		#print "No More Robots!"
		tbbp.waveinitted = 0
		return

	return

##################################################################
def	tbb_docmd(cmd):
	if tbbp.youdead:
		return

	if tbbp.waveinitted == 0:
		return

	if cmd == TBBCMD_NULL:
		return

	tbbp.introyou_timer = 0

	if cmd ==TBBCMD_WAIT:
		tbb_moveyou( 0,  0)
	elif cmd ==TBBCMD_WARP:
		tbb_moveyou( 100, 100)
	elif cmd ==TBBCMD_MOVE0:
		tbb_moveyou( 0, -1)
	elif cmd ==TBBCMD_MOVE1:
		tbb_moveyou( 1, -1)
	elif cmd ==TBBCMD_MOVE2:
		tbb_moveyou( 1,  0)
	elif cmd ==TBBCMD_MOVE3:
		tbb_moveyou( 1,  1)
	elif cmd ==TBBCMD_MOVE4:
		tbb_moveyou( 0,  1)
	elif cmd ==TBBCMD_MOVE5:
		tbb_moveyou( -1,  1)
	elif cmd ==TBBCMD_MOVE6:
		tbb_moveyou( -1,  0)
	elif cmd ==TBBCMD_MOVE7:
		tbb_moveyou( -1, -1)

	tbb_calcother()

	if (tbbp.youdead):
		return

	tbb_finalchecks()

	return

##################################################################
def	introyou_reset():
	tbbp.introyou_timer = 30
	return

##################################################################
def	tbbu_initgame():
	return

##################################################################
def	tbbu_dirty_xy((x,y)):
	tbbp.dirty[(x,y)] = 1
	return

##################################################################
def	tbbu_dirty_all():
	tbbp.dirty = dict()
	for j in range( tbbp.TBBMAXY):
		for i in range( tbbp.TBBMAXX):
			tbbp.dirty[(i,j)] = 1
	return


##################################################################
STATE.mouse_arrow_on = 1

STATE.mouse_distance = 0

##################################################################
def	ui_apply_animation( (i,j), fr):
	n = tbbp.field[(i,j)]
	frameno = 0
	# <WIP> make frame advance decisions here
	# these are the random-frame ones
	if (
			(n == TBBT_CORPSE) or
			(n == TBBT_BOMBON) or
			(n == TBBT_BOMBARMED) or
			(n == TBBT_ELECTRODE) or
		0):
		frameno = fr % len( ASSETS.tbb_tiles[n])
	# animation at once per every other frame
	if (
			(n == TBBT_WARPLINK) or
			(n == TBBT_EXTRAMOVES) or
		0):
		tbbp.animseq[(i,j)] += 1
		frameno = (tbbp.animseq[(i,j)] >> 2) % len( ASSETS.tbb_tiles[n])
	# irregularly-starting animation
	if (
			( n == TBBT_DOLLAR) or
			( n == TBBT_ROBOT1) or
			( n == TBBT_ROBOT2) or
		0):
		if tbbp.animseq[(i,j)] == 0:
			if Random(10) == 0:
				if STATE.irregulartimer > 0:
					STATE.irregulartimer -= 1
				else:
					STATE.irregulartimer = 10 + Random(10)
					tbbp.animseq[(i,j)] = 1
		if tbbp.animseq[(i,j)]:
			tbbp.animseq[(i,j)] += 1
			frameno = (tbbp.animseq[(i,j)] - 2) >> 1
			if frameno >= len( ASSETS.tbb_tiles[n]):
				tbbp.animseq[(i,j)] = 0		# done animating
				frameno = 0
	return (n, frameno)

##################################################################
def	ui_draw_field():
	# this "framerandomizer" crap essentially gets us a pseudo-random
	# frame on a less-than per-frame basis
	if (CANVAS.timer & 1) == 0:
		STATE.framerandomizer = Random(100)
	fr = STATE.framerandomizer
	for j in range( tbbp.TBBMAXY):
		for i in range( tbbp.TBBMAXX):
			fr += 7 + i + j		# this magic number is just sort of a random-advancer kinda thingy
			x = rtns_tilex(i)
			y = rtns_tiley(j)
			(n,frameno) = ui_apply_animation( (i,j), fr)
			if n >= 0:
				shape = ASSETS.tbb_tiles[n][frameno]
				# clone and colorize any assets here
				if n == TBBT_CORPSE:
					shape = shape.copy()
					colorize_surface( shape, (Random(256), Random(256), Random(256)))
				# you
				if (
						( n == TBBT_YOU) or
					0):
					if tbbp.introyou_timer:
						if CANVAS.timer & 4:
							continue
				pygame_library_screen.blit( shape, (x, y))
	return

##################################################################
def	ui_draw_explosions():
	for j in range( tbbp.TBBMAXY):
		for i in range( tbbp.TBBMAXX):
			if tbbp.expls[(i,j)]:
				frameno = (tbbp.expls[(i,j)] - 1) >> 1
				tbbp.expls[(i,j)] += 1
				if frameno >= len( ASSETS.tile_explosions):
					tbbp.expls[(i,j)] = 0
					continue
				x = rtns_tilex(i)
				y = rtns_tiley(j)
				pygame_library_screen.blit( ASSETS.tile_explosions[frameno], (x, y))
	return

##################################################################
arrow_layout_order = (
	7,
	0,
	1,
	6,
	-1,
	2,
	5,
	4,
	3,
)

arrow_layout_cmds = (
	TBBCMD_MOVE7,
	TBBCMD_MOVE0,
	TBBCMD_MOVE1,
	TBBCMD_MOVE6,
	TBBCMD_NULL,
	TBBCMD_MOVE2,
	TBBCMD_MOVE5,
	TBBCMD_MOVE4,
	TBBCMD_MOVE3,
)

waitwarp = ["WAIT", "WARP"]

##################################################################
STATE.MAXBUTTONS = 12
STATE.buttondowns = STATE.MAXBUTTONS * [0]
STATE.buttonrects = []
for a in xrange(STATE.MAXBUTTONS):
	STATE.buttonrects.append( pygame.Rect(0,0,0,0))

##################################################################
def	ui_choose_button_colors(down):
	if down:
		return (
			( 30, 30, 30),
			( 50, 50, 50),
			(110,110,110),
		)
	return (
		(110,110,110),
		( 80, 80, 80),
		( 30, 30, 30),
	)

##################################################################
def	ui_draw_raw_button( x, y, w, h, w2, h2, down):
	(c1,c2,c3) = ui_choose_button_colors(down)
	pygame.draw.rect( pygame_library_screen, c2, (x - w2, y - h2, w, h))
	pygame.draw.line( pygame_library_screen, c1, (x - w2, y - h2), ((x - w2) + w,  y - h2),      2)
	pygame.draw.line( pygame_library_screen, c1, (x - w2, y - h2), ((x - w2),     (y - h2) + h), 2)
	pygame.draw.line( pygame_library_screen, c3, ((x - w2) + w, (y - h2) + h), ((x - w2) + w,  y - h2),      2)
	pygame.draw.line( pygame_library_screen, c3, ((x - w2) + w, (y - h2) + h), ((x - w2),     (y - h2) + h), 2)
	return

##################################################################
def	ui_draw_unified_button(x,y,w,h,butno):
	w2 = w / 2
	h2 = h / 2
	ui_draw_raw_button( x, y, w, h, w2, h2, STATE.buttondowns[butno])
	r = STATE.buttonrects[butno]
	r.x = x - w2
	r.y = y - h2
	r.w = w
	r.h = h
	return

##################################################################
STATE.sidebar_boardtype_allscreen_ysz = 40
STATE.sidebar_boardtype_allscreen_bitmap = pygame.Surface( (scrx, STATE.sidebar_boardtype_allscreen_ysz)).convert_alpha()
STATE.sidebar_boardtype_allscreen_is_at_top = 1

def	ui_draw_sidebar_for_boardtype_allscreen():
	# chase (adjust) the ui bar according to where you are onscreen
	if tbbp.youy < 8:
		STATE.sidebar_boardtype_allscreen_is_at_top = 0
	if tbbp.youy >= tbbp.TBBMAXY - 8:
		STATE.sidebar_boardtype_allscreen_is_at_top = 1
	# how are we going to color this?
	COLOR_SIDEBAR_BACKGROUND = (  0,  0,  0,128)
	COLOR_DIVIDER_LINE       = (  0,  0,  0)
	COLOR_TEXT_HEADER        = (111,255,111)
	COLOR_TEXT_DATA          = (255,255,111)
	STATE.sidebar_boardtype_allscreen_bitmap.fill(COLOR_SIDEBAR_BACKGROUND)
	# decide where to stick it
	if STATE.sidebar_boardtype_allscreen_is_at_top:
		y = 0
		CANVAS.fullscreen_toggle_pos = (scrx - 32, 5)
		pygame.draw.line( STATE.sidebar_boardtype_allscreen_bitmap, COLOR_DIVIDER_LINE,
			(0, STATE.sidebar_boardtype_allscreen_ysz - 2),
			(scrx, STATE.sidebar_boardtype_allscreen_ysz - 2), 3)
	else:
		y = scry - STATE.sidebar_boardtype_allscreen_ysz
		CANVAS.fullscreen_toggle_pos = (scrx - 32, scry - 32)
		pygame.draw.line( STATE.sidebar_boardtype_allscreen_bitmap, COLOR_DIVIDER_LINE, (0, 1), (scrx, 1), 3)

	pygame_set_library_screen( STATE.sidebar_boardtype_allscreen_bitmap)

	VGAPRN.setsize(26)
	VGAPRN.justify = JUSTIFY_LEFT

	yy = 5
	if tbbp.times_multiplier > 1:
		n = (tbbp.times_multiplier - 2) + TBBT_TIMES2
		if (n >= TBBT_TIMES2) and (n <= TBBT_TIMES5):
			pygame_library_screen.blit( ASSETS.tbb_tiles[n][0], (7,7))
	VGAPRN.color1 = COLOR_TEXT_HEADER
	VGAPRN.printf( (38, yy), "Score: ")
	VGAPRN.color1 = COLOR_TEXT_DATA
	VGAPRN.printf( None, "%u" % tbbp.score)

	VGAPRN.color1 = COLOR_TEXT_HEADER
	VGAPRN.printf( (220, yy), "Moves: ")
	VGAPRN.color1 = COLOR_TEXT_DATA
	VGAPRN.printf( None, "%u / %u" % (tbbp.moveno, tbbp.maxmoveno))

	VGAPRN.color1 = COLOR_TEXT_HEADER
	VGAPRN.printf( (420, yy), "Wave: ")
	VGAPRN.color1 = COLOR_TEXT_DATA
	VGAPRN.printf( None, "%u" % tbbp.waveno)

	VGAPRN.setsize(16)
	VGAPRN.color1 = COLOR_TEXT_HEADER
	VGAPRN.justify = JUSTIFY_RIGHT
	xx = scrx - 40
	VGAPRN.printf( (xx, yy -  5), "F1-Help")
	VGAPRN.printf( (xx, yy + 12), "ESC-Exit")

	pygame_set_library_screen(-1)

	pygame_library_screen.blit( STATE.sidebar_boardtype_allscreen_bitmap, (0,y))

	return

##################################################################
def	ui_draw_sidebar_for_boardtype_square():
	CANVAS.fullscreen_toggle_pos = (scrx - 32, scry - 32)

	pygame.draw.rect( pygame_library_screen, (0,50,50),
		(STATE.ui_ulx, STATE.ui_uly, STATE.ui_w, STATE.ui_h))

	buttonsize = STATE.ui_w / 4
	buttonsize2 = buttonsize + 3

	VGAPRN.set_bitmap_font( ASSETS.bitmapfont_vic20)
	VGAPRN.justify = JUSTIFY_LEFT
	n = 0
	for j in range(-1,2):
		for i in range(-1,2):
			if arrow_layout_order[n] >= 0:
				x = STATE.ui_ulx + (STATE.ui_w >> 1) + buttonsize2 * i
				y = STATE.ui_uly + (STATE.ui_w >> 1) + buttonsize2 * j
				shapelist = ASSETS.arrows_20
				ui_draw_unified_button(x,y,40,40,n)
				if STATE.buttondowns[n]:
					shapelist = ASSETS.arrows_20_selected
				shapelist[ arrow_layout_order[n]].plot( (x, y))
				VGAPRN.color1 = (255,255,255)
				if STATE.buttondowns[n]:
					VGAPRN.color1 = (255,0,0)
				VGAPRN.printf( (x-18,y-18), "%c" %
					STATE.keyboard_keycap_indicators[arrow_layout_order[n]])
			n += 1

	VGAPRN.setsize(18)
	VGAPRN.zerowrite = 0
	VGAPRN.justify = JUSTIFY_CENTER
	for i in range(2):
		x = STATE.ui_ulx + (STATE.ui_w >> 1) + (i * 2 - 1) * (STATE.ui_w / 4)
		y = STATE.ui_uly + buttonsize * 4
		VGAPRN.color1 = (255,255,255)
		if STATE.buttondowns[i + 10]:
			VGAPRN.color1 = (255,0,0)
		ui_draw_unified_button(x,y+10,64,32,i+10)
		VGAPRN.printf( (x, y), waitwarp[i])

	x = STATE.ui_ulx + 8
	y = STATE.ui_uly + 8 + buttonsize * 5
	x2 = scrx - 8

	VGAPRN.setsize(26)
	yspacing = 26
	yspacing2 = 8
	c1 = (222,222,222)
	c2 = (111,255,111)
	VGAPRN.zerowrite = 0

	VGAPRN.color1 = c1
	VGAPRN.justify = JUSTIFY_LEFT
	VGAPRN.printf( (x, y), "Score:")
	if tbbp.times_multiplier > 1:
		n = (tbbp.times_multiplier - 2) + TBBT_TIMES2
		if (n >= TBBT_TIMES2) and (n <= TBBT_TIMES5):
			pygame_library_screen.blit( ASSETS.tbb_tiles[n][0], (x2 - ASSETS.tilesize, y))
	y += yspacing
	VGAPRN.color1 = c2
	VGAPRN.justify = JUSTIFY_RIGHT
	VGAPRN.printf( (x2, y), "%u" % tbbp.score)
	y += yspacing

	y += yspacing2

	VGAPRN.color1 = c1
	VGAPRN.justify = JUSTIFY_LEFT
	VGAPRN.printf( (x, y), "Moves:")
	y += yspacing
	VGAPRN.color1 = c2
	VGAPRN.justify = JUSTIFY_RIGHT
	VGAPRN.printf( (x2, y), "%u / %u" % (tbbp.moveno, tbbp.maxmoveno))
	y += yspacing

	y += yspacing2

	VGAPRN.color1 = c1
	VGAPRN.justify = JUSTIFY_LEFT
	VGAPRN.printf( (x, y), "Lives:")
	y += yspacing
	for i in range(tbbp.ships):
		pygame_library_screen.blit( ASSETS.tbb_tiles[TBBT_EXTRALIFE][0], (x2 - (i + 1) * ASSETS.tilesize, y + 8))
	y += yspacing

	y += yspacing2

	VGAPRN.color1 = c1
	VGAPRN.justify = JUSTIFY_LEFT
	VGAPRN.printf( (x, y), "Wave:")
	y += yspacing
	VGAPRN.color1 = c2
	VGAPRN.justify = JUSTIFY_RIGHT
	VGAPRN.printf( (x2, y), "%u" % tbbp.waveno)
	y += yspacing

	y += yspacing2

	VGAPRN.setsize(18)
	y = scry - 22
	VGAPRN.color1 = c2
	VGAPRN.justify = JUSTIFY_LEFT
	VGAPRN.printf( (x, y), "F1-Help")
	y -= 20
	VGAPRN.printf( (x, y), "ESC-Exit")

	return

##################################################################
def	ui_draw_sidebar():
	if tbbp.boardtype == BOARDTYPE_SQUARE:
		ui_draw_sidebar_for_boardtype_square()
	elif tbbp.boardtype == BOARDTYPE_ALLSCREEN:
		ui_draw_sidebar_for_boardtype_allscreen();
	else:
		print "ui_draw_sidebar(): Unhandled boardtype = %u" % tbbp.boardtype
		sys.exit()
	return

##################################################################
def	ui_introduce_you():
	if tbbp.introyou_timer > 0:
		tbbp.introyou_timer -= 1
		radius = tbbp.introyou_timer - 10
		blink = 0
		minradius = 4
		if radius < minradius:
			radius = minradius
			blink = 1
			# <WIP> blink you at the end of this loop??

		radius = 6 * radius

		width = tbbp.introyou_timer / 5
		if width <= 2:
			width = 2

		x = rtns_tilex(tbbp.youx) + (ASSETS.tilesize >> 1)
		y = rtns_tiley(tbbp.youy) + (ASSETS.tilesize >> 1)

		radialcoords = []
		maxangles = 10
		for i in range(maxangles):
			angle = (pi * 2 * i) / maxangles
			x2 = int( x + cos( angle) * radius)
			y2 = int( y + sin( angle) * radius)
			radialcoords.append((x2,y2))

		for i in range(len(radialcoords)):
			j = (i + 1) % len(radialcoords)
			c = (Random(256), Random(256), Random(256))
			pygame.draw.line( pygame_library_screen, c,
					radialcoords[i], radialcoords[j], width)

		return 1

	return 0

##################################################################
def	ui_draw_mouse_arrows():
	if tbbp.youdead:
		return

	distance = (abs( INPUT.mousecursor_prevx - INPUT.mousecursor_x) +
				abs( INPUT.mousecursor_prevy - INPUT.mousecursor_y))
	STATE.mouse_distance += distance
	if STATE.mouse_distance >= 100:
		if STATE.playfield_rect.collidepoint( INPUT.mousecursor_x, INPUT.mousecursor_y):
			STATE.mouse_arrow_on = 1
		else:
			STATE.mouse_arrow_on = 0
	else:
		STATE.mouse_arrow_on = 0

	STATE.mouse_click_action = TBBCMD_NULL
	if STATE.mouse_arrow_on:
		cellx = rtns_cellx( INPUT.mousecursor_x)
		celly = rtns_celly( INPUT.mousecursor_y)
		x = rtns_tilex(tbbp.youx) + ASSETS.tilesize / 2
		y = rtns_tiley(tbbp.youy) + ASSETS.tilesize / 2
		if (cellx == tbbp.youx) and (celly == tbbp.youy):
			# handle upper/lower half hover and do "warp" too?
			if (INPUT.mousecursor_y % ASSETS.tilesize) < (ASSETS.tilesize / 2):
				STATE.mouse_click_action = TBBCMD_WARP
				caption = "WARP"
				y -= 10
			else:
				STATE.mouse_click_action = TBBCMD_WAIT
				caption = "WAIT"
				y += 10
			VGAPRN.set_bitmap_font( ASSETS.bitmapfont_vic20)
			VGAPRN.justify = JUSTIFY_LEFT
			VGAPRN.color1 = (0,0,0)
			VGAPRN.printf( (x + ASSETS.tilesize / 2 - 1, y - 1), caption)
			VGAPRN.printf( (x + ASSETS.tilesize / 2 + 1, y + 1), caption)
			VGAPRN.color1 = (255,255,255)
			VGAPRN.printf( (x + ASSETS.tilesize / 2, y), caption)
		else:
			dir8 = ROT8.atan2( tbbp.youx, tbbp.youy, cellx, celly)
			#/ offset from you a bit
			#/ rapid zip-zip-zip movement
			distance = (ASSETS.tilesize / 2 - 4) + (CANVAS.timer & 7)
			#/ slow toggle back and forth movement
			distance = (ASSETS.tilesize / 2) + 2 * ((CANVAS.timer >> 4) & 1)
			x += xtable8[dir8] * distance
			y += ytable8[dir8] * distance
			ASSETS.arrows_14[dir8].plot( (x,y))
			STATE.mouse_click_action = TBBCMD_MOVE0 + dir8
		if (not INPUT.mousebuttons[0]) and INPUT.prevmousebuttons[0]:
			if STATE.mouse_click_action != TBBCMD_NULL:
				tbb_docmd( STATE.mouse_click_action)
	return

##################################################################
def	input_initgame():
	print "Enabling default keys"

	STATE.unicodeses_move0 = []
	STATE.unicodeses_move1 = []
	STATE.unicodeses_move2 = []
	STATE.unicodeses_move3 = []
	STATE.unicodeses_move4 = []
	STATE.unicodeses_move5 = []
	STATE.unicodeses_move6 = []
	STATE.unicodeses_move7 = []
	STATE.unicodeses_wait = [chr(32), '.', '>',]
	STATE.unicodeses_warp = ['w', 'W', ]

	STATE.keypresses_move0 = [K_KP8, K_UP,]
	STATE.keypresses_move1 = [K_KP9, K_PAGEUP,]
	STATE.keypresses_move2 = [K_KP6, K_RIGHT,]
	STATE.keypresses_move3 = [K_KP3, K_PAGEDOWN,]
	STATE.keypresses_move4 = [K_KP2, K_DOWN,]
	STATE.keypresses_move5 = [K_KP1, K_END,]
	STATE.keypresses_move6 = [K_KP4, K_LEFT,]
	STATE.keypresses_move7 = [K_KP7, K_HOME,]
	STATE.keypresses_wait = [K_KP5]
	STATE.keypresses_warp = [K_INSERT]

	if STATE.settings_array[SETTINGSOFFSET_ENABLE_VI_KEYS]:
		print "Also enabling VI keys"
		#/ put in vi keys, if selected
		STATE.unicodeses_move0 += ['k', 'K',]
		STATE.unicodeses_move1 += ['u', 'U',]
		STATE.unicodeses_move2 += ['l', 'L',]
		STATE.unicodeses_move3 += ['n', 'N',]
		STATE.unicodeses_move4 += ['j', 'J',]
		STATE.unicodeses_move5 += ['b', 'B',]
		STATE.unicodeses_move6 += ['h', 'H',]
		STATE.unicodeses_move7 += ['y', 'Y',]
	else:
		print "Also enabling old IJKM keys"
		#/ put in non-vi keys
		STATE.unicodeses_move0 += ['i', 'I',]
		STATE.unicodeses_move1 += ['o', 'O',]
		STATE.unicodeses_move2 += ['k', 'K', 'l', 'L',]
		STATE.unicodeses_move3 += [',', '<',]
		STATE.unicodeses_move4 += ['m', 'M',]
		STATE.unicodeses_move5 += ['n', 'N',]
		STATE.unicodeses_move6 += ['j', 'J', 'h', 'H',]
		STATE.unicodeses_move7 += ['u', 'U',]

	# tack on numerals, even though I think they never happen...
	STATE.unicodeses_move0 += ['8',]
	STATE.unicodeses_move1 += ['9',]
	STATE.unicodeses_move2 += ['6',]
	STATE.unicodeses_move3 += ['3',]
	STATE.unicodeses_move4 += ['2',]
	STATE.unicodeses_move5 += ['1',]
	STATE.unicodeses_move6 += ['4',]
	STATE.unicodeses_move7 += ['7',]

	def	find_first_uppercase(L):
		for x in L:
			if (x >= 'A') and (x < 'Z'):
				return x
		return L[0]

	# these go in the corner of the mouse-activated arrow buttons on the UI
	STATE.keyboard_keycap_indicators = (
		find_first_uppercase( STATE.unicodeses_move0),
		find_first_uppercase( STATE.unicodeses_move1),
		find_first_uppercase( STATE.unicodeses_move2),
		find_first_uppercase( STATE.unicodeses_move3),
		find_first_uppercase( STATE.unicodeses_move4),
		find_first_uppercase( STATE.unicodeses_move5),
		find_first_uppercase( STATE.unicodeses_move6),
		find_first_uppercase( STATE.unicodeses_move7),
	)
#	print STATE.keyboard_keycap_indicators

	return

##################################################################
def	input_process():
	for k in INPUT.keypresses:
		if k in STATE.keypresses_move0:
			tbb_docmd( TBBCMD_MOVE0)
			STATE.mouse_distance = 0
			return
		if k in STATE.keypresses_move1:
			tbb_docmd( TBBCMD_MOVE1)
			STATE.mouse_distance = 0
			return
		if k in STATE.keypresses_move2:
			tbb_docmd( TBBCMD_MOVE2)
			STATE.mouse_distance = 0
			return
		if k in STATE.keypresses_move3:
			tbb_docmd( TBBCMD_MOVE3)
			STATE.mouse_distance = 0
			return
		if k in STATE.keypresses_move4:
			tbb_docmd( TBBCMD_MOVE4)
			STATE.mouse_distance = 0
			return
		if k in STATE.keypresses_move5:
			tbb_docmd( TBBCMD_MOVE5)
			STATE.mouse_distance = 0
			return
		if k in STATE.keypresses_move6:
			tbb_docmd( TBBCMD_MOVE6)
			STATE.mouse_distance = 0
			return
		if k in STATE.keypresses_move7:
			tbb_docmd( TBBCMD_MOVE7)
			STATE.mouse_distance = 0
			return

	for u in INPUT.unicodeses:
		if u in STATE.unicodeses_wait:
			tbb_docmd( TBBCMD_WAIT)
			STATE.mouse_distance = 0
			return
		if u in STATE.unicodeses_warp:
			tbb_docmd( TBBCMD_WARP)
			STATE.mouse_distance = 0
			return
		if u in STATE.unicodeses_move0:
			tbb_docmd( TBBCMD_MOVE0)
			STATE.mouse_distance = 0
			return
		if u in STATE.unicodeses_move1:
			tbb_docmd( TBBCMD_MOVE1)
			STATE.mouse_distance = 0
			return
		if u in STATE.unicodeses_move2:
			tbb_docmd( TBBCMD_MOVE2)
			STATE.mouse_distance = 0
			return
		if u in STATE.unicodeses_move3:
			tbb_docmd( TBBCMD_MOVE3)
			STATE.mouse_distance = 0
			return
		if u in STATE.unicodeses_move4:
			tbb_docmd( TBBCMD_MOVE4)
			STATE.mouse_distance = 0
			return
		if u in STATE.unicodeses_move5:
			tbb_docmd( TBBCMD_MOVE5)
			STATE.mouse_distance = 0
			return
		if u in STATE.unicodeses_move6:
			tbb_docmd( TBBCMD_MOVE6)
			STATE.mouse_distance = 0
			return
		if u in STATE.unicodeses_move7:
			tbb_docmd( TBBCMD_MOVE7)
			STATE.mouse_distance = 0
			return

	return


##################################################################
# There is no code here... use the TBB-flavored init routines!


##################################################################
# AI to play the Daleks game on its own...

##################################################################
class	aistate:
	def	__init__(self):
		self.lastpos = (-1,-1)
		return
AI = aistate()

##################################################################
ai_list_of_prioritized_goodie_sets = (
	(TBBT_EXTRALIFE,),
	(TBBT_EXTRAMOVES,),
	(TBBT_TIMES2, TBBT_TIMES3, TBBT_TIMES4, TBBT_TIMES5,),
	(TBBT_DOLLAR,),
)

##################################################################
def	ai_create_threat_map():
	return

##################################################################
def	ai_find_nearest_goodie_helper():
	x = tbbp.youx
	y = tbbp.youy
	# scans square boxes outwards from you
	for goodieset in ai_list_of_prioritized_goodie_sets:
		for d in xrange(30):
			distance = 1 + d
			for i in xrange( -distance, distance + 1):
				pos = (x+i,y-distance)
				if tbb_get(pos) in goodieset:
					return pos
				pos = (x+i,y+distance)
				if tbb_get(pos) in goodieset:
					return pos
				pos = (x-distance,y+i)
				if tbb_get(pos) in goodieset:
					return pos
				pos = (x+distance,y+i)
				if tbb_get(pos) in goodieset:
					return pos
	# not likely we will not have something, unless
	# we're on the very edge case of ending a wave
	return None

##################################################################
def	ai_find_nearest_goodie():
	AI.goodie_dir8 = None
	AI.goodie_found = ai_find_nearest_goodie_helper()
	if AI.goodie_found:
		# Now develop a plan to move towards it
		AI.goodie_dir8 = ROT8.atan2( tbbp.youx, tbbp.youy, AI.goodie_found[0], AI.goodie_found[1])
	return

##################################################################
# if we have not moved for X moves, despite trying, then WARP
def	ai_check_for_snagged():
	pos = (tbbp.youx, tbbp.youy)
	if AI.lastpos == pos:
		AI.snagcount += 1
		if AI.snagcount >= 10:
			# we'll try mostly to warp, but if there is only
			# one gold left, you won't warp, and therefore we
			# should just move randomly
			if Random(3):
				tbb_docmd( TBBCMD_WARP)
			else:
				tbb_docmd( TBBCMD_MOVE0 + Random(8))
			return 1
	else:
		AI.snagcount = 0
	AI.lastpos = pos
	return 0

##################################################################
def	ai_check_peril_at_position(pos=None,dir8=None):
	if pos == None:
		pos = (tbbp.youx, tbbp.youy)
	if dir8 != None:
		pos = (
				pos[0] + xtable8[dir8],
				pos[1] + ytable8[dir8])
	# check for peril AT this spot
	c = tbb_get( pos)
	if c in (
			TBBT_ROBOT1,
			TBBT_ROBOT2,
			TBBT_ELECTRODE,
			TBBT_BOMBON,
			TBBT_BOMBARMED,
			TBBT_BOMBFLAME,
			TBBT_MINE,
		):
		return c
	# check for exploding bombs nearby
	for i in xrange(8):
		x1 = pos[0] + xtable8[i]
		y1 = pos[1] + ytable8[i]
		c = tbb_get((x1,y1))
		if c in (TBBT_BOMBON, TBBT_BOMBARMED,):
			return c
	# check for robot2s nearby
	for i in xrange(8):
		x1 = pos[0] + xtable8[i]
		y1 = pos[1] + ytable8[i]
		c = tbb_get((x1,y1))
		if c in (TBBT_ROBOT2,):
			return c
	# check for robot1s nearby
	for i in xrange(4):
		x1 = pos[0] + xtable4[i]
		y1 = pos[1] + ytable4[i]
		c = tbb_get((x1,y1))
		if c in (TBBT_ROBOT1,):
			return c
	return TBBT_BLANK

##################################################################
def	ai_check_can_go(pos = None):
	if pos == None:
		pos = (tbbp.youx,tbbp.youy)
	c = tbb_get(pos)
	if c in (
			TBBT_BLANK,
			TBBT_DOLLAR,
			TBBT_STONE1,
			TBBT_STONE2,
			TBBT_STONE3,
			TBBT_WARPLINK,
			TBBT_EXTRALIFE,
			TBBT_EXTRAMOVES,
			TBBT_TIMES2,
			TBBT_TIMES3,
			TBBT_TIMES4,
			TBBT_TIMES5,
		):
		return 1
	return 0

##################################################################
def	ai_check_for_peril():
	peril = ai_check_peril_at_position()
	if peril:
		basedir = Random(8)
		for i in xrange(8):
			n = (basedir + i) & 7
			x1 = tbbp.youx + xtable8[n]
			y1 = tbbp.youy + ytable8[n]
			if not ai_check_peril_at_position((x1,y1)):
				if ai_check_can_go((x1,y1)):
					tbb_docmd( TBBCMD_MOVE0 + n)
					return 1
		tbb_docmd( TBBCMD_WARP)
		return 1
	return 0

##################################################################
def	ai_make_1_move():
	if ai_check_for_peril():
		return
	if ai_check_for_snagged():
		return
	ai_create_threat_map()
	ai_find_nearest_goodie()
	# move towards the goodie
	if AI.goodie_dir8 != None:
		if ai_check_peril_at_position(None,AI.goodie_dir8):
			c = Random(10)
			if c == 0:
				tbb_docmd( TBBCMD_WARP)
				return
			tbb_docmd( TBBCMD_WAIT)
			return
		tbb_docmd( TBBCMD_MOVE0 + AI.goodie_dir8)
		return
	# can we move? if so move towards goodies
	# if we cannot move but are not threatened, then WAIT
	return

##################################################################
def	ai_initwave():
	global AI
	AI = aistate()
	return

if not ASSETS.tbb_tiles:
	assets_load_tiles(GLOBAL_TILESIZE)

statistics_initonce()

##################################################################
CANVAS.game_title = "Daleks - Attack Of The Robots"

CANVAS.pause_quitfunc = rtns_gameover

CANVAS.fullscreen_toggle_pos = (scrx - 32, scry - 32)

canvas_greet(CANVASOP_TRANSITION_IN)

##################################################################
#canvas_set_current( canvas_attract)
canvas_set_current( canvas_greet)
#canvas_set_current( canvas_playing)
if 0:
	assets_load_tiles(GLOBAL_TILESIZE)
	tbb_initgame()
	tbbp.score = 12345
	if len( CANVAS.ht.hiscores):
		tbbp.score = CANVAS.ht.hiscores[0].score + 1000
	tbbp.tbbstats_robots_destroyed = 20 + Random(50)
	tbbp.tbbstats_dollars_collected = 20 + Random(50)
	rtns_gameover()


##################################################################
# This is part of Kurt Dekker's common python library codebase.
#

##################################################################
def	dispatch_canvases():
	if CANVAS.timer > 10:				# universal debounce timer
		CANVAS.debounced = 1

	if CANVAS.current:
		if CANVAS.takearg:
			CANVAS.current(CANVASOP_UPDATE)
		else:
			CANVAS.current()

	return

##################################################################
while CANVAS.current:
	dispatch_canvases()
	waitclock()
